      SUBROUTINE ASCCMR(FILNAM,SPEC,TEXT,ICAL,RCAL,IERR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 920816 tk
*---mru : 980502 tk
C ----------------------------------------------------------------------
C       READ one SPECTRUM AND ITS HEADER from Munck UNFOLDED ASCII file.
*
C       File FORMAT IS AS FOLLOWS:
*Line # |
* 1     |X$FFA201     0     0     0
* 2     |ER17E ACON+5MM CITRATE+2.5HOURS, 4.2K 0G 4R 12/1/83            
* 3     | 256     0     0     0     0
* 4     |     256.900000    0.000000E+00    0.000000E+00    1.446461E+07
* 5 - 68| data in 8F8.0 format 
*Description of header:
*Line 1: File name (A8)  date code (3I6)
*Line 2: comment (A72)
*Line 3: Nchannels 0 0 0 0
*Line 4: fold pt.,  cal1,  cal2,  baseline
*Line 5 to 68: 512 channels in 8F8.0 format (64 rows)
*------------------------------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      real specuf(2*lspec)
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL SPEC(lspec),RCAL(MCAL)
      INTEGER ICAL(MCAL),IERR, ierr1
      integer i , irow, nuf
*-------------------------------------------------------
*---executables
*---clear error flag
      ierr = 0

*---clear header info in RAM
      do 10 i=1,mcal
         ical(i)=0
         rcal(i)=0.0
   10 continue
         do 40 i=1,mcommt
40         text(i)=' '

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER
        DO 50 I = 1,4
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
 50     CONTINUE

C READ IN THE SPECTRUM
         DO 140 IROW=0,63
          READ (JDISK,'(8F9.0)',IOSTAT=IERR,ERR=300)
     &          (SPECuf(I+8*IROW),I=1,8)
  140  continue

*---Now fold the data.
          nuf=512
         CALL FALT(filnam, nuf, specuf, ical(1), spec, rcal(5),
     &       rcal(6), rcal(7), ierr)
 
  300 CLOSE (JDISK, IOSTAT=IERR1)
      if (ierr1.ne.0) ierr = ierr1
      RETURN
      END
