c     BESTCOM.INC 
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
c     Generic Version

* stores the best variables found at each level of optimization.

*----------------------------------------------*
* Best variables at each level of optimization *
*----------------------------------------------*------------------------
      common /best/ bvar, response
*-----------------------------------------------------------------------
      integer mlevel
      parameter (MLEVEL=4)

      integer GLOLEV, LOCLEV, GARLEV, LINLEV, BLLEV
      parameter (GLOLEV=1, LOCLEV=2, GARLEV=3, LINLEV=4, BLLEV=5)

      real bvar(MVAR, MLEVEL+1, MLEVEL)
      real response(LSPEC, LT1, 0:MLOC, 0:GARLEV)
*-----------------------------------------------------------------------
* mlevel : Maximum number of optimization levels.
*
* glolev : Global level no.
* loclev : Local level no.
* garlev : Global area level no.
* linlev : Linear level no.
*
* bvar     : Best variables for level m when optimizing at n found in
*          :    bvar(*,m,n) [where m <= n !]
* response : Simulation going with above variables found in
*          :    response(*, Spectrum #, 0 or subsite #, level [<3])
*          :    where a zero level holds the simulation for the final
*          :    fit result.
*-----------------------------------------------------------------------

