*-----------------------------------------------------------------------
      SUBROUTINE CALGA2(LEN,NFREE,VFREE,FVEC,IFLAG)
*-----------------------------------------------------------------------
      INTEGER LEN,NFREE,IFLAG
      REAL VFREE(NFREE),FVEC(LEN)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    Orig 20May94 CS, 23May94 CS
*
*     Global area routine for LMDIF optimization.
*
*     len    : [input]  Number of unmasked data points;
*     nfree  : [input]  Number of free variables to optimize over;
*     vfree  : [input]  Values of free variables for this local iter.;
*     fvec   : [output] Noise-scaled residuals at this point;
*     iflag  : [output] Error/abort code;
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'errcodes.inc'
 
      INTEGER IBOUND,IERR
      REAL DUMMYC,DUMMYG(MLPAR)
 
      EXTERNAL CALGA
*-----------------------------------------------------------------------
 
      IF ( NOPTMZ.LT.0 ) THEN
        IBOUND = 0
      ELSE
        IBOUND = 1
      ENDIF
 
      CALL CALFUN(CALGA,NFREE,VFREE,VALB,VAUB,IBOUND,0,LEN,DUMMYC,
     &            DUMMYG,FVEC,IERR)
 
      IF ( (IERR.NE.NOERROR) .OR. (ABORT.NE.ABORTOFF) ) IFLAG = ERRABORT
 
      RETURN
      END
