*-----------------------------------------------------------------------
      SUBROUTINE CALGA5(NPOINT,NFREE,VFREE,NF,FVEC,UIDUM,URDUM,UFDUM)
*-----------------------------------------------------------------------
      INTEGER NPOINT,NFREE,NF,UIDUM(*)
      REAL VFREE(NFREE),FVEC(NPOINT),URDUM(*)
      EXTERNAL UFDUM
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     26May94 CS
*
*     Global area routine for N2FB (Port) optimization.
*
*     npoint : [input]  Number of data points being fitted;
*     nfree  : [input]  Number of free variables to optimize over;
*     vfree  : [input]  Values of free variables for this local iter.;
*     nf     : [input]  Ignored;
*     fvec   : [output] Residuals at this point;
*     uidum  : [input]  Ignored;
*     urdum  : [input]  Ignored;
*     ufdum  : [input]  Ignored.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'varcom.inc'
 
      INTEGER IERR
      REAL DUMMYC,DUMMYG(MVAR)
 
      EXTERNAL CALGA
*-----------------------------------------------------------------------
 
      CALL CALFUN(CALGA,NFREE,VFREE,VALB,VAUB,0,0,NPOINT,DUMMYC,DUMMYG,
     &            FVEC,IERR)
 
      RETURN
      END
