      SUBROUTINE CORDAT(DATSPC,HEIGHT)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru : 971209 tk
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      include 'plotcom.inc'
      include 'togcom.inc'
      include 'constcom.inc'
      include 'scrncom.inc'

      integer lenact
      external lenact
 
      INTEGER DATSPC,HEIGHT
*---legend text
      character*8 gtext(1)
*---plot title storage
      character*72 ptitle(2),xtitl,ytitl,xttitl
*---length
      integer npts
*---data type
      integer itype

      real pwl, qwl, pwu, qwu
      real xsmin, xsmax, ysmin, ysmax
      real xs(lspec), ys(lspec), ysnoi(lspec), toplst(2,MTOP)
      logical msk(LSPEC)
      integer ntop
*-----------------------------------------------------------------------
      
*---Scale x and y data according to info in common block toggle
      npts = icalsp(1,datspc)
      itype = icalsp(10,datspc)
      call scldat(itype,npts,xspc(1,datspc),spctra(1,datspc),
     &   spcnoi(1,datspc), spcmsk(1,datspc), spccal(1,datspc), kxplot,
     &   kyplot, xs, ys, ysnoi, msk, ntop, toplst)

*---SET UP THE SCALING
      if (zscale) then
         call armm1(xs,npts,xsmin,xsmax)
         call armm1(ys,npts,ysmin,ysmax)
      else
         ysmin = clpbot
         ysmax = clptop
         xsmin = clplt
         xsmax = clprt
      endif

      pwl= 0.12 
      qwl= 1.-(height-.02)/iscrow
      pwu= 1.0
      qwu= 1.-1./iscrow
      ptitle(1)=spcnam(datspc)(1:lenact(spcnam(datspc)))// ': '// 
     &   spccmt(1,datspc)
      ptitle(2)=spccmt(2,datspc)
      gtext(1)=ptitle(1)(1:8)

      call pltitl(kxplot, kyplot, mcal, spccal(1,datspc),
     &   icalsp(1,datspc), xtitl, ytitl, xttitl)      
      call newbox(xsmin, ysmin, xsmax, ysmax, ntop, toplst, 
     &   pwl, qwl, pwu, qwu, 0, 1,gtext,ptitle,xtitl,xttitl,ytitl)
      
      call shodat(.false.,icalsp(1,datspc),xspc(1,datspc),
     &   spctra(1,datspc), 
     &   spcnoi(1,datspc),icalsp(1,datspc),spccal(1,datspc),
     &   spcmsk(1,datspc), 1.0, -1, 0, spcnam(datspc),
     &   spccmt(1,datspc), .false.)
 
      RETURN
      END
