      SUBROUTINE DEFAXS(XMIN,XMAX,BORDR,AMIN,AMAX,NTICS,TIC1,WIDTH)
*---Purpose:determine ticlength & # of tics for given range of graphed values
*---Origin Date:January 23, 1989
*---Most Recent Update: June 9, 1992
*---Who did it? BML; TK; CS
*----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*----------------------------------------------------------------------
 
c---DEFAXS inputs min.(xmin) & max(xmax) data values and
*---      (ntics) number of tic marks to set
 
      REAL XMIN,XMAX,BORDR
      INTEGER NTICS
 
C Output
*---      (tic1)-coordinate of first tic mark
*---      (width)-distance between tic marks
*---      (nfrac)-number of fractional digits to display
 
      REAL TIC1,WIDTH,AMIN,AMAX
      REAL RANGE
 
      REAL GOODNM
      EXTERNAL GOODNM
 
      RANGE = XMAX - XMIN
      IF ( RANGE.GT.0 ) THEN
        AMIN = XMIN - BORDR*RANGE
        AMAX = XMAX + BORDR*RANGE
      ELSE
        AMIN = -1.0 + XMIN
        AMAX = 1.0 + XMIN
        RANGE = 2
      ENDIF
      WIDTH = GOODNM(RANGE/(NTICS-1),.TRUE.)
      TIC1 = ANINT(XMIN/WIDTH+.4999995)*WIDTH
 
      NTICS = (XMAX-TIC1)/WIDTH + 1
 
      RETURN
      END
