      subroutine deftic(effect,ntic,dtic)
*---Custome routine for Mossbauer spectra
*---input: effect in percent.
*---output: Number of tic marks and tic step.
      real effect
      integer ntic
      real dtic

      if(effect.gt.20)then
         ntic=4
         dtic=5.0
      elseif(effect.ge. 15.0)then
         ntic=5
         dtic=3.0
      elseif(effect.ge. 14.0)then
         ntic=7
         dtic=2.0
      elseif(effect.ge. 12.0)then
         ntic=6
         dtic=2.0
      elseif(effect.ge. 10.0)then
         ntic=5
         dtic=2.0
      elseif(effect.ge. 8.0)then
         ntic=4
         dtic=2.0
      elseif(effect.ge. 7.0)then
         ntic=7
         dtic=1.0
      elseif(effect.ge. 6.0)then
         ntic=6
         dtic=1.0
      elseif(effect.ge. 5.0)then
         ntic=5
         dtic=1.0
      elseif(effect.ge. 4.0)then
         ntic=4
         dtic=1.0
      elseif(effect.ge. 3.5)then
         ntic=7
         dtic=0.5
      elseif(effect.ge. 3.0)then
         ntic=6
         dtic=0.5
      elseif(effect.ge. 2.5)then
         ntic=5
         dtic=0.5
      elseif(effect.ge. 2.0)then
         ntic=4
         dtic=0.5
      elseif(effect.ge. 1.6)then
         ntic=8
         dtic=0.2
      elseif(effect.ge. 1.4)then
         ntic=7
         dtic=0.2
      elseif(effect.ge. 1.2)then
         ntic=6
         dtic=0.2
      elseif(effect.ge. 1.0)then
         ntic=5
         dtic=0.2
      elseif(effect.ge. 0.8)then
         ntic=4
         dtic=0.2
      elseif(effect.ge. 0.7)then
         ntic=7
         dtic=0.1
      elseif(effect.ge. 0.6)then
         ntic=6
         dtic=0.1
      elseif(effect.ge. 0.5)then
         ntic=5
         dtic=0.1
      elseif(effect.ge. 0.4)then
         ntic=4
         dtic=0.1
      elseif(effect.ge. 0.3)then
         ntic=3
         dtic=0.1
      elseif(effect.ge. 0.2)then
         ntic=2
         dtic=0.1
      elseif(effect.ge. 0.1)then
         ntic=1
         dtic=0.1
      elseif(effect.lt.0.1)then
         ntic=1
         dtic=0.05
      endif

      return
      end

