      SUBROUTINE exsu(nd,nd1,nd2,ur,ui,nst,o1,nst1,o2,nst2,eo12)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: TK     GFWBI     1/22/82 
*---mru : 930222 tk
*---Purpose:  
C---EXS , ALIAS "TERRIBLE DELIRIUM", CALCULATES THE
C---VALUES OF THE TWO SPIN OPERATOR O WHERE O = O1 O2.
C---I.E.  <PSI(I)/ O /PSI(I)> = <PSI(I)/ O1 O2 /PSI(I)>.
C---THE TWO SPIN BASIS STATES, /PHI(I)> = / M1, M2>,
C---MUST BE ORDERED SUCH THAT  I = 1 + S1-M1 + NST1*(S2-M2).
C---1.LE.I.LE.NST, WHERE NST IS THE TOTAL NUMBER OF STATES.
C---NST = NST1 * NST2
C---NST1 = 2*S1 + 1
C---NST2 = 2*S2 + 1
C---C(J,I) = <PHI(J)/PSI(I)>,   WHERE /PSI(I)> IS THE ITH
C---EIGENSTATE AND /PHI(J)> IS THE JTH BASIS STATE.
*-----------------------------------------------------------------------
*---externals
C---ND,ND1 AND ND2 ARE ARRAY SIZES SPECIFIED IN MAIN.
      integer nd,nd1,nd2
      real ur(nd,nd),ui(nd,nd)
      integer nst,nst1,nst2
      COMPLEX o1(nd1,nd1),o2(nd2,nd2)
      REAL eo12(nst)
*---internals
      complex cki,cji,e 
      real ei
      integer i,j1,j2,j,k1,k2,k
*----------------------------------------------------------------------
*---executables
 
      DO 100 i = 1,nst
        e  = (0.,0.)
        DO 50 j2 = 1,nst2
          DO 20 j1 = 1,nst1
            j  = j1 + (j2-1)*nst1
            cji = cmplx( ur(j,i) , ui(j,i) )
            DO 10 k2 = 1,nst2
              DO 5 k1 = 1,nst1
                 k  = k1 + (k2-1)*nst1
                cki = cmplx( ur(k,i) , -ui(k,i) )
                e  = e + cki*o1(k1,j1)*o2(k2,j2)*cji
 5            CONTINUE
 10         CONTINUE
 20       CONTINUE
 50     CONTINUE
 
        ei = aimag(e)
        IF( abs(ei).GT.0.0001 )GOTO 200
        eo12(i) = real(e)
 100  CONTINUE
 
      RETURN
 
 200  WRITE(*,99001)
      WRITE(*,99002)i
99001 FORMAT(1X,'expectation value not real')
99002 FORMAT(1X,I3)
 
      END
