      SUBROUTINE FILES(FILOPT)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:1991 cs
*---mru : tk 960527
*-----------------------------------------------------------------------
      INTEGER FILOPT
 
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'bestcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER MFILES
      PARAMETER (MFILES=60)
 
      CHARACTER*(MFLLEN) INFILE,IFILES(MFILES)
      INTEGER LEN,FIN,I,J,ICOUNT,IERR
 
      REAL BL0CPY(MBLPAR,LT1)
      INTEGER BLCCPY(MBLPAR,LT1),ISNEW
      CHARACTER*10 BNMCPY(MBLPAR,LT1)
*-----------------------------------------------------------------------
 
      IF ( FILOPT.EQ.1 ) THEN
 
C LOAD SPECTRUM
        INFILE = SFMASK
        CALL GETFIL('Enter the name(s) of the spectra to load',.FALSE.,
     &              INFILE,LEN)
        IF ( LEN.NE.0 ) THEN
*---if running under demo license, increment "load" count
c          IF ( MFLDMO.GT.0 ) CALL FILCNT(1,IERR)
 
          IF ( (INDEX(INFILE,'*').NE.0) .OR. (INDEX(INFILE,'?').NE.0) )
     &         THEN
            FIN = MFILES
            CALL FILLST(INFILE,IFILES,FIN,.FALSE.)
            ICOUNT = 0
            DO 10 I = 1,FIN
              CALL READSP(IFILES(I),MIN(SPCTOT+1,MMAIN),ISNEW,IERR)
              IF ( (IERR.EQ.0) .AND. (ISNEW.LE.MMAIN) ) THEN
                ICOUNT = ICOUNT + 1
                SPCTOT = ISNEW
              ENDIF
 10         CONTINUE
 
            IF ( ICOUNT.GT.0 ) THEN
              SFMASK = INFILE
              ACTSPC = SPCTOT
              CALL SHOACT(.FALSE.)
              CALL SHOLST
            ENDIF
          ELSE
            CALL READSP(INFILE,MIN(SPCTOT+1,MMAIN),ISNEW,IERR)
            IF ( IERR.EQ.0 ) THEN
              IF ( ISNEW.LE.MMAIN ) SPCTOT = ISNEW
              ACTSPC = SPCTOT
              CALL SHOACT(.FALSE.)
              CALL SHOLST
            ENDIF
          ENDIF
        ENDIF
      ELSEIF ( FILOPT.EQ.2 ) THEN
 
C EDIT CALIBRATION
        IF ( SPCTOT.GT.0 ) THEN
          CALL EDTCAL(ACTSPC,.TRUE.)
          IF ( DATCHU ) CALL MAKTAB(0)
          CALL SHOLST
          CALL SHOACT(.FALSE.)
        ENDIF

      ELSEIF ( FILOPT.EQ.3 ) THEN

C SAVE SPECTRUM
       IF ( SPCTOT.GT.0 ) THEN
          INFILE = ' '
          CALL GETFIL('Enter a filename for this spectrum.',.TRUE.,
     &                INFILE,LEN)
          IF ( LEN.NE.0 ) THEN
            CALL WRITSP(INFILE,ACTSPC,IERR)
            IF ( IERR.EQ.0 ) THEN
              SPCNAM(ACTSPC) = INFILE
              CALL ERRMSG('Data saved to disk.')
            ELSE
              CALL ERRMSG('Error:  Data not saved to disk.')
            ENDIF
            CALL SHOLST
          ENDIF
        ELSE
          CALL ERRMSG('There is no current spectrum to save!')
        ENDIF
      ELSEIF ( FILOPT.EQ.5 ) THEN
 
C READ PARAMETERS
        INFILE = PFMASK
 50     CALL GETFIL('Name of the parameter file:  ',.FALSE.,INFILE,LEN)
        IF ( LEN.NE.0 ) THEN
          IF ( (INDEX(INFILE,'*').NE.0) .OR. (INDEX(INFILE,'?').NE.0) )
     &         THEN
            FIN = 1
            CALL FILLST(INFILE,IFILES,FIN,.TRUE.)
            IF ( FIN.EQ.0 ) GOTO 200
            INFILE = IFILES(1)
          ENDIF
 
*---Save the old baseline values and constraints
          IF ( DATCHU ) THEN
            DO 60 J = 1,LT1
              DO 55 I = 1,MBLPAR
                BL0CPY(I,J) = PBL0(I,J)
                BLCCPY(I,J) = KONBL(I,J)
                BNMCPY(I,J) = PBLNAM(I,J)
 55           CONTINUE
 60         CONTINUE
          ENDIF
 
          OPEN (JDISK,FILE=INFILE)
          CALL GETPAR(IERR)
          CLOSE (JDISK)
 
          IF ( IERR.EQ.0 ) THEN
            IF ( DATCHU ) THEN
              CALL MAKTAB(0)
              DO 65 J = 1,LT1
                DO 62 I = 1,MBLPAR
                  PBLNAM(I,J) = BNMCPY(I,J)
                  PBL0(I,J) = BL0CPY(I,J)
                  KONBL(I,J) = BLCCPY(I,J)
 62             CONTINUE
 65           CONTINUE
            ENDIF
 
            FILNAM(1) = INFILE
            PARLOD = .TRUE.
            CALL MAKVEC
          ELSE
            PARLOD = .FALSE.
            DATCHU = .FALSE.
            NSPEC = 0
            DO 70 I = 1,MMAIN
              PICKED(I) = .FALSE.
 70         CONTINUE
            GOTO 50
          ENDIF
        ENDIF
        CALL SHOLST
      ELSEIF ( FILOPT.EQ.6 ) THEN
 
C EDIT PARAMETERS
 100    IF ( .NOT.(PARLOD) ) THEN
          CALL ERRMSG('No parameters have been entered yet!')
        ELSEIF ( DATCHU ) THEN
          CALL EDTPAR
          CALL MAKVEC
        ELSEIF ( SPCTOT.EQ.1 ) THEN
          CALL MAKTAB(-1)
          DATCHU = .TRUE.
          CALL SHOLST
          GOTO 100
        ELSE
          CALL ERRMSG('Please choose some data!')
          CALL LIST(4)
          IF ( .NOT.DATCHU ) THEN
          ENDIF
        ENDIF
      ELSEIF ( FILOPT.EQ.7 ) THEN
 
C WRITE PARAMETERS
        if (.not. zcrip)then
         IF ( PARLOD ) THEN
          INFILE = FILNAM(1)
          CALL GETFIL('Filename for current parameters:  ',.TRUE.,
     &                INFILE,LEN)
          IF ( LEN.NE.0 ) THEN
            CALL PWRITE(INFILE,IERR)
 
            IF ( IERR.EQ.0 ) THEN
              FILNAM(1) = INFILE
              CALL SHOLST
            ELSE
              CALL ERRMSG('Error:  Could not write parameters.')
            ENDIF
          ENDIF
         ELSE
          CALL ERRMSG('There are no parameters to save!')
         ENDIF
        else
          call errmsg('Demonstration program can not write to disk!')
        endif
      ELSEIF ( FILOPT.EQ.9 ) THEN
 
C CHANGE DIR
        CALL CHGDIR()
      ELSEIF ( FILOPT.EQ.10 ) THEN
 
C DOS SHELL
C Uses interacter OSCMND
        IF ( .NOT.UNIX ) CALL ENDGR
        CALL OSCMND(SHELL)
        IF ( .NOT.UNIX ) CALL INTGRA
      ENDIF
 
 200  RETURN
      END
