      SUBROUTINE GETCFG
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---mru : 950928 tk
*-----------------------------------------------------------------------
      INCLUDE 'iocom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'togcom.inc'
 
      CHARACTER*255 FNAME
      CHARACTER*80 INLINE
      CHARACTER*20 KEY
      CHARACTER*60 VALUE,VAL1
      INTEGER ISTAT,EQSIGN,EXMARK,IERR,K0
      REAL T0
      INTEGER PIONERR
 
      INTEGER LENACT,INFOER
      EXTERNAL LENACT,INFOER
*-----------------------------------------------------------------------
 
      CALL UPPERC(PROG)
      CALL OSVAR(PROG(1:LENact(PROG))//'CFG',FNAME)
      IF ( LENACT(FNAME).EQ.0 ) THEN
        CALL LOWERC(PROG)
        FNAME = PGMDIR(1:PGMLEN)//PROG(1:lenact(prog))//'.cfg'
      ENDIF
      OPEN (JDISK,FILE=FNAME,STATUS='OLD',IOSTAT=ISTAT)
      IF ( ISTAT.NE.0 ) THEN
*---PION
c        PRINT *,'Could not open configuration file '//FNAME
c     &        (1:LENACT(FNAME))
        GOTO 300
      ENDIF
      CALL UPPERC(PROG)
 
 100  READ (JDISK,'(A80)',END=200) INLINE
      EQSIGN = INDEX(INLINE,'=')
      EXMARK = INDEX(INLINE,'!')
      IF ( EXMARK.EQ.0 ) EXMARK = LEN(INLINE) + 1
*---Ignore a line starting with an exclamation point
      IF ( EXMARK.EQ.1 ) THEN
*---Skip keyless lines
      ELSEIF ( LENACT(INLINE(1:EXMARK-1)).EQ.0 ) THEN
*---Skip blank lines
      ELSEIF ( LENACT(INLINE).EQ.0 ) THEN
      ELSEIF ( EQSIGN.GT.0 ) THEN
        KEY = INLINE(1:EQSIGN-1)
        VALUE = INLINE(EQSIGN+1:EXMARK-1)
        VAL1 = VALUE
        CALL JUSTIF(KEY,'Left')
        CALL JUSTIF(VALUE,'Left')
        CALL JUSTIF(VAL1,'Left')
        CALL UPPERC(KEY)
        CALL UPPERC(VALUE)
        IF ( KEY.EQ.'TEMP0' ) THEN
          IERR = INFOER(1)
          CALL STRREA(VALUE,T0)
*---PION(PRINT)
          IF ( INFOER(1).NE.0 ) THEN
c            PRINT *,'Bad TEMP0 in config file; TEMP0 unchanged.'
          PIONERR=0
          ELSE
            TEMP0 = T0
          ENDIF
        ELSEIF ( KEY.EQ.'XSCALE' ) THEN
          IERR = INFOER(1)
          CALL STRINT(VALUE,K0)
*---PION(PRINT)
          IF ( INFOER(1).NE.0 ) THEN
c            PRINT *,'Bad PLOTTYPE value in config file'
          PIONERR=0
          ELSE
            KXPLOT = K0
          ENDIF
        ELSEIF ( KEY.EQ.'YSCALE' ) THEN
          IERR = INFOER(1)
          CALL STRINT(VALUE,K0)
*---PION(PRINT)
          IF ( INFOER(1).NE.0 ) THEN
c            PRINT *,'Bad PLOTTYPE value in config file'
          PIONERR=0
          ELSE
            KYPLOT = K0
          ENDIF
        ELSEIF ( KEY.EQ.'DIAG' ) THEN
          IERR = INFOER(1)
          CALL STRINT(VALUE,K0)
*---PION(PRINT)
          IF ( INFOER(1).NE.0 ) THEN
c            PRINT *,'Bad DIAG value in config file'
          PIONERR=0
          ELSE
            IDIAG = K0
          ENDIF
        ELSEIF ( KEY.EQ.'DIAG4' ) THEN
          IERR = INFOER(1)
          CALL STRINT(VALUE,K0)
*---PION(PRINT)
          IF ( INFOER(1).NE.0 ) THEN
c            PRINT *,'Bad DIAG4 value in config file'
          PIONERR=0
          ELSE
            IDIAG4 = K0
          ENDIF
        ELSEIF ( KEY.EQ.'POSTSCRIPT' ) THEN
          PSPORT = VAL1
        ELSEIF ( KEY.EQ.'LASERJET' ) THEN
          LJPORT = VAL1
        ELSEIF ( KEY.EQ.'HPGL' ) THEN
          HPGLPORT = VAL1
        ELSEIF ( KEY.EQ.'TEXT' ) THEN
          TXPORT = VAL1
        ELSEIF ( KEY.EQ.'EPSON' ) THEN
          EPPORT = VAL1
        ELSEIF ( KEY.EQ.'PSINIT' ) THEN
          PSINIT = VAL1
        ELSEIF ( KEY.EQ.'PSOUT' ) THEN
          PSOUT = VAL1
        ELSEIF ( KEY.EQ.'UNIXGRAPHCMD' ) THEN
          UGRPRT = VAL1
        ELSEIF ( KEY.EQ.'UNIXTEXTCMD' ) THEN
          UTXPRT = VAL1
        ELSEIF ( KEY.EQ.'MONTE' ) THEN
          MONTE = VAL1
        ELSEIF ( KEY.EQ.'PARMASK' ) THEN
          PFMASK = VAL1
        ELSEIF ( KEY.EQ.'SPECMASK' ) THEN
          SFMASK = VAL1
        ELSEIF ( KEY.EQ.'DEMOPATH' ) THEN
          DMOPTH = VAL1
        ELSEIF ( KEY.EQ.'SCREENFILE' ) THEN
          SCRFIL = VAL1
        ELSEIF ( KEY.EQ.'SHELL' ) THEN
          SHELL = VAL1
        ELSEIF ( KEY.EQ.'SYSTEM' ) THEN
          UNIX = (VALUE(1:4).EQ.'UNIX')
          IF ( UNIX ) THEN
            PTHSEP = '/'
          ELSE
            PTHSEP = CHAR(92)
          ENDIF
        ELSEIF ( KEY.EQ.'MOUSE' ) THEN
          MOUSE = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'ROTATEHPGL' ) THEN
          GLROT = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'NNEGAREAS' ) THEN
          NNEGAR = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'DIFFSPEC' ) THEN
          SHORES = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'PLOTSUBS' ) THEN
          SHOSUB = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'KEEPSUBS' ) THEN
          STOSUB = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'SHOWPATHS' ) THEN
          SHOPTH = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'DATETIME' ) THEN
          ZTIMDY = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'SYMBOLS' ) THEN
          ZSYMBL = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'ERRORBARS' ) THEN
          ZBAR = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'LINES' ) THEN
          ZLINE = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'POINTS' ) THEN
          ZPOINT = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'TITLE' ) THEN
          ZTITL = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'THEORY' ) THEN
          ZTHRY = (VALUE(1:2).EQ.'ON')
*        ELSEIF ( KEY.EQ.'XAUTOSCALE' ) THEN
*          ZXAUTO = (VALUE(1:2).EQ.'ON')
*        ELSEIF ( KEY.EQ.'YAUTOSCALE' ) THEN
*          ZYAUTO = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'GRAPHICS' ) THEN
          ZGRAPH = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'LJCOMPRESS' ) THEN
          ZLJCMP = (VALUE(1:2).EQ.'ON')
        ELSEIF ( KEY.EQ.'SCDUMP' ) THEN
          IF ( VALUE(1:4).EQ.'HPGL' ) THEN
            SCDPRT = 1
          ELSEIF ( VALUE(1:8).EQ.'LASERJET' ) THEN
            SCDPRT = 2
          ELSEIF ( VALUE(1:10).EQ.'POSTSCRIPT' ) THEN
            SCDPRT = 3
          ELSEIF ( VALUE(1:5).EQ.'EPSON' ) THEN
            SCDPRT = 4
          ELSE
*---PION(PRINT)
c            PRINT *,'Bad SCDUMP value in configuration file.'
          PIONERR=0
          ENDIF
        ELSEIF ( LENACT(KEY).EQ.0 ) THEN
c          PRINT *,'Missing keyword in configuration file.'
        PIONER=0
        ELSE
c          PRINT *,'Unrecognized keyword in configuration file.'
        ENDIF
      ELSE
      PIONERR=0
c        PRINT *,'Bad line in configuration file.'
      ENDIF
      GOTO 100
 
 200  CLOSE (JDISK)
 
 300  RETURN
      END
