*-----------------------------------------------------------------------
      SUBROUTINE GETFIL(PROMPT,SAVING,INFILE,LENSTR)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    1991 cs, mru 13Aug93 cs
*
*     Gets a filename which already exists (if saving) or a new
*     filename (in which case confirmation is required to use an
*     already existing filname).
*
*     prompt  : Prompt to display asking for filename
*     saving  : Flag indicating whether the user's response should
*               be a new or old filename.
*     infile  : Returned filename
*     lenstr  : Number of characters in response (0 if exited via ESC)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      CHARACTER*(*) PROMPT
      CHARACTER*(MFLLEN) INFILE
      LOGICAL SAVING
      INTEGER LENSTR
*-----------------------------------------------------------------------
      INCLUDE 'iocom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER ICHR,NCHOSE
      LOGICAL EXISTS
      CHARACTER*(MFLLEN) INF1(1)
 
      LOGICAL INYNO
      INTEGER LENACT,INFOCU,INFOER
      EXTERNAL LENACT,INFOCU,INYNO,INFOER
*-----------------------------------------------------------------------
 
*---Get filename
 100  CALL MESSAGE(PROMPT)
      CALL GETS(INFOCU(1)+1,INFOCU(2),INFILE,LEN(INFILE),ICHR,.FALSE.)
 
      IF ( (LENACT(INFILE).EQ.0) .OR. (ICHR.EQ.ESC) ) THEN
        LENSTR = 0
        GOTO 200
      ENDIF
 
      LENSTR = LENACT(INFILE)
 
*---check for wildcards
      IF ( (INDEX(INFILE,'*').NE.0) .OR. (INDEX(INFILE,'?').NE.0) ) THEN
        IF ( .NOT.(SAVING) ) GOTO 200
        NCHOSE = 1
        CALL FILLST(INFILE,INF1,NCHOSE,.FALSE.)
        IF ( NCHOSE.EQ.0 ) GOTO 100
      ENDIF
 
*---Check whether file exists
      IF ( PROG.EQ.'WMRS' ) THEN
        EXISTS = .NOT.SAVING
      ELSE
        INQUIRE (FILE=INFILE,EXIST=EXISTS)
      ENDIF
 
      IF ( .NOT.SAVING ) THEN
        IF ( .NOT.EXISTS ) THEN
          CALL ERRMSG('~Error~:  No such file exists!')
          GOTO 100
        ENDIF
      ELSEIF ( EXISTS ) THEN
        CALL MESSAGE('Write over existing file? (~Y~/~N~) ')
        IF ( .NOT.INYNO(2) ) THEN
          LENSTR = 0
        ELSE
c           ;; Delete old file if extant
c PION = delete file was handled by INTERACTER. Removed it and let
c BINIO to solve the problem.

c          IF ( UNIX ) THEN
c            CALL OSCMNS('/bin/rm -f '//INFILE)
c          ELSE
c            CALL OSCMNS('del '//INFILE)
c          ENDIF
c          IF ( INFOER(1).EQ.13 ) THEN
c            CALL ERRMSG('~Error~:  Could not delete old file!')
c            LENSTR = 0
c          ENDIF
      CALL MESSAGE(' file updated ')
        ENDIF
      ENDIF
 
 200  CALL MESSAGE(' ')
      RETURN
      END
