      SUBROUTINE GETPNT(NPTS,XS,YS,YSNOI,CHAN,ICHR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: CS
*---mru : tk 950303
*     Selects a point on a spectrum assumed to have been already
*     displayed.  Display cursor postion (channel & (x,y) )
*
*     npts   : Number of points in the spectrum
*     xs     : Scaled x coordinates }
*     ys     : Scaled y coordinates } Same scaling as in the
*     ysnoi  : Scaled noise values  } plotted spectrum
*     chan   : On input, initial channel to place cursor
*              On output, selected channel.
*     ichr   : Character pressed to exit (i.e., ESC or ENTER)
*-----------------------------------------------------------------------
      REAL XS(NPTS),YS(NPTS),YSNOI(NPTS)
      INTEGER CHAN,ICHR,NPTS
*-----------------------------------------------------------------------
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
 
      INTEGER I
      REAL XPOS,YPOS,YSMIN,YSMAX
      CHARACTER*8 NUMSTR
 
      INTEGER MRKKEY,INFOIN
      EXTERNAL MRKKEY,INFOIN
*-----------------------------------------------------------------------
 
      CALL ARMM1(YS,NPTS,YSMIN,YSMAX)
 
      IF ( MOUSE ) THEN
        XPOS = XS(CHAN)
        YPOS = YS(CHAN)
        CALL GINXY(XPOS,YPOS)
        IF ( INFOIN(55).EQ.23 ) THEN
          ICHR = ESC
        ELSE
          ICHR = ENTER
          CHAN = NPTS
          DO 20 I = 1,NPTS
            IF ( XS(I).GT.XPOS ) THEN
              CHAN = MAX(1,I-1)
              GOTO 100
            ENDIF
 20       CONTINUE
        ENDIF
      ELSE
        CALL CURSAV
 50     IF ( CHAN.LT.1 ) THEN
          CHAN = CHAN + NPTS
        ELSEIF ( CHAN.GT.NPTS ) THEN
          CHAN = CHAN - NPTS
        ENDIF
 
        CALL CURRES
        CALL NORMAL
        CALL OUTSTR('(')
        CALL CONVRT(XS(CHAN),NUMSTR,.TRUE.)
        CALL JUSTIF(NUMSTR,'l')
        CALL EMPHSZ
        CALL OUTSTR(NUMSTR)
        CALL NORMAL
        CALL OUTSTR(', ')
        CALL CONVRT(YS(CHAN),NUMSTR,.TRUE.)
        CALL JUSTIF(NUMSTR,'l')
        CALL EMPHSZ
        CALL OUTSTR(NUMSTR)
        CALL NORMAL
        CALL OUTSTR(')')
 
        ICHR = MRKKEY(XS(CHAN),YS(CHAN),(YSMAX-YSMIN)/8.)
 
        IF ( ICHR.EQ.RTARR ) THEN
          CHAN = CHAN + 1
        ELSEIF ( ICHR.EQ.LTARR ) THEN
          CHAN = CHAN - 1
        ELSEIF ( ICHR.EQ.CRTARR ) THEN
          CHAN = CHAN + 10
        ELSEIF ( ICHR.EQ.CLTARR ) THEN
          CHAN = CHAN - 10
        ELSEIF ( ICHR.EQ.ENDKEY ) THEN
          CHAN = NPTS
        ELSEIF ( ICHR.EQ.HOME ) THEN
          CHAN = 1
        ELSE
          GOTO 100
        ENDIF
        GOTO 50
      ENDIF
 
 100  CALL MESSAGE(' ')
      RETURN
      END
