*-----------------------------------------------------------------------
      SUBROUTINE GETS(IX1,IY1,INSTR,FLDLEN,ICHR,ARRESC)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    1992 cs, mru 21Dec93 cs
*
* IX1    : X coordinate of the first character
* IY1    : Y coordinate of the first character
* INSTR  : On input, the default string
*          On output, the user's input
* FLDLEN : Length of the input field
* ICHR   : Ascii code of the character the user hit which entered the
*          string
* ARRESC : Should the arrow keys, PGUP/PGDN, etc. confirm a string?
*-----------------------------------------------------------------------
      LOGICAL ARRESC
      CHARACTER*(*) INSTR
      INTEGER IX1,IY1,ICHR,FLDLEN
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
 
      INTEGER LENSTR,IX,IY,VIS1,VIS2,MAXLEN,SHOWLEN
      CHARACTER*255 INSTR1
 
      INTEGER LENACT,INFOCU
      EXTERNAL LENACT,INFOCU
*-----------------------------------------------------------------------
 
      MAXLEN = LEN(INSTR)
 
*---Display default string
      IF ( IX1.LE.0 ) THEN
        IX = INFOCU(1)
      ELSE
        IX = IX1
      ENDIF
      IF ( IY1.LE.0 ) THEN
        IY = INFOCU(2)
      ELSE
        IY = IY1
      ENDIF
 
      CALL SAVCOL
      CALL INVERT
      VIS2 = LENACT(INSTR)
      VIS1 = MAX(1,VIS2-FLDLEN+1)
      CALL CLFIEL(IX,IY,FLDLEN)
      IF ( VIS2.GE.VIS1 ) CALL OUTSXY(IX,IY,INSTR(VIS1:VIS2))
 
      IF ( LENACT(INSTR).EQ.0 ) THEN
        LENSTR = 0
      ELSE
*---Get the user's first keypress; allow the default to be kept
 50     CALL INKEY(ICHR)
        IF ( (ICHR.EQ.ESC) .OR. (ICHR.EQ.ENTER) ) GOTO 300
        IF ( ARRESC .AND. ((ICHR.EQ.UPARR) .OR. (ICHR.EQ.DNARR)) ) THEN
          IF ( ARRESC ) GOTO 300
        ELSEIF ( ARRESC .AND. ((ICHR.EQ.PGDN) .OR. (ICHR.EQ.PGUP)) )
     &           THEN
          IF ( ARRESC ) GOTO 300
        ELSEIF ( (ICHR.EQ.RTARR) .OR. (ICHR.EQ.LTARR) ) THEN
          LENSTR = LENACT(INSTR)
        ELSEIF ( (ICHR.GT.32) .AND. (ICHR.LT.127) ) THEN
          INSTR = CHAR(ICHR)
          LENSTR = 1
        ELSEIF ( ICHR.EQ.SPACE ) THEN
          INSTR = ' '
          LENSTR = 0
        ELSE
          GOTO 50
        ENDIF
      ENDIF
 
*---Display initial entry
 
      CALL CLFIEL(IX,IY,FLDLEN)
 100  VIS2 = LENSTR
      VIS1 = MAX(1,VIS2-FLDLEN+1)
      IF ( LENSTR.LT.MAXLEN .AND. VIS2.GE.FLDLEN ) VIS1 = VIS1 + 1
      IF ( VIS2.GE.VIS1 ) CALL OUTSXY(IX,IY,INSTR(VIS1:VIS2))
 
*---Main Loop
 200  VIS2 = LENSTR
      VIS1 = MAX(1,VIS2-FLDLEN+1)
      IF ( LENSTR.LT.MAXLEN .AND. VIS2.GE.FLDLEN ) VIS1 = VIS1 + 1
      SHOWLEN = VIS2 - VIS1 + 1
      IF ( SHOWLEN.GT.0 ) THEN
        CALL OUTSXY(IX+SHOWLEN-1,IY,INSTR(LENSTR:LENSTR))
      ELSE
        CALL CURXY(IX,IY)
      ENDIF
      IF ( SHOWLEN.LT.FLDLEN ) CALL OUTSTR('_')
      IF ( SHOWLEN.LT.FLDLEN-1 ) CALL OUTSTR(' ')
 
      CALL INKEY(ICHR)
 
      IF ( (ICHR.GE.32) .AND. (ICHR.LT.127) .AND. (LENSTR.LT.MAXLEN) )
     &     THEN
*---Normal Character
        INSTR1 = INSTR
        IF ( LENSTR.GT.0 ) THEN
          INSTR = INSTR1(:LENSTR)//CHAR(ICHR)
        ELSE
          INSTR = CHAR(ICHR)
        ENDIF
        LENSTR = LENSTR + 1
        IF ( (LENSTR.LT.MAXLEN) .AND. (LENSTR.GE.FLDLEN-1) ) GOTO 100
      ELSEIF ( ((ICHR.EQ.DEL) .OR. (ICHR.EQ.BS)) .AND. (LENSTR.GT.0) )
     &         THEN
*---Backing up
        LENSTR = LENSTR - 1
        IF ( (LENSTR.LT.MAXLEN-1) .AND. (VIS1.GT.1) ) GOTO 100
      ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.ESC) .OR. 
     &         ((ICHR.EQ.UPARR) .OR. (ICHR.EQ.PGDN) .OR. (ICHR.EQ.DNARR)
     &         .OR. (ICHR.EQ.PGUP) .AND. ARRESC) ) THEN
*---Exit
        IF ( LENSTR.EQ.0 ) THEN
          INSTR = ' '
        ELSE
          INSTR1 = INSTR(1:LENSTR)
          INSTR = INSTR1(1:LENSTR)
        ENDIF
        GOTO 300
      ENDIF
 
      GOTO 200
 
C Exit Point: Display what the user entered, and return
 300  CALL RSTCOL
      CALL OUTSXY(IX,IY,INSTR(1:MIN(LEN(INSTR),FLDLEN)))
      RETURN
      END
