*-----------------------------------------------------------------------
      SUBROUTINE GETVC2
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     19Jul93 cs
*     Copies all global nonlinear, local nonlinear, global area and
*     linear parm from the parameter vector to the *BEST parameter
*     arrays & CAL arrays; but ignores vector upper/lower bounds.
*     (Linear parameters go into the *0 arrays)
*     Assumes all curent integer parameters correctly reflect the
*     parameter vector contents.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'mancom.inc'
 
      INTEGER I,IPAR,ISUB
 
      REAL PGBEST(MGPAR,MGLO),XI2BST
      REAL PLBEST(MLPAR,MLOC)
      REAL PABEST(MAPAR,LT1)
      COMMON /RGBEST/ PGBEST,XI2BST
      COMMON /RLBEST/ PLBEST
      COMMON /RABEST/ PABEST
*-----------------------------------------------------------------------
      INTEGER KON2I,KON2J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      DO 100 I = 1,NPTOT
        IPAR = KON2I(PARIDX(I))
        ISUB = KON2J(PARIDX(I))
        IF ( PARTYP(I).EQ.GNLTYP ) THEN
          PGBEST(IPAR,ISUB) = PARVEC(I)
        ELSEIF ( PARTYP(I).EQ.LNLTYP ) THEN
          PLBEST(IPAR,ISUB) = PARVEC(I)
        ELSEIF ( PARTYP(I).EQ.GARTYP ) THEN
          PABEST(IPAR,ISUB) = PARVEC(I)
        ELSEIF ( PARTYP(I).EQ.LINTYP ) THEN
          PLN0(IPAR,ISUB) = PARVEC(I)
        ELSEIF ( PARTYP(I).EQ.BLTYP ) THEN
          PBL0(IPAR,ISUB) = PARVEC(I)
        ELSEIF ( PARTYP(I).EQ.CALTYP ) THEN
          CAL(IPAR,ISUB) = PARVEC(I)
        ENDIF
 100  CONTINUE
 
      RETURN
      END
