*-----------------------------------------------------------------------
      SUBROUTINE INTPRN
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*      1992 cs, mru 05Dec93
*
*     Initializes INTERACTER to send all graphics output both to the
*     screen and to the printer until the next call to CLSPRN.
*-----------------------------------------------------------------------
      INCLUDE 'constcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
 
      INTEGER IERR
      CHARACTER*72 TMPFNT
*-----------------------------------------------------------------------
 
*---Set default font to PRINTER font
      TMPFNT = FNTLST(1)
      FNTLST(1) = FNTLST(3)
      FNTLST(3) = TMPFNT
 
      TMPFNT = FNTLST(2)
      FNTLST(2) = FNTLST(4)
      FNTLST(4) = TMPFNT
 
      CALL GCHSET(FNTLST(IFNT))
 
      PRNTNG = .TRUE.
 
      IF ( SCDPRT.EQ.1 ) THEN
        CALL TMPFIL(HPGLPORT,GRFILE,IERR)
      ELSEIF ( SCDPRT.EQ.2 ) THEN
        CALL TMPFIL(LJPORT,GRFILE,IERR)
      ELSEIF ( SCDPRT.EQ.3 ) THEN
        CALL TMPFIL(PSPORT,GRFILE,IERR)
      ELSEIF ( SCDPRT.EQ.4 ) THEN
        CALL TMPFIL(EPPORT,GRFILE,IERR)
      ENDIF
      IF ( IERR.NE.0 ) THEN
        CALL ERRMSG('Could not open temporary file for printing!')
        GOTO 100
      ENDIF
 
      IF ( SCDPRT.EQ.1 ) THEN
        CALL PLOTTR(11)
        CALL GHCSEL(1,1)
        IF ( GLROT ) THEN
          CALL GHCOPT(5,1)
        ELSE
          CALL GHCOPT(5,0)
        ENDIF
        CALL GHCOPT(14,1)
      ELSEIF ( SCDPRT.EQ.2 ) THEN
        CALL PRINTR(11)
        CALL GHCSEL(1,4)
        CALL GHCOPT(5,1)
        CALL GHCOPT(13,1)
        CALL GHCOPT(14,0)
        IF ( ZLJCMP ) THEN
          CALL GHCOPT(24,2)
        ELSE
          CALL GHCOPT(24,0)
        ENDIF
      ELSEIF ( SCDPRT.EQ.3 ) THEN
        CALL GHCSEL(1,2)
        CALL GHCOPT(5,1)
*---do not force hardware font 14,0
        CALL GHCOPT(14,0)
      ELSEIF ( SCDPRT.EQ.4 ) THEN
        CALL PRINTR(7)
        CALL GHCSEL(1,4)
        CALL GHCOPT(5,1)
        CALL GHCOPT(13,1)
        CALL GHCOPT(14,0)
      ENDIF
      CALL GHCOPY(GRFILE)
 
 100  RETURN
      END
