      SUBROUTINE MAKHST(MMONTE,MVAR,VFREE,NMONTE,NFREE,MBINS,HIST,VLB,
     &                  VUB)
*--------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*      mru 920525 tk
*--------------------------------------------------------------------
*---Purpose:  construct probability histograms
*--------------------------------------------------------------------
*---externals
      INTEGER MMONTE,MVAR,NMONTE,NFREE,MBINS
      REAL VFREE(MMONTE,MVAR),HIST(MBINS,MVAR),VLB(MVAR),VUB(MVAR)
 
*---internal variables
      REAL BOX,DV
      INTEGER I,J,K,JVAL,IV
 
*---setup for histogram
      BOX = 1.0/FLOAT(NMONTE)
      DO 100 I = 1,NFREE
        CALL ARMM1(VFREE(1,I),NMONTE,VLB(I),VUB(I))
        IF ( VUB(I).LE.VLB(I) ) THEN
          VUB(I) = VUB(I) + 0.01
          VLB(I) = VLB(I) - 0.01
        ENDIF
 100  CONTINUE
 
*---first zero histogram.
      DO 200 I = 1,NFREE
        DO 150 J = 1,MBINS
          HIST(J,I) = 0.0
 150    CONTINUE
 200  CONTINUE
 
*---create histogram
      DO 300 K = 1,NMONTE
        DO 250 IV = 1,NFREE
          DV = (VUB(IV)-VLB(IV))/MBINS
          JVAL = INT((VFREE(K,IV)-VLB(IV))/DV) + 1
          IF ( JVAL.LT.1 ) JVAL = 1
          IF ( JVAL.GT.MBINS ) JVAL = MBINS
          HIST(JVAL,IV) = HIST(JVAL,IV) + BOX
 250    CONTINUE
 300  CONTINUE
 
 
      RETURN
      END
