*-----------------------------------------------------------------------
      INTEGER FUNCTION MENU(MNUNAM,OPTNAM,NOPT,ISTOPT,JSTSHO)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*   mru 920220 tk
*     Display a menu on top line of screen.
*     Similar to Interacter MNHORI function;
*     WARNING: CHANGES GRAPHICS AREA & SCALING! Caller beware!
*
*     mnunam : name of menu displayed at left of line.
*     optnam : array of menu items to pick from
*     nopt   : the number of menu items
*     istopt : initial highlighted option
*     jstsho : should the routine return immediately after showing
*              the menu (No keyboard input)?
*-----------------------------------------------------------------------
      INTEGER NOPT,ISTOPT
      LOGICAL JSTSHO
      CHARACTER MNUNAM*8
      CHARACTER*9 OPTNAM(NOPT)
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'scrncom.inc'
 
      CHARACTER*1 HOTKEY(20)
      INTEGER I,ICHOICE,ICHR,NROWS
*-----------------------------------------------------------------------
      ICHOICE = ISTOPT
 
*---Scan menu options for first character hotkeys.
      DO 100 I = 1,NOPT
        HOTKEY(2*I-1) = OPTNAM(I)(:1)
        HOTKEY(2*I) = OPTNAM(I)(:1)
        CALL LOWERC(HOTKEY(2*I-1))
        CALL UPPERC(HOTKEY(2*I))
 100  CONTINUE
 
*---Wrap options around
 200  IF ( ICHOICE.LT.1 ) THEN
        ICHOICE = NOPT
      ELSEIF ( ICHOICE.GT.NOPT ) THEN
        ICHOICE = 1
      ENDIF
 
*---Display menu options
*---display clean line
      CALL NORMAL
c      call outsxy(1,1,clean)
*---display menu name
      CALL BRIGHT
      CALL OUTSXY(1,1,MNUNAM//' ')
      CALL NORMAL
      DO 300 I = 1,NOPT
        IF ( I.NE.ICHOICE ) THEN
          CALL EMPHSZ
          CALL OUTSTR(' '//OPTNAM(I)(:1))
          CALL NORMAL
          CALL OUTSTR(OPTNAM(I)(2:)//' ')
        ELSE
          CALL INVERT
          CALL OUTSTR(' '//OPTNAM(I)//' ')
          CALL NORMAL
        ENDIF
 300  CONTINUE
 
 
*---Underline menu if in MSDOS
      IF ( .NOT.UNIX .AND. ZGRAPH ) THEN
        NROWS = ISCROW
        CALL GNORMC()
        CALL GAREA(0.,(NROWS-1.01)/NROWS,1.,1.)
        CALL GUNIT(0.,0.,1.,1.)
        IF ( .NOT.UNIX ) CALL GJOINA(0.,0.,1.,0.)
*---Restore old graphics area/scaling
        CALL GAREA(PA1,QA1,PA2,QA2)
        CALL GUNIT(XA1,YA1,XA2,YA2)
      ENDIF
 
      IF ( .NOT.(JSTSHO) ) THEN
 
*---Get keystroke from user
 350    CALL INKEY(ICHR)
        DO 400 I = 1,NOPT*2
          IF ( ICHAR(HOTKEY(I)).EQ.ICHR ) THEN
            MENU = (I+1)/2
            GOTO 500
          ENDIF
 400    CONTINUE
 
        IF ( (ICHR.EQ.RTARR) .OR. (ICHR.EQ.SPACE) ) THEN
          ICHOICE = ICHOICE + 1
          GOTO 200
        ELSEIF ( ICHR.EQ.LTARR ) THEN
          ICHOICE = ICHOICE - 1
          GOTO 200
        ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.DNARR) ) THEN
          MENU = ICHOICE
*tk 920219***********************
*      elseif (((ichr.gt.SPACE).and.(ichr.le.126)).or.(ichr.eq.ESC)) then
        ELSEIF ( (ICHR.GE.ICHAR('A')) .AND. (ICHR.LE.ICHAR('Z')) ) THEN
          GOTO 350
        ELSEIF ( (ICHR.GE.ICHAR('a')) .AND. (ICHR.LE.ICHAR('z')) ) THEN
          GOTO 350
        ELSEIF ( ICHR.EQ.ESC ) THEN
          MENU = 0
*********************************
        ELSE
          MENU = -ICHR
        ENDIF
      ENDIF
 
 500  RETURN
      END
