*-----------------------------------------------------------------
      SUBROUTINE MOFONT(XPOS,YPOS,STRING)
*-----------------------------------------------------------------
*---Generalized version of Interacter routine GCHAUA.
*---MOFONT ouputs STRING at the graphics co-ordinate (XPOS,YPOS).
*---MOFONT recognizes certain ESCAPE characters as switches for
*---selecting the current font.
*---
*---Note: Upon return current font will be set to that define by
*---      last escape code
*---Examples:  string=' abcde ' would not change font.
*---           string=' abc~2cde ' would leave font #2 active
*---           string=' abc~2cde~1' would leave font #1 active
*---
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*   tk 920207    mru 920207
*-----------------------------------------------------------------
      INCLUDE 'plotcom.inc'
*---externals
      REAL XPOS,YPOS
      CHARACTER STRING*(*)
*---internals
*---lenght of input string excluding trailing blanks
      INTEGER LS
*---counters
      INTEGER I,K
 
      INTEGER LENACT
      EXTERNAL LENACT
 
*---Escape character to signal font change
      CHARACTER ESC*1
      SAVE ESC
      DATA ESC/'~'/
*-----------------------------------------------------------------
 
*---check string length
      LS = LENACT(STRING)
      IF ( LS.LE.0 ) RETURN
*---Define plotting position
      CALL GMOVEA(XPOS,YPOS)
*---Output one character at a time checking for embedded escape code
      I = 0
 100  I = I + 1
      IF ( STRING(I:I).EQ.ESC ) THEN
        I = I + 1
        CALL STRINT(STRING(I:I),K)
        IF ( K.GE.1 .AND. K.LE.MAXFNT ) IFNT = K
        CALL GCHSET(FNTLST(IFNT))
      ELSE
        CALL GCHOUR(STRING(I:I))
      ENDIF
      IF ( I.LT.LS ) GOTO 100
 
      RETURN
      END
