 
*----------------------------------------------------------------------
      INTEGER FUNCTION MRKKEY(XDAT,YDAT,DATNOI)

*--- PION 110620: replace gcoln()

*----------------------------------------------------------------------
*     Displays a blinking "cursor" over the data and
*        waits for a keypress; the function returns the Interacter
*        keycode of this key.
*     xdat   : x-position of data point
*     ydat   : y-position of data point
*     datnoi : noise of data point
*----------------------------------------------------------------------
      REAL XDAT,YDAT,DATNOI
*----------------------------------------------------------------------
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
 
      INTEGER ICHR
      REAL CURLEN,YSTART
*----------------------------------------------------------------------
 
*---define window and units (see common /pbox/)
      CALL GAREA(PA1,QA1,PA2,QA2)
      CALL GUNIT(XA1,YA1,XA2,YA2)
 
 
      CURLEN = MAX(2*DATNOI,(YA2-YA1)/16.0)
 
      IF ( YFLIP ) THEN
        YSTART = -YDAT + CURLEN
      ELSE
        YSTART = YDAT + CURLEN
      ENDIF
 
 
	call igrcolourn(THRCOL)
c      CALL GCOLN(THRCOL)
      CALL GPLOTM('E')
      CALL GMOVEA(XDAT,YSTART)
      CALL GLINER(0.0,-2*CURLEN)
 
      CALL INKEY(ICHR)
 
      CALL GMOVEA(XDAT,YSTART)
      CALL GLINER(0.0,-2.0*CURLEN)
      CALL GPLOTM('N')
 
      MRKKEY = ICHR
 
      RETURN
      END
