*-----------------------------------------------------------------------
      SUBROUTINE NOBLNK(STR,IERR)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 21May93 CS
*
*     Find substring in string STR, remove leading blanks,
*     then fill remaining substring with blanks.
*     Example  '  xyz prq  ' -->  'xyz        '
*-----------------------------------------------------------------------
      CHARACTER STR*(*)
      INTEGER IERR
*-----------------------------------------------------------------------
      INTEGER ISTART,IEND,LENSUB
      CHARACTER DUM*80
*-----------------------------------------------------------------------
 
*---clear error flag and dum string
      IERR = 0
      DUM = ' '
 
*---use Interacter Libraray routines to find first sub-string.
      CALL LOCSTR(STR,ISTART,IEND)
 
*---if STR empty, return with error flag set
      IF ( IEND.EQ.0 ) THEN
        IERR = 1
        RETURN
      ENDIF
 
*---fill STR with blanks and then left-justify substring.
      LENSUB = IEND - ISTART + 1
      DUM(:LENSUB) = STR(ISTART:IEND)
      STR = ' '
      STR(:LENSUB) = DUM(:LENSUB)
 
      RETURN
      END
