*-----------------------------------------------------------------------
      SUBROUTINE NUDATA(ZNOISE)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: TK 900124
*---mru:  TK 931002
*
*     This version of nudata uses unique noise values
*     for each data point.
*
*     znoys : [Input]  Add noise when copying data to fit table?
*-----------------------------------------------------------------------
      LOGICAL ZNOISE
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'bestcom.inc'
      INTEGER I,ISPEC
 
      REAL GASDEV
      EXTERNAL GASDEV
*-----------------------------------------------------------------------
 
      IF ( ZNOISE ) THEN
        DO 50 ISPEC = 1,NSPEC
          DO 20 I = 1,ICAL(1,ISPEC)
*--old method perturb orig data:
*---               spec(i,ispec,1) = spec0(i,ispec,1) +
*---new way perturbs orig fit (theory)
            SPEC(I,ISPEC,1) = RESPONSE(I,ISPEC,0,0) + GASDEV(0)
     &                        *SNOYS(I,ISPEC,1)
 20       CONTINUE
 50     CONTINUE
      ELSE
        DO 100 ISPEC = 1,NSPEC
          DO 60 I = 1,ICAL(1,ISPEC)
            SPEC(I,ISPEC,1) = SPEC0(I,ISPEC,1)
 60       CONTINUE
 100    CONTINUE
      ENDIF
 
      RETURN
      END
