      SUBROUTINE OPTIONS
*---WMOSS version
*---display OPTIONS box and accept keyboard input to define toggles.
*---WEB Reserch Co. 
*---orig: before 921219 tk
*---mru : 950921 tk; 19980320 tk
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'plotcom.inc'
 
      INTEGER WIDTH,HEIGHT,MAXOPT,OPTWID,ULX,ULY
      PARAMETER (MAXOPT=6,OPTWID=20,HEIGHT=MAXOPT+3,WIDTH=optwid+7)
      PARAMETER (ULX=(80-WIDTH)/2,ULY=(30-HEIGHT)/2)
 
      CHARACTER*(OPTWID) OPTMNU(MAXOPT)
      INTEGER OPTOPT, i, ichr, ichr1, iopt

      save optmnu
      DATA OPTMNU/'Diff Spec','Plot Subs','Subs->List',
     &   'Vel. Scale Cal. [F7]',
     &   'X autoscale','Y autoscale'/
 
      call normal
      CALL WNACTN('CP')
      CALL WNOPEN(ULX,ULY,WIDTH,MAXOPT+4)
      CALL FRAME1(ULX,ULY,ULX+WIDTH-1,ULY+HEIGHT-1,'C','Options')
 
      OPTOPT = 1
 
 100  IOPT = 1
      DO 200 I = 1,MAXOPT
        IOPT = IOPT + 1
        IF ( I.EQ.OPTOPT ) THEN
           call invert
        ELSE
           call normal
        ENDIF
        CALL WNOUSX(2,IOPT,OPTMNU(I))
 200  CONTINUE
 
      call normal
 
      IF ( SHORES ) THEN
        CALL WNOUSX(OPTWID+3,2,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,2,'OFF')
      ENDIF
 
      IF ( SHOSUB ) THEN
        CALL WNOUSX(OPTWID+3,3,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,3,'OFF')
      ENDIF
 
      IF ( STOSUB ) THEN
        CALL WNOUSX(OPTWID+3,4,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,4,'OFF')
      ENDIF
 
      IF (kxplot.eq.2) THEN
        CALL WNOUSX(OPTWID+3,5,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,5,'OFF')
      ENDIF

      IF (zxauto) THEN
        CALL WNOUSX(OPTWID+3,6,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,6,'OFF')
      ENDIF
 
      IF (zyauto) THEN
        CALL WNOUSX(OPTWID+3,7,'ON ')
      ELSE
        CALL WNOUSX(OPTWID+3,7,'OFF')
      ENDIF
 
 
      CALL INKEY(ICHR)
      IF ( ICHR.EQ.DNARR ) THEN
        OPTOPT = MIN(OPTOPT+1,MAXOPT)
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        OPTOPT = MAX(OPTOPT-1,1)
      ELSEIF ( ICHR.EQ.ENTER ) THEN
        IF ( OPTOPT.EQ.1 ) THEN
          SHORES = .NOT.SHORES
        ELSEIF ( OPTOPT.EQ.2 ) THEN
          SHOSUB = .NOT.SHOSUB
        ELSEIF ( OPTOPT.EQ.3 ) THEN
          STOSUB = .NOT.STOSUB
        ELSEIF ( OPTOPT.EQ.4 ) THEN
          zscale = .true.
          kxplot = 3 - kxplot
          CALL MESSAGE(' ')
        elseif (optopt.eq.5) then
          if (zxauto) then
             CALL WNOUSX(OPTWID+3,6,'OFF')
             manlt = clplt
  400        call message('New minimum X-value?  ')
             call getr(0, 0, manlt, ichr1, .false.)
             if (ichr1.eq.ESC) goto 100
             manrt = clprt
             call message('New maximum X-value?  ')
             call getr(0, 0, manrt, ichr1, .false.)
             if (ichr1.eq.ESC) goto 400
          endif
          zscale = .true.
          zxauto = .not.zxauto
          if(.not.zxauto)call errmsg('X autoscale OFF')
          call message(' ' )
        elseif (optopt.eq.6) then
          if (zyauto) then
             call wnousx(OPTWID+3,7,'OFF')
             manbot = clpbot
  410        call message('New minimum Y-value?  ')
             call getr(0, 0, manbot, ichr1, .false.)
             if (ichr1.eq.ESC) goto 100
             mantop = clptop
             call message('New maximum Y-value?  ')
             call getr(0, 0, mantop, ichr1, .false.)
             if (ichr1.eq.ESC) goto 410
          endif           
          zscale = .true.
          zyauto = .not.zyauto
          if(.not.zyauto)call errmsg('Y autoscale OFF')
          call message(' ' )
        ENDIF
      ENDIF
      IF ( ICHR.NE.27 ) GOTO 100
 
      CALL WNCLOS(1)
      RETURN
      END
