      subroutine pspm
*-----------------------------------------------------------------------
*     CREATES POST SCRIPT FILE FOR DATA PRINTING OR PLOTTING.
*     GFWBI     TAK  2/10/87  KKS   
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---major rewrite 17Aug93 cs
*---mru 931116 tk; 971209 tk
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'
      include 'constcom.inc'
      include 'togcom.inc'
      include 'keycom.inc'
      include 'scrncom.inc'
*---patch
      real v1(3,3)
      common/efg1/ v1
 
      integer chuspc
      integer i1, inow, ichr
      character str40*40,cmt*86
      integer ispec
      logical zstd, zland, zppar, zhead, zabscl, z, zchan, zcent
      logical zreset, z1scl
      integer kxplt1, kyplt1, ntop
      logical msk(LSPEC)
      real xs(LSPEC), ys(LSPEC), ysnoi(LSPEC), toplst(2,MTOP)
      real ysmin, ysmax, xsmin, xsmax
      real ysmin1, ysmax1, ysrng1, xsmin1, xsmax1, xsrng1
      real ysdatabox, xsdatabox, xaxisbox, yaxisbox
      real y0databox, x0databox, x0axisbox, y0axisbox
      real ypos, yspos, xs1, ydisp, weight
 
      integer ntic, isymbl, npts, itype

      real dtic

      integer j, kc, i, ip
      character*40 outfil
      character*255 pscmnd

      integer lenact, infocu
      external lenact, infocu

      real yscale, yy, xscale, xx, cent11, cent8, cent8a

      integer mtics
*980104 tk:      parameter(mtics=27)
      parameter(mtics=27)
      real ticeff(mtics), ticspc(mtics)
      integer ticnum(mtics), illx, illy, iurx, iury
      integer iyr,imon,iday,ihr,imin,isec,izero
      character sdate*8,stime*8
      character*15 symbls(0:7)
      save ticeff, ticnum, ticspc, symbls
      data ticeff/20., 15., 14., 12., 10., 8., 7., 6., 5., 4.,
     &   3.5, 3., 2.5, 2., 1.6, 1.4, 1.2, 1., .8, .7, .6, .5,
     &   .4, .3, .2, .1, -1.e30/
      data ticnum/4, 5, 7, 6, 5, 4, 7, 6, 5, 4, 7, 6, 5, 4, 8, 7, 6, 5,
*980104 tk:     &   4, 7, 6, 5, 4, 3, 2, 1, 1/
     &   4, 3, 3, 5, 4, 3, 2, 1, 1/
*980104 tk:      data ticspc/5., 3., 4*2., 4*1., 4*.5, 5*0.2, 7*0.1,
*               &   0.05/
      data ticspc/5., 3., 4*2., 4*1., 4*.5, 5*0.2, 
     &   0.2, 0.2, 5*0.1, 0.05/
      data symbls/'vbar', 'cross', 'line', 'ocircle', 'ccircle',
     &   'osquare', 'csquare', 'dashline'/
*-----------------------------------------------------------------------
      yscale(yy) = ((yy-ysmin1)/(ysmax1-ysmin1) - 1)*ysdatabox +
     &   y0axisbox + ydisp
      xscale(xx) = (xx-xsmin1)/xsrng1 * xsdatabox + x0databox
      cent8(xx) = 0.25 + (7.75-xx) / 2
      cent8a(xx) = 0.5 + (7.5-xx) / 2
      cent11(xx) = 1. + (10-xx) / 2
*-----------------------------------------------------------------------

C
C---CREATE POSTSCRIPT FILE FROM INFO. IN OTHER FILES.
c
      call normal
      call outsxy(1,1,'Mossbauer PostScript Plot')

      call outsxy(1,infocu(2)+1,'Output to:  ')
      outfil = psport
      call gets(0,infocu(2),outfil,len(outfil),ichr,.false.)
      if (ichr.eq.ESC.or.lenact(outfil).eq.0) goto 1000

      call outsxy(1, infocu(2) + 1,
     &   'Reset printer before & after plot (Y/N) ? ')
      zreset = .true.
      call getl(0,0,zreset,' ',' ',ichr,.false.)
      if (ichr.eq.ESC) goto 100

      zstd = .true.
      call outsxy(1, infocu(2)+1, 
     &   'Standard plot              (Y/N) ? ')
      call getl(0,0,zstd,' ',' ',ichr,.false.)
      if (ichr.eq.ESC) goto 100
 
      zhead = .true.
      if (.not.zstd) then
         call outsxy(1, infocu(2)+1,
     &      'Print filename and comment (Y/N) ? ')
         call getl(0,0,zhead,' ',' ',ichr,.false.)
         if (ichr.eq.ESC) goto 100
      endif

      zppar = parlod
      if (parlod) then
         call outsxy(1,infocu(2)+1,
     &      'Print current parameters   (Y/N) ? ')
         call getl(0,0,zppar,' ',' ',ichr,.false.)
         if (ichr.eq.ESC) goto 100
      endif

      xsdatabox = 7.6
      ysdatabox = 5.1 
      xaxisbox = 8.0
      yaxisbox = 5.5
      zland = .true.
      zcent = .true.

      if (.not.zstd ) then
         call outsxy(1, infocu(2)+1,
     &      'Landscape orientation      (Y/N) ? ')
         call getl(0,0,zland,' ',' ',ichr,.false.)
         if (ichr.eq.ESC) goto 100

         call outsxy(1, infocu(2)+1,
     &      'Enter horizontal size of axes [inches] :  ')
         call getr(0,0,xaxisbox,ichr,.false.)
         if (ichr.eq.ESC) goto 100

         call outsxy(1, infocu(2)+1,
     &      'Enter vertical size of axes   [inches] :  ')
         call getr(0,0,yaxisbox,ichr,.false.)
         if (ichr.eq.ESC) goto 100

         call outsxy(1, infocu(2)+1,
     &      'Enter horizontal size of data [inches] :  ')
         call getr(0,0,xsdatabox,ichr,.false.)
         if (ichr.eq.ESC) goto 100

         call outsxy(1, infocu(2)+1,
     &      'Enter vertical size of data   [inches] :  ')
         call getr(0,0,ysdatabox,ichr,.false.)
         if (ichr.eq.ESC) goto 100
      endif

      if (zland) then
*--landscape
         x0axisbox = cent11(xaxisbox)
         y0axisbox = cent8(yaxisbox)
         x0databox = cent11(xsdatabox)
         if (zcent) then
            y0databox = cent8(ysdatabox)
         else
            y0databox = y0axisbox + (0.18/5.5) * yaxisbox
         endif
         illx = nint((8.-y0axisbox-yaxisbox)*72)
         illy = nint((x0axisbox-0.2)*72)
         iurx = nint((8.-y0axisbox+0.6)*72)
         iury = nint((0.5+x0axisbox+xaxisbox)*72)
         if (zppar) then
            illx = illx - 8
            illy = 0
            iurx = 8.5 * 72
         endif
         if (zhead) then
            illx = min(illx, nint((8.-7.3)*72)-7)
            illy = min(illy, nint(0.1*72)+36)
         endif
      else
*--portrait
         x0axisbox = cent8a(xaxisbox)
         y0axisbox = cent11(yaxisbox)
         x0databox = cent8a(xsdatabox)
         if (zcent) then
            y0databox = cent11(ysdatabox)
         else
            y0databox = y0axisbox + (0.18/5.5) * yaxisbox
         endif
         illx = max(0,nint((x0axisbox-0.2)*72))
         illy = max(0,nint((y0axisbox-0.1)*72))
         iurx = nint((0.5+x0axisbox+xaxisbox)*72) + 2
         iury = nint((0.5+y0axisbox+yaxisbox)*72) + 2
         if (zppar) then
            iury = iury + 8
            illx = 0
            illy = 0
         endif
         if (zhead) then
            iury = max(iury, nint(10.5*72)+7)
            illx = min(illx, nint(0.1*72)+36)
         endif
      endif
*---------------------------------------------------------------
*---Create EPS header  file
      open (5,file=psout)
      if (zreset) write (5,*) char(4)
      write(5,'(A)') '%!PS-Adobe-3.0 EPSF-3.0'
      write(5,'(A)') '%%Creator: WMOSS'
      write(5,'(A)') '%%Title: '//outfil(:lenact(outfil))
      call osdate(iyr,imon,iday)
      call ostime(ihr,imin,isec)
      izero = ichar('0')
      sdate = char(izero+imon/10)//char(izero+mod(imon,10))//'/'//
     &   char(izero+iday/10)//char(izero+mod(iday,10))//'/'//
     &   char(izero+mod(iyr,100)/10)//char(izero+mod(iyr,10))
      stime = char(izero+ihr/10)//char(izero+mod(ihr,10))//':'//
     &   char(izero+imin/10)//char(izero+mod(imin,10))//':'//
     &   char(izero+isec/10)//char(izero+mod(isec,10))
      write(5,'(A)') '%%CreationDate: '//sdate//' at '//stime
      write(5,'(A15,4I5)') '%%BoundingBox: ',illx,illy,iurx,iury
      write(5,'(A)') '%%Pages: 1'
      write(5,'(A)') '%%DocumentFonts: Times-Roman '
      write(5,'(A)') '%%IncludeFont: Times-Roman '
      write(5,'(A)') '%%EndComments'
      write(5,'(A)') '%%BeginProlog'
      write(5,'(A)') '%%EndProlog'
      write(5,'(A)') '%%BeginSetup'
      write(5,'(A)') '%%EndSetup'
      write(5,'(A)') '/Save_state save def'

      close(5)
*---append WMOSS PostScript procedures to EPS header
      pscmnd = 'copy/b '//psout(1:lenact(psout)) //'+'//
     &                  psinit(1:lenact(psinit)) //
     &                 ' temp.eps > nul'
      call oscmns(pscmnd)

*---------------------------------------------------------------
*---now append specific data and format ...
      open (5,file=psout)

      if (zland) then
         write(5,*) 'landscape'
      else
         write(5,*) 'portrait'
      endif
      write(5,*) '/x0databox ', x0databox, ' def'
      write(5,*) '/y0databox ', y0databox, ' def'
      write(5,*) '/x0axisbox ', x0axisbox, ' def'
      write(5,*) '/y0axisbox ', y0axisbox, ' def'
      write(5,*) '/xsdatabox ', xsdatabox, ' def'
      write(5,*) '/ysdatabox ', ysdatabox, ' def'
      write(5,*) '/xaxisbox ', xaxisbox, ' def'
      write(5,*) '/yaxisbox ', yaxisbox, ' def'

      if (zstd) then
         write(5,*) 'stdplot'
      else
         write(5,*) 'pubplot'
      endif

      ispec = 0
      i1 = 0
      z1scl=.true.
      call curxy(1, infocu(2)+2)
      call cursav

   20 call curres
      call clarea(1, infocu(2), isccol, iscrow)
      inow = chuspc('SPECTRA')
      if ( inow.le.0 ) then
         ichr = ESC
         goto 100
      endif

*---store stack pointer for First spectrum
      if(i1.eq.0)i1=inow
 
      call normal
      call outsxy(1,infocu(2),'Plotting Symbol')
      call outsxy(1, infocu(2)+1,
     &   '   0=vbar; 1=cross; 2=line; 3=open circle; 4=closed circle;')
      call outsxy(1, infocu(2)+1,'5=open square; 6=closed square')
      call outsxy(1, infocu(2)+1,'7=dashed line :  ')
      isymbl = 0
      call geti(0,0,isymbl,ichr,.false.)
      if (ichr.eq.ESC) goto 100

*---get toggle for which vertical scale to use
      if(inow.ne.i1)then
      call outsxy(1, infocu(2)+1,
     &   'Scale to % Absorption scale of 1st spectrum'
     &   //' (like SSUB) [Y/N] ?')
         call getl(0,0,z1scl,' ',' ',ichr,.false.)
         if (ichr.eq.ESC) goto 100
      endif

      ispec = ispec + 1
      write (5,*) '% Spectrum # ',ispec
      write (5,*) '/ispec ',ispec,' def'
      write (5,*) '/field ',spccal(1,inow),' def'
      write (5,*) '/temperature ',spccal(2,inow),' def'
      write (5,*) '/bsline ',spccal(3,inow),' def'
      write (5,*) '/zvc ',spccal(6,inow),' def'
      write (5,*) '/slope ',spccal(7,inow),' def'
      write (5,*) '/dplotsym ('//symbls(isymbl)//') def'
       
      if (ispec.eq.1) then
         call outsxy(1, infocu(2)+2,
     &      'Plot by Channel numbers    (Y/N) ? ')
         zchan = (kxplot.eq.1)
         call getl(0,0,zchan,' ',' ',ichr,.false.)
         if (ichr.eq.ESC) goto 100
         if (zchan) then
            kxplt1 = 1
         else
            kxplt1 = 2
         endif
      endif

      ydisp = y0databox + ysdatabox - y0axisbox
      call outsxy(1, infocu(2) + 1,
     & 'Enter position above bottom axis of highest data [inches]  :  ')
      call getr(0, 0, ydisp, ichr, .false.)
      if (ichr.eq.ESC) goto 100

      weight = 1.0
      if (ispec.gt.1) then
         zabscl = .true.
         if (.not.zstd) then
            call outsxy(1, infocu(2)+1,
     &         'Show absorption scale   (Y/N) ? ')
            call getl(0,0,zabscl,' ',' ',ichr,.false.)
            if (ichr.eq.ESC) goto 100
         endif
      
         call outsxy(1, infocu(2)+1,
     &      'Weighting factor (>0=area, <0=height)  :  ')
         call getr(0,0,weight,ichr,.false.)
         if (ichr.eq.ESC) goto 100
      endif
      write (5,*) '/weight ',weight,' def'

      if (.not.zstd) then
         call outsxy(1,infocu(2)+1,'Label for this spectrum:  ')
         str40 = ' '
         call gets(0,0,str40,40,ichr,.false.)
         if (ichr.eq.ESC) goto 100
         write(5,*) '/label ('//str40//') def'
      endif
      write(5,*) '/filename ('//spcnam(inow)(1:8)//') def'

*---mark "(" and ")" then write first comment
      j = 1
      cmt = ' '
      do 30 kc = 1,lenact(spccmt(1,inow))
         if ( spccmt(1,inow)(kc:kc).eq.'(' ) then
            cmt(j:j+1) = '\('
            j = j + 2
         elseif ( spccmt(1,inow)(kc:kc).eq.')' ) then
            cmt(j:j+1) = '\)'
            j = j + 2
         else
            cmt(j:j) = spccmt(1,inow)(kc:kc)
            j = j + 1
         endif
   30 continue
      write (5,*) '/comment ( '//cmt//' ) def'
 
*---mark "(" and ")" then write second comment
      j = 1
      cmt = ' '
      do 40 kc = 1,lenact(spccmt(2,inow))
         if ( spccmt(2,inow)(kc:kc).eq.'(' ) then
            cmt(j:j+1) = '\('
            j = j + 2
         elseif ( spccmt(2,inow)(kc:kc).eq.')' ) then
            cmt(j:j+1) = '\)'
            j = j + 2
         else
            cmt(j:j) = spccmt(2,inow)(kc:kc)
            j = j + 1
         endif
   40 continue
      write(5,*) '/comment2 ( '//cmt//' ) def'
c
      kyplt1 = 2
      npts = icalsp(1,inow)
      itype = icalsp(10,inow)
      if(z1scl)then
*---scale data to percent absortption scale of first spectrum
      call scldat(itype, npts, xspc(1,inow), spctra(1,inow),
     &   spcnoi(1,inow),
     &   spcmsk(1,inow), spccal(1,i1), kxplt1, kyplt1, xs, ys, ysnoi, 
     &   msk, ntop, toplst)
      else
*---scale data to percent absortption scale of current spectrum
      call scldat(itype,npts, xspc(1,inow), spctra(1,inow),
     &   spcnoi(1,inow),
     &   spcmsk(1,inow), spccal(1,inow), kxplt1, kyplt1, xs, ys, ysnoi,
     &   msk, ntop, toplst)
      endif

      call armm1(ys, npts, ysmin, ysmax)
      call armm1(xs, npts, xsmin, xsmax)
      if (ispec.eq.1) then
         ysmin1 = ysmin - ysnoi(1)
         ysmax1 = ysmax + ysnoi(1)
         xsmin1 = xsmin
         xsmax1 = xsmax
         ysrng1 = ysmax1 - ysmin1
         xsrng1 = xsmax1 - xsmin1
      endif

      write(5,*) '/yheight ', y0axisbox + ydisp, ' def'

*---Get weight
      if (weight.gt.0) then
      else
         if (ysmin.ne.0) then
*---For scaling according to height: Height = baseline - min data point
            weight = -weight * (ysmin1+ysnoi(1)) / ysmin
         else
            weight = 0.0
         endif
      endif

*---Set font size & Plot absorption scale
      write(5,*) 'gsave  newpath  14 fontscale'
      if (ispec.eq.1) then
         do 410 i = 1, mtics
            if (abs(ysmin).gt.ticeff(i)) then
               ntic = ticnum(i)
               dtic = ticspc(i)
               goto 411
            endif
  410    continue
  411    do 420 i = 1, ntic+1
            ypos = - (i-1) * dtic
            yspos = yscale(ypos)
            if (yspos.le.y0axisbox+yaxisbox) then
               if (yspos.ge.y0axisbox) then
                  write(5,*) '  ', yspos, ' ytic'
                  write(5,*) '  ', -ypos, yspos, ' ylababs'
               endif
            endif
  420    continue
         write(5,*) 'showabslabel'
      elseif (zabscl) then
         write(5,*) '  ', yscale(0.), ' ytic'
         write(5,*) '  ', 0., yscale(0.), ' ylababs'
         write(5,*) '  ', yscale(-weight*dtic), ' ytic'
         write(5,*) '  ', dtic, yscale(-weight*dtic),
     &      ' ylababs'
      endif
      write(5,*) 'stroke grestore'

*---Plot data
*---931005 tk : scale noise same way as data.
      write(5,*) '/ysnoi ', weight*ysnoi(1)/ysrng1*ysdatabox, ' def'
      write(5,*) 'gsave  newpath'
      write(5,*) '  x0axisbox y0axisbox moveto'
      write(5,*) '  xaxisbox yaxisbox llbox'
      write(5,*) '  clip newpath'
      if (isymbl.eq.7) write(5,*) '  [0.1 0.025] 0 setdash '
      write(5,*) '  ',xscale(xs(1)), yscale(ys(1)*weight),
     &   ' moveto'
      do 430 i = 1, npts
         write(5,*) '  ',xscale(xs(i)), yscale(weight*ys(i)),
     &      ' ', symbls(isymbl)
  430 continue
      write(5,*) 'stroke  grestore'
               
*---Display x-scale if on first spectrum
      if (ispec.eq.1) then
         write(5,*) 'gsave  newpath'
         if (zchan) then
            write(5,*) '  7 fontscale'
            do 440 i = 1, icalsp(1,i1), 10
               xs1 = xscale(float(i))
               write(5,*) '  ',xs1, ' xtic'
               write(5,*) '  ',i, xs1, ' xlabch#'
  440       continue
            write(5,*) 'showchlabel  stroke  grestore'
         else
*---set font size for Veloctiy Scale
            write(5,*) ' 14 fontscale '
            ntic = 0.9 * (xsmax1-xsmin1) / 2
            do 450 i = -ntic, ntic
               xs1 =  xscale(float(i))
               write(5,*) '  ', xs1, ' xtic'
               if (mod(i,2).eq.0) write(5,*) '  ', i, ' ', xs1,
     &            ' xlabvel'
  450       continue
            write(5,*) 'showvellabel stroke grestore'
         endif
      endif

*---Display header & label if requested
      if (zhead) write(5,*) 'print_header'
      if (.not.zstd) write(5,*) 'showlabel'
c
      z = .false.
      call outsxy(1, infocu(2)+2,
     &   'Add another spectrum (Y/N) ? ')
      call getl(0,0,z,' ',' ',ichr,.false.)
      if (ichr.eq.ESC) goto 100
      if (z) goto 20

      if (zppar) then
*---write efg tensor of site #1
         write(5,'(a8,6f7.3,a6)') '/efg1 [ ', v1(1,1), v1(2,2),
     &      v1(3,3), v1(2,1), v1(3,1), v1(3,2),' ] def'
*---define parameter names and values
         write (5,*) ' /parnam [ '
*---tack on global integer parameter names, i > 2
         do 42 ip = 3, igp(1,1)
            write (5,9001) '( ',igpnam(ip,1),' )'
   42    continue
*---insert blank
         write(5,9001) '( ','----------',' )'
*---real parameter names
         do 44 ip = 1,nptot
            write (5,9001) '( ',parnam(ip),' )'
   44    continue
         write (5,*) ' ] def '
         write (5,*) ' /parvec [ '
*---tack on global integer parameters values, i > 2
         do 46 ip = 3, igp(1,1)
            write (5,9002) igp(ip,1)
   46    continue
*---insert dummy value
         write (5,9002) 0
*---real parameters
         do 48 ip = 1,nptot
            write (5,'(f10.4)') parvec(ip)
   48    continue
         write (5,*) ' ] def '
         write (5,*) ' listpar'
      endif
 
      write (5,*) 'showpage'
      write (5,*) 'end'
      write (5,'(A9)') '%%Trailer'
      write (5,*) 'Save_state restore'


      if (zreset) write (5,*) char(4)//char(26)

      close(5)

      call clscrn
      call outsxy(1,1,'Copying to the printer, please wait...')
c         pscmnd = 'copy/b ' // psout(1:lenact(psout)) // ' ' //
          pscmnd = 'copy/b temp.eps+'//psout(1:lenact(psout)) // ' ' //
     &      outfil(1:lenact(outfil)) // ' > nul'
      call outsxy(1,2,pscmnd(:80))
      call oscmns(pscmnd)
      call oscmns('del temp.eps')
      goto 1000
 
  100 close (5)
 1000 return

 9001 format (a2,a10,a2)
 9002 format (i5)
      end
