      SUBROUTINE REPMNU(ILEVEL,CHIBST)
*-----------------------------------------------------------------------
*     Allows spectrum manipulations within a fit
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     920220 CS, mru 23May94
*-----------------------------------------------------------------------
      INTEGER ILEVEL
      REAL CHIBST
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'bestcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'keycom.inc'
 
      EXTERNAL GETYN
      LOGICAL GETYN
 
      CHARACTER MNUNAM*8
      INTEGER REPOPT
      PARAMETER (REPOPT=6)
      CHARACTER*9 REPMAI(REPOPT)
 
      INTEGER DEFALT,ICHOICE
 
      INTEGER MENU
      EXTERNAL MENU
 
      SAVE REPMAI
      DATA REPMAI/'Next Spec','Print','Options','Zoom','Continue',
     &     'Abort'/
 
      MNUNAM = 'Paused:'
      CALL WNSAVE(1,1,ISCCOL,2)
 
      DEFALT = 1
 100  ICHOICE = MENU(MNUNAM,REPMAI,REPOPT,DEFALT,.FALSE.)
      IF ( ICHOICE.GT.0 ) THEN
*---show next spectrum
        DEFALT = ICHOICE
        IF ( ICHOICE.EQ.1 ) THEN
          IF ( NSPEC.GT.1 ) THEN
            REPSPC = REPSPC + 1
            IF ( REPSPC.GT.NSPEC ) REPSPC = 1
*---show data
            ZSCALE = .TRUE.
            CALL REPPLT(.FALSE.)
*---show fit
            CALL SIMPLT(ILEVEL,.FALSE.)
          ENDIF
        ELSEIF ( ICHOICE.EQ.2 ) THEN
*---screen dump to printer
          CALL CLRALL
          CALL INTPRN
*---show data
          CALL REPPLT(.TRUE.)
*---show fit
          CALL SIMPLT(ILEVEL,.TRUE.)
          CALL CLSPRN
*---return to screen output only and clear screen
          CALL CLRALL
*---replot to ensure plot size is correctly defined in case fit continued
*---show data
          CALL REPPLT(.FALSE.)
*---show fit
          CALL SIMPLT(ILEVEL,.FALSE.)
        ELSEIF ( ICHOICE.EQ.3 ) THEN
          CALL OPTIONS
          CALL REPPLT(.FALSE.)
          CALL SIMPLT(ILEVEL,.FALSE.)
        ELSEIF ( (ICHOICE.EQ.4) .OR. (ICHOICE.EQ.-F8) ) THEN
          IF ( ZSCALE ) THEN
            CALL ZOOM
          ELSE
            ZSCALE = .TRUE.
          ENDIF
*---show data
          CALL REPPLT(.FALSE.)
*---show fit
          CALL SIMPLT(ILEVEL,.FALSE.)
        ELSEIF ( ICHOICE.EQ.5 ) THEN
*---continue with fit
          GOTO 200
        ELSEIF ( ICHOICE.EQ.6 ) THEN
C Abort fit
          IF ( GETYN('Are you sure you want to ABORT?') ) THEN
            ABORT = ABORTALL
            GOTO 200
          ENDIF
        ENDIF
      ENDIF
      GOTO 100
 
*---Restore Screen State
 200  CALL WNREST
      RETURN
      END
