      SUBROUTINE SCAPLT
*-----------------------------------------------------------------------
*---WEB Research Co.
*---orig: 1991 cs
*--- mru: 960527 tk
*---PION:110620 replace gcoln(icol)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'plotcom.inc'
 
 
      REAL VFREE(MMONTE,MVAR),HIST(MBINS,MVAR),REDXI2
      REAL VUB(MVAR),VLB(MVAR)
      REAL PLTSID,X1,X2,Y1,Y2
      INTEGER NFREE,NMONTE,ISTAT,I,ICOUNT,J,IROW,ICOL,ICHR
      CHARACTER*10 VNAME(MVAR),CDUMMY
 
      INTEGER LENACT
      EXTERNAL LENACT
*-----------------------------------------------------------------------
 
      CALL CLSCRN
 
*---Read monte carlo file
      OPEN (JDISK,FILE=MONTE,IOSTAT=ISTAT,STATUS='old')
      IF ( ISTAT.NE.0 ) THEN
        CALL ERRMSG('Unable to open file '//MONTE(1:LENACT(MONTE)))
        GOTO 800
      ENDIF
 
      READ (JDISK,*,ERR=900) NMONTE,NFREE
      READ (JDISK,*,ERR=900)
      READ (JDISK,9003,ERR=900) CDUMMY,(VNAME(I),I=1,NFREE)
      ICOUNT = 0
      DO 100 I = 1,NMONTE
        READ (JDISK,9002,ERR=900,END=200) REDXI2,(VFREE(I,J),J=1,NFREE)
        ICOUNT = ICOUNT + 1
 100  CONTINUE
 200  NMONTE = ICOUNT
      CLOSE (JDISK)
 
*---Center variable names
      DO 300 I = 1,NFREE
        CALL JUSTIF(VNAME(I),'C')
 300  CONTINUE
 
*---Scan Monte Carlo results and generate probability histograms
      CALL MAKHST(MMONTE,MVAR,VFREE,NMONTE,NFREE,MBINS,HIST,VLB,VUB)
 
      IROW = NFREE
      ICOL = 1
 
*---Fill the screen with plots
 400  CALL NORMAL
      CALL GAREA(0.,0.,1.,1.-1.2/ISCROW)
      CALL GUNIT(0.,0.,1.,1.)
      CALL GCHSIZ(0.7,0.7)
      CALL GCLEAR
      PLTSID = 1./NFREE
      DO 500 I = 1,NFREE
        DO 450 J = 1,NFREE
          CALL PGAREA((I-1)*PLTSID,(J-1)*PLTSID,I*PLTSID,J*PLTSID)
          IF ( I.LT.J ) THEN
            CALL ARMM1(VFREE(1,I),NMONTE,X1,X2)
            CALL ARMM1(VFREE(1,J),NMONTE,Y1,Y2)
            CALL PGUNIT(X1,Y1,X2,Y2)
            CALL PGRAPH(1,NMONTE,' ',' ','S')
            CALL PGBORD
            CALL PGSTYL(1,1,0,0,0,NRMCOL)
            CALL PGSCAT(VFREE(1,I),VFREE(1,J))
          ELSEIF ( I.EQ.J ) THEN
            CALL ARMM1(HIST(1,I),MBINS,Y1,Y2)
            Y2 = Y2*1.1
            CALL PGUNIT(1.0,Y1,FLOAT(MBINS),Y2)
            CALL PGRAPH(1,MBINS,' ','A','H')
            CALL PGBORD
            CALL PGSTYL(1,-4,1,1,NRMCOL,0)
            CALL PGHIST(HIST(1,I))
          ENDIF
 450    CONTINUE
 500  CONTINUE
 
 600  call igrcolourn(RESCOL)
c     CALL GCOLN(RESCOL)
      CALL GFILL(0,1,1)
      CALL GRECTA((ICOL-1)*PLTSID,(IROW-1)*PLTSID,ICOL*PLTSID,
     &            IROW*PLTSID)
      CALL NORMAL
      CALL OUTSXY(70,28,VNAME(IROW))
      CALL OUTSXY(73,29,'vs')
      CALL OUTSXY(70,30,VNAME(ICOL))
      CALL GNORMC()
 
      CALL INKEY(ICHR)
 700  IF ( ICHR.EQ.LTARR ) THEN
        CALL GRECTA((ICOL-1)*PLTSID,(IROW-1)*PLTSID,ICOL*PLTSID,
     &              IROW*PLTSID)
        ICOL = MAX(1,ICOL-1)
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        CALL GRECTA((ICOL-1)*PLTSID,(IROW-1)*PLTSID,ICOL*PLTSID,
     &              IROW*PLTSID)
        ICOL = MIN(IROW,ICOL+1)
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        CALL GRECTA((ICOL-1)*PLTSID,(IROW-1)*PLTSID,ICOL*PLTSID,
     &              IROW*PLTSID)
        IROW = MIN(NFREE,IROW+1)
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        CALL GRECTA((ICOL-1)*PLTSID,(IROW-1)*PLTSID,ICOL*PLTSID,
     &              IROW*PLTSID)
        IROW = MAX(ICOL,IROW-1)

c	PION Refresh SCRN
	ELSEIF ( ICHR.EQ.ALTR ) THEN
        call clrall
		GOTO 400
c
      ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.CTRLP) ) THEN
        CALL GCLEAR
        IF ( ICHR.EQ.CTRLP .and. .not. zcrip) CALL INTPRN
        IF ( IROW.NE.ICOL ) THEN
          CALL PGAREA(.1,.07,.97,.95)
          CALL ARMM1(VFREE(1,ICOL),NMONTE,X1,X2)
          CALL ARMM1(VFREE(1,IROW),NMONTE,Y1,Y2)
          CALL PGUNIT(X1-0.05*(X2-X1),Y1-.05*(Y2-Y1),X2+0.05*(X2-X1),
     &                Y2+.05*(Y2-Y1))
          CALL PGRAPH(1,NMONTE,' ',' ','S')
          CALL PGBORD
          CALL PGXSCL('NTI')
          CALL PGYSCL('NTI')
          CALL PGXLBL(VNAME(ICOL),'C')
          CALL PGYLBL(VNAME(IROW),'CV')
          CALL PGSTYL(1,6,3,0,0,NRMCOL)
          CALL GCHSIZ(0.3,0.3)
          CALL PGSCAT(VFREE(1,ICOL),VFREE(1,IROW))
          CALL PGRAPH(1,1,' ',' ','S')
          CALL PGSTYL(1,9,3,0,0,16)
          CALL PGSCAT(VFREE(1,ICOL),VFREE(1,IROW))
          CALL GCHSIZ(0.7,0.7)
        ELSE
          CALL PGAREA(.1,.07,.97,.95)
          CALL ARMM1(VFREE(1,ICOL),NMONTE,X1,X2)
          CALL ARMM1(HIST(1,IROW),MBINS,Y1,Y2)
          CALL PGUNIT(X1-0.05*(X2-X1),0.,X2+0.05*(X2-X1),1.05*Y2)
          CALL PGRAPH(1,MBINS,' ','A','H')
          CALL PGBORD
          CALL PGXSCL('NT')
          CALL PGSTYL(1,4,1,1,32,0)
          CALL PGHIST(HIST(1,IROW))
          CALL GCHSIZ(1.0,1.0)
          CALL PGTITL(VNAME(IROW),'C')
          CALL GCHSIZ(0.7,0.7)
        ENDIF
        IF ( ICHR.EQ.CTRLP ) THEN
          CALL CLSPRN
        ELSE
          CALL INKEY(ICHR)
          IF ( ICHR.EQ.CTRLP ) GOTO 700
        ENDIF
        GOTO 400
      ENDIF
      IF ( ICHR.NE.ESC ) GOTO 600
 
 800  CALL CLRALL
      CALL SHOACT(.FALSE.)
      CALL SHOLST
      RETURN
 
 900  CALL ERRMSG('Error reading monte-carlo file '//MONTE
     &            (1:LENACT(MONTE)))
      GOTO 800
 
 9001 FORMAT (2X,2(I3,2X))
 9002 FORMAT (1X,20(E12.5,1X))
 9003 FORMAT (2X,21(A10,3X))
      END
