*-----------------------------------------------------------------------
      subroutine selcal(fp, v0, dv, rlpos, ierr)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
      integer ierr
      real fp, v0, dv, rlpos(12)
*-----------------------------------------------------------------------
      include 'constcom.inc'
      include 'iocom.inc'

      integer mline
      parameter (mline=50)

      integer nlines, i, j, maxsho, ichoice
      real v0list(mline), fplist(mline), stlist(mline)
      real rlpos2(12,mline)
      character*44 calmnu(mline)
      character*2 scale
      character*6 datstr
      character*12 spcfil
      character*6 v0str, fpstr
      character*7 stpstr

      integer mnscrl, infoin
      external mnscrl, infoin
*-----------------------------------------------------------------------

      open (jdisk,file=pgmdir(1:pgmlen)//'cal.log', status='old',
     &   iostat=ierr)

      if (ierr.eq.0) then
         nlines = 0
         do 100 j = 1, mline
            read (jdisk,9900,iostat=ierr,err=1000,end=200) datstr, 
     &         spcfil, scale, v0list(nlines+1), stlist(nlines+1),
     &         fplist(nlines+1)
            read (jdisk,9910,iostat=ierr,err=1000) 
     &         (rlpos2(i,nlines+1),i=1,6)
            read (jdisk,9910,iostat=ierr,err=1000)
     &         (rlpos2(i,nlines+1),i=7,12)

            nlines = nlines + 1

            call reastr(v0list(nlines), v0str, '(F6.2)')
            call reastr(stlist(nlines), stpstr, '(F7.5)')
            call reastr(fplist(nlines), fpstr, '(F6.2)')
            
            calmnu(nlines) = datstr//' '//scale//' '//spcfil//
     &         ' '//v0str//' '//stpstr//' '//fpstr
  100    continue

  200    maxsho = min(16, nlines)
         ichoice = mnscrl(calmnu, nlines, 0, 0, ' ', maxsho, 1, nlines)
         if (infoin(55).eq.21) then
            v0 = v0list(ichoice)
            dv = stlist(ichoice)
            fp = fplist(ichoice)
            do 300 i = 1, 12
               rlpos(i) = rlpos2(i,ichoice)
  300       continue
            ierr = 0
         else
            ierr = -999
         endif

 1000    close(jdisk)
      endif

      return

 9900 format (A6,1X,A12,1X,A2,1X,F6.2,1X,F7.5,1X,F6.2)
 9910 format (5X,6(F8.3,1X))

      end
