      INTEGER FUNCTION SUBMNU(IX,IY,OPTNAM,NOPT,ISTOPT,MNUNAM)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  1991 cs
*---mru :  930212 tk
*---Purpose: Display submenu and get user response.
*-----------------------------------------------------------------------
*     Similar to Interacter MNVERT function
*     ix,iy  : Position of the upper left-hand corner
*     optnam : array of menu items to pick from
*     nopt   : the number of menu items
*     istopt : initial highlighted option
*-----------------------------------------------------------------------
*---mru 16May93 CS
*-----------------------------------------------------------------------
      INTEGER IX,IY,NOPT,ISTOPT
      CHARACTER*(*) MNUNAM
      CHARACTER*(*) OPTNAM(NOPT)
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
 
      CHARACTER*1 HOTKEY(20)
      INTEGER ADDROW,I,ICHOICE,ICHR
      INTEGER ULX,ULY,IHKPOS,MLEN,LENGTH
      REAL XJOT,YJOT
 
      INTEGER LENACT
      EXTERNAL LENACT
*-----------------------------------------------------------------------
 
      IF ( MNUNAM.EQ.' ' ) THEN
        ADDROW = 0
      ELSE
        ADDROW = 1
      ENDIF
 
      CALL NORMAL
      ULX = IX - 1
      ULY = IY - 1
 
      MLEN = 0
      DO 100 I = 1,NOPT
        IF ( INDEX(OPTNAM(I),'~').EQ.0 ) THEN
          MLEN = MAX(MLEN,LENACT(OPTNAM(I)))
        ELSE
          MLEN = MAX(MLEN,LENACT(OPTNAM(I))-1)
        ENDIF
 100  CONTINUE
 
      CALL WNSAVE(ULX,ULY,MLEN+4,NOPT+2+ADDROW)
 
*---Scan menu options for first character hotkeys.
      DO 200 I = 1,NOPT
        IHKPOS = INDEX(OPTNAM(I),'~') + 1
        IF ( IHKPOS.EQ.0 ) IHKPOS = 1
        HOTKEY(2*I-1) = OPTNAM(I)(IHKPOS:IHKPOS)
        HOTKEY(2*I) = OPTNAM(I)(IHKPOS:IHKPOS)
        IF ( HOTKEY(2*I).NE.' ' ) THEN
          CALL LOWERC(HOTKEY(2*I-1))
          CALL UPPERC(HOTKEY(2*I))
        ELSE
          HOTKEY(2*I-1) = CHAR(0)
          HOTKEY(2*I) = CHAR(0)
        ENDIF
 200  CONTINUE
 
      ICHOICE = ISTOPT
 
*---Display border if in IBM MSDOS
c      xjot = (3.5/iscx)*ix
c      yjot = (2.0/iscy)*iy
      XJOT = (40./ISCX)
      YJOT = (4.0/ISCY)
      IF ( .NOT.UNIX .AND. ZGRAPH ) THEN
        CALL GAREA(0.,0.,1.,1.)
        CALL GUNIT(1.,1.,ISCCOL+1.0,ISCROW+1.0)
        CALL GFILL(0,1,1)
        CALL GNORMC()
 
        CALL GRECTA(FLOAT(IX)-XJOT,ISCROW+2+6*YJOT-IY,FLOAT(IX+MLEN)
     &              +2+XJOT,ISCROW+2-YJOT/2-IY-NOPT-ADDROW)
        CALL GAREA(PA1,QA1,PA2,QA2)
        CALL GUNIT(XA1,YA1,XA2,YA2)
      ENDIF
 
*---display menu name (if any)
      IF ( ADDROW.GT.0 ) THEN
        CALL BRIGHT
        CALL OUTSXY(ULX+1,ULY+1,' ')
        CALL OUTSTR(MNUNAM)
        CALL OUTSTR(' ')
        IF ( .NOT.UNIX ) CALL GRECTA(FLOAT(IX)-.01,32.02-IY,
     &                               FLOAT(IX+MLEN)+2.01,32.01-IY-1)
      ENDIF
 
*---Wrap options around
 300  IF ( ICHOICE.LT.1 ) THEN
        ICHOICE = NOPT
      ELSEIF ( ICHOICE.GT.NOPT ) THEN
        ICHOICE = 1
      ENDIF
 
*---Display menu options
      CALL NORMAL
      DO 400 I = 1,NOPT
        IHKPOS = INDEX(OPTNAM(I),'~')
        LENGTH = LENACT(OPTNAM(I))
        IF ( I.NE.ICHOICE ) THEN
          CALL OUTSXY(ULX+1,ULY+I+ADDROW,' ')
          CALL NORMAL
          IF ( IHKPOS.GT.1 ) CALL OUTSTR(OPTNAM(I)(1:IHKPOS-1))
          CALL EMPHSZ
          IF ( LENGTH.NE.0 ) CALL ATTRIB('U')
          CALL OUTSTR(OPTNAM(I)(IHKPOS+1:IHKPOS+1))
          CALL NORMAL
          CALL OUTSTR(OPTNAM(I)(IHKPOS+2:MLEN))
          IF ( IHKPOS.NE.0 ) THEN
            IF ( LENGTH.LT.MLEN+1 ) THEN
              CALL OUTSTR(' ')
            ELSE
              CALL OUTSTR(OPTNAM(I)(MLEN+1:MLEN+1))
            ENDIF
          ENDIF
          CALL OUTSTR(' ')
        ELSE
          CALL INVERT
          CALL OUTSXY(ULX+1,ULY+I+ADDROW,' ')
          IF ( IHKPOS.EQ.0 ) THEN
            CALL OUTSTR(OPTNAM(I)(1:MLEN))
          ELSEIF ( IHKPOS.EQ.1 ) THEN
            CALL OUTSTR(OPTNAM(I)(2:MLEN))
          ELSE
            CALL OUTSTR(OPTNAM(I)(1:IHKPOS-1))
            CALL OUTSTR(OPTNAM(I)(IHKPOS+1:MLEN))
          ENDIF
          IF ( IHKPOS.NE.0 ) THEN
            IF ( LENGTH.LT.MLEN+1 ) THEN
              CALL OUTSTR(' ')
            ELSE
              CALL OUTSTR(OPTNAM(I)(MLEN+1:MLEN+1))
            ENDIF
          ENDIF
          CALL OUTSTR(' ')
          CALL NORMAL
        ENDIF
 400  CONTINUE
 
*---Get keystroke from user
 500  CALL INKEY(ICHR)
      DO 600 I = 1,NOPT*2
        IF ( ICHAR(HOTKEY(I)).EQ.ICHR ) THEN
          SUBMNU = (I+1)/2
          GOTO 700
        ENDIF
 600  CONTINUE
 
      IF ( ICHR.EQ.DNARR ) THEN
        ICHOICE = ICHOICE + 1
        GOTO 300
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        ICHOICE = ICHOICE - 1
        GOTO 300
      ELSEIF ( ICHR.EQ.ESC ) THEN
        SUBMNU = 0
      ELSEIF ( ICHR.EQ.ENTER ) THEN
        SUBMNU = ICHOICE
      ELSEIF ( (ICHR.GE.ICHAR('A')) .AND. (ICHR.LE.ICHAR('Z')) ) THEN
        GOTO 500
      ELSEIF ( (ICHR.GE.ICHAR('a')) .AND. (ICHR.LE.ICHAR('z')) ) THEN
        GOTO 500
      ELSE
        SUBMNU = -ICHR
      ENDIF
 
 700  CALL WNREST
      RETURN
      END
