*-----------------------------------------------------------------------
      SUBROUTINE SWPLOC(SITE1,SITE2)
*-----------------------------------------------------------------------
      INTEGER SITE1,SITE2
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    03Oct93 cs
*
*     site1  : Number of source site;
*     site2  : Number of destination site.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
 
      INTEGER I,J
      CHARACTER*2 SUBNUM
 
      INTEGER TILP(MILPAR),TKONL(MLPAR),TKONLN(MLLPAR)
      CHARACTER*10 TILPNAM(MILPAR),TPLNAM(MLPAR),TPLNNAM(MLLPAR)
      REAL TPL0(MLPAR),TPLLB(MLPAR),TPLUB(MLPAR),TWEIL(MLPAR)
      REAL TPLN0(MLLPAR),TPLNLB(MLLPAR),TPLNUB(MLLPAR),TWEILN(MLLPAR)
*-----------------------------------------------------------------------
      INTEGER IJ2KON,KON2I,KON2J
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
*---Swap local integer parameters
      DO 100 I = 1,MILPAR
        TILP(I) = ILP(I,SITE2)
        TILPNAM(I) = ILPNAM(I,SITE2)
 100  CONTINUE
      DO 200 I = 1,MILPAR
        ILP(I,SITE2) = ILP(I,SITE1)
        ILPNAM(I,SITE2) = ILPNAM(I,SITE1)
 200  CONTINUE
      DO 300 I = 1,MILPAR
        ILP(I,SITE1) = TILP(I)
        ILPNAM(I,SITE1) = TILPNAM(I)
 300  CONTINUE
 
*---Swap local linear parameters
      WRITE (SUBNUM,'(I2)') SITE2
      DO 400 I = 1,MLLPAR
        TPLN0(I) = PLN0(I,SITE1)
        TPLNLB(I) = PLNLB(I,SITE1)
        TPLNUB(I) = PLNUB(I,SITE1)
        TWEILN(I) = WEILN(I,SITE1)
        TKONLN(I) = KONLN(I,SITE1)
        TPLNNAM(I) = 'Arfrac '//SUBNUM
 400  CONTINUE
      WRITE (SUBNUM,'(I2)') SITE1
      DO 500 I = 1,MLLPAR
        PLN0(I,SITE1) = PLN0(I,SITE2)
        PLNLB(I,SITE1) = PLNLB(I,SITE2)
        PLNUB(I,SITE1) = PLNUB(I,SITE2)
        WEILN(I,SITE1) = WEILN(I,SITE2)
        KONLN(I,SITE1) = KONLN(I,SITE2)
        PLNNAM(I,SITE1) = 'Arfrac '//SUBNUM
 500  CONTINUE
      DO 600 I = 1,MLLPAR
        PLN0(I,SITE2) = TPLN0(I)
        PLNLB(I,SITE2) = TPLNLB(I)
        PLNUB(I,SITE2) = TPLNUB(I)
        WEILN(I,SITE2) = TWEILN(I)
        KONLN(I,SITE2) = TKONLN(I)
        PLNNAM(I,SITE2) = TPLNNAM(I)
 600  CONTINUE
 
*---Fix linear constraints
      DO 700 J = 1,NSUBS
        DO 650 I = 1,ILP(3,J)
          IF ( KON2J(KONLN(I,J)).EQ.SITE1 ) THEN
            KONLN(I,J) = IJ2KON(KON2I(KONLN(I,J)),SITE2)
          ELSEIF ( KON2J(KONLN(I,J)).EQ.SITE2 ) THEN
            KONLN(I,J) = IJ2KON(KON2I(KONLN(I,J)),SITE1)
          ENDIF
 650    CONTINUE
 700  CONTINUE
 
*---Swap local nonlinear parameters
      DO 800 J = 1,MLPAR
        TPLNAM(J) = PLNAM(J,SITE2)
        TPL0(J) = PL0(J,SITE2)
        TKONL(J) = KONL(J,SITE2)
        TWEIL(J) = WEIL(J,SITE2)
        TPLLB(J) = PLLB(J,SITE2)
        TPLUB(J) = PLUB(J,SITE2)
 800  CONTINUE
      DO 900 J = 1,MLPAR
        PLNAM(J,SITE2) = PLNAM(J,SITE1)
        PL0(J,SITE2) = PL0(J,SITE1)
        KONL(J,SITE2) = KONL(J,SITE1)
        WEIL(J,SITE2) = WEIL(J,SITE1)
        PLLB(J,SITE2) = PLLB(J,SITE1)
        PLUB(J,SITE2) = PLUB(J,SITE1)
 900  CONTINUE
      DO 1000 J = 1,MLPAR
        PLNAM(J,SITE1) = TPLNAM(J)
        PL0(J,SITE1) = TPL0(J)
        KONL(J,SITE1) = TKONL(J)
        WEIL(J,SITE1) = TWEIL(J)
        PLLB(J,SITE1) = TPLLB(J)
        PLUB(J,SITE1) = TPLUB(J)
 1000 CONTINUE
 
*---Fix linear constraints
      DO 1100 J = 1,NSUBS
        DO 1050 I = 1,ILP(2,J)
          IF ( KON2J(KONL(I,J)).EQ.SITE1 ) THEN
            KONL(I,J) = IJ2KON(KON2I(KONL(I,J)),SITE2)
          ELSEIF ( KON2J(KONL(I,J)).EQ.SITE2 ) THEN
            KONL(I,J) = IJ2KON(KON2I(KONL(I,J)),SITE1)
          ENDIF
 1050   CONTINUE
 1100 CONTINUE
 
      RETURN
      END
