*----------------------------------------------------------------------
      common /toggle/shosub, shores, stosub, shovel, inftyp, ouftyp,
     &	 inhdln, ouhdln, infrmt, oufrmt, scdprt, kxplot, kyplot,
     &   porig, zbar, zsymbl, zthry, ztitl, zxauto, zyauto, ztimdy,
     &	 zfulls, zline, zpoint, zscale, zgraph, zinf, zljcmp,
     &   yflip, fitting, shopth, unix, prntng, nnegar, glrot, mouse,
     &	 idiag, idiag4, imaxwid
*----------------------------------------------------------------------
      logical shosub, shores, stosub, shovel
      integer inftyp, ouftyp
      integer inhdln, ouhdln
      integer infrmt, oufrmt
      integer scdprt
      logical porig
      integer kxplot, kyplot
      integer idiag, idiag4, imaxwid
      logical zbar,zsymbl,zthry,ztitl,zxauto,zyauto,ztimdy,zfulls
      logical zline, zpoint, zscale, zgraph, zinf, zljcmp
      logical yflip, fitting, shopth, unix, prntng, nnegar, glrot,mouse
*----------------------------------------------------------------------
* zbar   : Should plot vertical error bars
* zsymbl : Should plot data symbol
* zthry  : Should plot theory
* ztitl  : Should plot Title above plot
* zxauto : Should auto scale x axis
* zyauto : Should auto scale y axis
* ztimdy : Should plot time/day stamp
* zfulls : Should make plot cover full screen
* kxplot : index of x-scale type. See OPTIONS.FOR
* kyplot : index of y-scale type. See OPTIONS.FOR
* porig  : Should include (0,0) point in line plots ?

* zpoint : Should plot be drawn as single points?
* zline  : Should plot be drawn as a extended line?
* zscale : Autoscale x and y axes?
* zgraph : Make any calls to graphics routines?
* zinf   : Show spectrum info at bottom of screen?

* yflip  : Should the y-axis display increasing values downwards?
* fitting: Is a fit currently being performed?
* shopth : Should the path of spectra in the list be shown?
* unix   : Is this a UNIX system?
* prntng : Is the current graphics going out to the printer?
* nnegar : Should all areas be forced to be nonnegative?
* glrot  : Should HPGL plots be rotated from default?
* mouse  : Should a mouse be used in those routines supporting it?

* shosub : Should REPORT display subspectra during a fit?
* shores : Should REPORT, LSUB, SSUB display the difference spec?
* stosub : Should the best fitted subspectra be put in the list?
* shovel : Should the x-axis be marked w/ velocity? (false=channels)
* inftyp : File format to use when reading spectrum data.
* ouftyp : File format to use when writing spectrum data.
* inhdln : Number of header lines to expect when reading ASCII-N data.
* ouhdln : Number of header lines to expect when writing ASCII-N data.
* infrmt : Free format or F9.0 when reading ASCII-N data.
* oufrmt : Free format or F9.0 when writing ASCII-N data.
* scdprt : What device for screen-dump output? (1=HPGL,2=HP,3=PS,4=epson)
*
* idiag  : Matrix diagonalizer (0:=CH,1:=CHEEV)
* idiag4 : 4x4 Matrix diagonalizer (0:=CH,1:=X4CH,2:=POLY4)
*----------------------------------------------------------------------


*----------------------------------------------------------------------
      common /checks/parlod, datchu, grphon
*----------------------------------------------------------------------
      logical parlod, datchu, grphon
*----------------------------------------------------------------------
* parlod : Has a set of parameters been loaded in?
* datchu : has a data set been chosen for the fit?
* grphon : Has INTGRA been called yet? (i.e., Does ENDGR need to
*	   be called before exiting the program?)
*----------------------------------------------------------------------

*----------------------------------------------------------------------
	common /aborts/ abort, replot
*----------------------------------------------------------------------
	logical replot(4)
	integer abort
	
	integer AbortOff, AbortEndOpt, AbortFit, AbortAll, AbortFatal
        parameter (AbortOff = 0, AbortEndOpt = 1)
	parameter (AbortFit = 2, AbortAll = 3)
	parameter (AbortFatal = 4)

*----------------------------------------------------------------------
* abort  : is the current fit being aborted?
*        :    0 => No;
*        :    1 => Optimization has finished nonfatally on some level;
*        :    2 => Abort current fit, but continue annealling;
*        :    3 => Abort entire fit (save best so far);
*        :    4 => Abort entire fit (don't save anything about fit).
* replot : should the next call to replot redraw the spectrum
*----------------------------------------------------------------------
