*-----------------------------------------------------------------------
      subroutine ulolc3(isub)
*-----------------------------------------------------------------------
      integer isub
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    mru 28Jul93 cs
*
*     Calculates the subspectra for the quadrupole pair model, using
*     the parameters in the PLBEST array.
*
*     isub  : Subsite to calculate.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'constcom.inc'
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest

      real centrd, split, fwhml, fwhmr, czero, step, fwcal
      real lrntzr(LSPEC)
      integer i, npts, ispec

      real vel2ch
      external vel2ch
*-----------------------------------------------------------------------
 
      do 100 ispec = 1, nspec
         czero = cal(6,ispec)
         step = cal(7,ispec)
         npts = ical(1,ispec)
 
         centrd = vel2ch(plbest(1,isub), czero, step)
         split  = plbest(2,isub) / step
         fwhml  = plbest(3,isub) / step
         fwhmr  = plbest(4,isub) / step
         fwcal  = fwhml0         / step

c        ;; Calculate two separate lines, each of area 1/2.
         call lnorm(npts, locspc(1,ispec,isub), centrd-(split/2.),
     &      fwhml, fwcal, 0.0, 0.5)
         call lnorm(npts, lrntzr, centrd+(split/2.), fwhmr, fwcal, 0.0,
     &      0.5)

c        ;; Sum the two lines to create the pair.
         do 50 i = 1, npts
            locspc(i,ispec,isub) = locspc(i,ispec,isub) + lrntzr(i)
   50    continue
  100 continue
 
      return
      end
