      SUBROUTINE ULOLC5(isub)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 930619 tk
*---mru : 931101 tk
*---Purpose: Heff || z  +  efg
*-----------------------------------------------------------------------
*---parameters and common blocks
      INCLUDE 'limits.inc'
      INCLUDE 'constcom.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'opcom.inc'
      INCLUDE 'expcom.inc'
      INCLUDE 'gridcom.inc'
      REAL PLBEST(MLPAR,MLOC)
      COMMON /RLBEST/ PLBEST
 
*---internal storage
      REAL HINT,FWHM,SHIFT,DEQ,ETA,AL,BE,GA
      REAL TV(3,3),R(3,3),V(3,3),A(3,3),V1(3,3),theta,phi,lx,ly,lz
      INTEGER I,J,IG,NCHAN,KPOL,ISPEC,ISUB
 
*-----------------------------------------------------------------------
*---copy direction cosines of Hint to storage for thermal expectation
*---values of electronic spin vector. Set bpop to unity.
          theta = plbest(4,isub)*rpd
          phi   = plbest(5,isub)*rpd
          lx = sin(theta)*cos(phi)
          ly = sin(theta)*sin(phi)
          lz = cos(theta)
      DO 100 ISPEC = 1,NSPEC
        DO 50 IG = 1,NGRID
          ES1XT(IG,ISPEC) = -lx
          ES1YT(IG,ISPEC) = -ly
          ES1ZT(IG,ISPEC) = -lz
          BPOP(1,IG,ISPEC) = 1.0
 50     CONTINUE
 100  CONTINUE
 
 
*---Set up Nuclear Hamiltonian.
*---Linewidth
        FWHM = PLBEST(1,isub)
*---shift
        SHIFT = PLBEST(2,isub)
*---magnitude of internal field
        HINT = PLBEST(3,isub)
*---efg tensor
        DEQ = PLBEST(6,isub)
        ETA = PLBEST(7,isub)
        AL = plbest(8,isub)*rpd
        BE = PLBEST(9,isub)*RPD
        GA = PLBEST(10,isub)*RPD
        CALL E2MZIM(AL,BE,GA,R)
        CALL MIDENT3(TV)
        TV(3,3) = DEQ/SQRT(1.0+ETA*ETA/3.0)
        TV(1,1) = 0.5*TV(3,3)*(ETA-1.0)
        TV(2,2) = -TV(1,1) - TV(3,3)
        CALL STRNF3(R,TV,V)
*---patch: store efg of site #1 for Postscript plots
        IF ( ISUB.EQ.1 ) THEN
          DO 280 I = 1,3
            DO 260 J = 1,I
              V1(I,J) = V(I,J)
 260        CONTINUE
 280      CONTINUE
        ENDIF
*---fake magnetic hyperfine tensor
        CALL MIDENT3(A)
        A(1,1) = Hint
        A(2,2) = Hint
        A(3,3) = Hint
 
 
C NOW CALCULATE SPECTRUM FOR THIS SITE FOR EACH applied FIELD AND TEMPERATURE
C POINT
        DO 300 ISPEC = 1,NSPEC
          NCHAN = ICAL(1,ISPEC)
          KPOL = ICAL(3,ISPEC)
*---fast: calc. 1 spectrum using thermal averages of spin expectation values
          CALL SMGRID(1,1,ES1XT(1,ISPEC),ES1YT(1,ISPEC),ES1ZT(1,ISPEC),
     &                BPOP(1,1,ISPEC),A,V,SHIFT,FWHM,KPOL,LSPEC,NCHAN,
     &                CAL(1,ISPEC),LOCSPC(1,ISPEC,ISUB))
 300    CONTINUE
 
 
      RETURN
      END
