      SUBROUTINE WRITSP(NAME,ISLOT,IERR)
*----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1991 tk
*---mru : 931121 tk; 980102 tk
*
*     Writes a data file from the specified slot in the list
*
*     name   : filename to write;
*     islot  : place in list to take the spectrum from.
*
*     Output format specified by ouftyp (see togcom.inc)
*----------------------------------------------------------------------
*---externals
      INCLUDE 'limits.inc'
      INCLUDE 'iocom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
 
      CHARACTER*(*) NAME
      INTEGER ISLOT,IERR
*---internals
      INTEGER npts, I, nwrit
      character*(MFLLEN) name1(1)
 
C Salford routine
c      EXTERNAL FORTRAN_ERROR_MESSAGE@
c      CHARACTER*72 MSG
c      INTEGER*2 IERR2
*--------------------------------------------------------------------
*---executables
      ierr=0
      name1(1) = name
      npts = icalsp(1,islot)
 
C WRITE SPECTRUM TO DISK
      IF ( OUFTYP.EQ.1 ) THEN
C BINARY
       if(spccmt(6,islot)(:4).eq.'pack')then
           CALL BINIO(NAME1, JDISK, 1, 1, SPCCMT(1,ISLOT), 
     &         ICALSP(1,islot),
     &         SPCCAL(1,islot), spctra(1,islot), NWRIT, IERR)
        else
           CALL BINIO(NAME1, JDISK, 1, 1, SPCCMT(1,ISLOT), 
     &         ICALSP(1,islot),
     &         SPCCAL(1,islot), spctra(1,islot), NWRIT, IERR)
        endif
      ELSEIF ( OUFTYP.EQ.2 ) THEN
C WEB ASCII 10 line header, y only raw counts
         CALL ASCow(NAME, 1, npts, xspc, spctra(1,islot), 
     &      6, SPCCMT(1,ISLOT), 10, icalsp(1,islot), 
     &      10, spccal(1,islot), IERR)

      ELSEIF ( OUFTYP.EQ.3 ) THEN
C ASCII- 10 line header , Y only, raw counts
         CALL ASCoc(NAME, 1, npts, xspc, spctra(1,islot), 
     &      6, SPCCMT(1,ISLOT), 10, icalsp(1,islot), 
     &      10, spccal(1,islot), IERR)

      ELSEIF ( OUFTYP.EQ.4 ) THEN
C ASCII - 10 line header, [channels, counts]
         CALL ASCocc(NAME, 1, npts, xspc, spctra(1,islot), 
     &      6, SPCCMT(1,ISLOT), 10, icalsp(1,islot), 
     &      10, spccal(1,islot), IERR)

      ELSEIF ( OUFTYP.EQ.5 ) THEN
C ASCII - 10 line header, [velocity, % absorption]
         CALL ASCovp(NAME, 1, npts, xspc, spctra(1,islot), 
     &      6, SPCCMT(1,ISLOT), 10, icalsp(1,islot), 
     &      10, spccal(1,islot), IERR)

      else
        call errmsg('Bad value for Data Save Format switch.'  )
        ierr = 1
      ENDIF
 
 
      RETURN
      END
