*-----------------------------------------------------------------------
      real function xtoxs(xval, rcal)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
      include 'limits.inc'
      real xval, rcal(mcal)
*-----------------------------------------------------------------------
      include 'togcom.inc'
      real v0, step
*-----------------------------------------------------------------------

      v0   = rcal(6)
      step = rcal(7)

      if (kxplot.eq.1) THEN
         xtoxs = (xval/step) + v0
      else
         xtoxs = xval
      endif

      return
      end

*-----------------------------------------------------------------------
      real function xstox(xsval, rcal)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
      include 'limits.inc'
      real xsval, rcal(mcal)
*-----------------------------------------------------------------------
      include 'togcom.inc'
      real v0, step
*-----------------------------------------------------------------------

      v0   = rcal(6)
      step = rcal(7)

      IF (kxplot.eq.1) THEN
         xstox = (xsval-v0)*step
      else
         xstox = xsval
      endif

      return
      end

*-----------------------------------------------------------------------
      real function ytoys(yval, rcal)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
      include 'limits.inc'
      real yval, rcal(mcal)
*-----------------------------------------------------------------------
      real area, bl
*-----------------------------------------------------------------------

      bl   = rcal(3)
      area = rcal(4)

      if (bl.ne.0) then
         ytoys = -100.0*yval*area/bl
      else
         ytoys = -yval
      endif

      return
      end

*-----------------------------------------------------------------------
      real function ystoy(yval,rcal)
*-----------------------------------------------------------------------
      include 'limits.inc'
      real yval, rcal(mcal)
*-----------------------------------------------------------------------
      real area, bl
*-----------------------------------------------------------------------

      bl   = rcal(3)
      area = rcal(4)

      if (area.ne.0) then
         ystoy = -0.01*yval*bl/area
      else
         ystoy = -yval
      endif

      return
      end
