*-----------------------------------------------------------------------
      SUBROUTINE ZOOM
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     orig: 1992 cs,
*     mru 01Aug93 cs, 960913 tk; 971209 tk
*
*     Allows the user to pick a subset of the spectrum to display
*     using the mouse or the keyboard.
*
*     CURRENTLY DOES NOT WORK IN A SUPER-VGA VIDEO MODE!
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
 
      INTEGER NTOP,NPTS, itype
      REAL XPOS,YPOS,WIDTH,HEIGHT
      REAL XS(LSPEC),YS(LSPEC),YSNOI(LSPEC),TOPLST(2,MTOP)
      LOGICAL MARKS(LSPEC)
 
      INTEGER INFOIN
      EXTERNAL INFOIN
*----------------------------------------------------------------------
*---patch 19980326 tk: insist data be on list
      if(actspc.le.0)then
        call errmsg('Before ZOOM, please load data to List.')
        return
      endif
*---end patch

*19980326 tk: Why does ZOOM need to know ACTSPC, etc. ?

      NPTS = ICALSP(1,ACTSPC)
      itype = icalsp(10,actspc)
      CALL SCLDAT(itype, NPTS,XSPC(1,ACTSPC),SPCTRA(1,ACTSPC),
     &            SPCNOI(1,ACTSPC),
     &            SPCMSK(1,ACTSPC),SPCCAL(1,ACTSPC),KXPLOT,KYPLOT,XS,YS,
     &            YSNOI,MARKS,NTOP,TOPLST)
 
      IF ( ZSCALE ) THEN
*        IF ( ZYAUTO ) THEN
          YPOS = YS(1)
*        ELSE
*          YPOS = CLPBOT1
*        ENDIF
*        IF ( ZXAUTO ) THEN
          XPOS = XS(1)
*        ELSE
*          XPOS = CLPLT1
*        ENDIF
      ELSE
        YPOS = CLPTOP
        XPOS = CLPLT
      ENDIF
 
      WIDTH = 0.
      HEIGHT = 0.
 
      CALL GINBOX(XPOS,YPOS,WIDTH,HEIGHT,3)
      IF ( INFOIN(55).EQ.21 ) THEN
        CLPLT = MAX(MIN(XS(1),XS(NPTS)),MIN(XPOS,XPOS+WIDTH))
        CLPRT = MIN(MAX(XS(1),XS(NPTS)),MAX(XPOS,XPOS+WIDTH))
 
        IF ( YFLIP ) THEN
          CLPTOP = -MIN(YPOS,YPOS+HEIGHT)
          CLPBOT = -MAX(YPOS,YPOS+HEIGHT)
        ELSE
          CLPTOP = MAX(YPOS,YPOS+HEIGHT)
          CLPBOT = MIN(YPOS,YPOS+HEIGHT)
        ENDIF
 
        ZSCALE = .FALSE.
      ENDIF
 
      RETURN
      END
