*-----------------------------------------------------------------------
      SUBROUTINE ARROW(XDAT,YDAT,DATNOI)
*-----------------------------------------------------------------------
*--- PION 110620: replace gcoln()
*-----------------------------------------------------------------------
*     Draws an arrow pointing to a specific channel in the data.
*     xdat   : x coordinate of datum
*     ydat   : y coordinate of datum
*     datnoi : noise value of datum
*-----------------------------------------------------------------------
      INCLUDE 'plotcom.inc'
      INCLUDE 'togcom.inc'
*-----------------------------------------------------------------------
      REAL XDAT,YDAT,DATNOI
*-----------------------------------------------------------------------
      REAL ALEN,AWID,YSTART
*-----------------------------------------------------------------------
 
*---define window and units (see common /pbox/)
      CALL GAREA(PA1,QA1,PA2,QA2)
      CALL GUNIT(XA1,YA1,XA2,YA2)
 
      IF ( YFLIP ) THEN
        YSTART = -YDAT + 2.0*ABS(DATNOI)
      ELSE
        YSTART = YDAT + 2.0*ABS(DATNOI)
      ENDIF
      ALEN = (YA2-YA1)/8.
      AWID = (XA2-XA1)/100.
 
*---Draw arrow above data point
      CALL GPLOTM('EOR')
	call igrcolourn(THRCOL) 
c      CALL GCOLN(THRCOL)
      CALL GMOVEA(XDAT,YSTART)
      CALL GLINER(0.0,ALEN)
      CALL GMOVER(0.0,-ALEN)
      CALL GLINER(AWID,ALEN/3)
      CALL GMOVER(-2*AWID,0.0)
      CALL GLINER(AWID,-ALEN/3)
      CALL GPLOTM('N')
 
      RETURN
      END
