      SUBROUTINE ASCbhh(FILNAM,SPEC,TEXT,ICAL,RCAL,IERR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 920816 tk
*---mru : 980502 tk
C ----------------------------------------------------------------------
C       READ one SPECTRUM AND ITS HEADER from Munck FOLDED ASCII file.
*
C       File FORMAT IS AS FOLLOWS:
*Description of header:
*Line 1: blank
*Line 2: file name  ,   nchan,    nchan  ?
*Line 3: comment
*Line 4 - 35 : data 8F10.0
*------------------------------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL SPEC(lspec),RCAL(MCAL)
      INTEGER ICAL(MCAL),IERR, ierr1
      integer i 
*-------------------------------------------------------
*---executables
*---clear error flag
      ierr = 0

*---clear header info in RAM
*---note:  ical(5) = 0 specified Mossbauer absorption data file.
      do 10 i=1,mcal
         ical(i)=0
         rcal(i)=0.0
   10 continue

         do 40 i=1,mcommt
40         text(i)=' '

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(3)
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(1)
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(2)

C READ IN THE SPECTRUM
      ical(1) = 256
      READ (JDISK,*,IOSTAT=IERR,ERR=300)( SPEC(I),I=1, ICAL(1) )

  300 CLOSE (JDISK, IOSTAT=IERR1)
      if (ierr1.ne.0) ierr = ierr1

      RETURN
      END
