      SUBROUTINE 
     &   ASCIcc(FILNAM,Npts,SPEC,NTX,TEXT,NIC,ICAL,NRC,RCAL,IERR)
C
C       READ a SPECTRUM from free format ASCII file.
*       No header.   ( idum, counts )
*
C       File FORMAT IS AS FOLLOWS:
C     DATA     No. of elements    Total Bytes   Format
c     spec         npts            npts*4        free
C
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---ASCIfr will read free format ascii files, folded or unfolded.
*---orig: 980213 tk
*---mru : 980213 tk
C --------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      real specuf(2*lspec)
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL SPEC(npts),RCAL(MCAL)
      INTEGER I,ICAL(MCAL),IERR
      INTEGER Npts,NTX,NIC,NRC

      REAL NONOYS(2*LSPEC),XPOS(2*LSPEC),NOCAL(MCAL)
      INTEGER INOCAL(MCAL), idum, ierr1
      LOGICAL NOMASK(2*LSPEC)
      CHARACTER NOCMT(6)*72


      integer  nuf,nf
*---external funcions
      logical getyn
      external getyn
*---define no cal values
      save nocal, nocmt
      DATA NOCAL/0.,0.,100.,1.,0.,0.,1.,0.,0.,0./
      DATA NOCMT/6*' '/
*-----------------------------------------------------------
*---executables

*---zero cal info
      do 10 i=1,nic
         ical(i)=0
         inocal(i) =0
   10 continue
      do 12 i=1,nrc
         rcal(i)=0.0
   12 continue
      do 40 i=1,ntx
         text(i)=' '
   40 continue

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE SPECTRUM

          READ (JDISK,*,IOSTAT=IERR,ERR=100) (idum, SPECuf(I),I=1,npts)
100       CLOSE (JDISK, IOSTAT=IERR1)
          if (ierr.ne.0) then
             goto 999
          elseif(ierr1.ne.0)then
             ierr = ierr1
             goto 999
          endif
*---display raw data
          do 150 i=1,npts
             xpos(i)=i
             nonoys(i)=0.0
             nomask(i)=.true.
  150     continue
        inocal(1) = npts
        inocal(5) = 5
       CALL SHODAT(.TRUE.,Npts,XPOS,specuf,NONOYS,INOCAL,NOCAL,NOMASK,
     &   1.0,0,0,FILNAM,NOCMT,.FALSE.)

          nuf=npts
         call message(' ')
         if(getyn('Fold data ?'))then
*----fold spectrum
         CALL FALT(filnam, nuf, specuf, nf, spec, rcal(5), rcal(6),
     &      rcal(7), ierr)
         if (ierr.eq.0) ical(1) = nf
      else
*---do not fold spectrum
         call fixsawth(filnam,specuf,spec,nuf,rcal(5),rcal(6),
     &      rcal(7),ierr)
         if (ierr.eq.0) ical(1) = nuf
      endif
 
 
  999 continue
      RETURN
      END
