      subroutine ascsch(FILNAM,md,SPEC,NTX,TEXT,ICAL,RCAL,IERR)
C
C     1. READ sawtooth SPECTRUM AND ITS HEADER from ASCII file.
*        THIS FORMAT COMPATIBLE WITH FILES created by
*        Martin Schoonen @ SUNY
*     2. Store 512 (number of points) in ICAL(1).
 
C       HEADER IS FOLLOWED BY A REAL ARRAY CONTAINING THE
C       SPECTRAL DATA.  LOWER BOUND SUBSCRIPT OF THE ARRAY
C       IS 1.   UPPER BOUND SUBSCRIPT IS NCHANS=ical(1).
C
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*--- Orig 920921 MRU 920921 TK
C --------------------------------------------------
      include 'limits.inc'
      INCLUDE 'iocom.inc'
*---externals
      integer md 
      CHARACTER FILNAM*(*),TEXT(6)*72
      REAL SPEC(md),RCAL(*)
      INTEGER I,ICAL(*),IERR
      INTEGER NTX
*---internals
      integer ispec(lspec)
      integer nrc,nic
      real dummy, tmpspc(lspec)
      integer iover, nrow, irow, megs
 
C OPEN FILE
      IERR=0
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
*---Initial Comment lines 
      do 45 i=1,6
         text(i)=' '
45    continue
      Text(2)= 'Schoonen, SUNY , Elscint format'
 
C READ & ignore IN THE 16 line HEADER
        DO 50 I = 1,16
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=999) DUMMY
 50     CONTINUE
*---Initialize cal info.
      do 100 i=1,mcal
        ical(i) = 0
        rcal(i) = 0.0
100   continue
 
C READ IN THE SPECTRUM
*---number of channel in spectrum
        ical(1)=512

*---predefined format ascii file
         nrow=ical(1)/8
         DO 140 IROW=0,NROW-1
          READ (JDISK,9001,IOSTAT=IERR) (iSPEC(I+8*IROW),I=1,8)
         if(ierr.ne.0)goto 999
 9001 format(7x,8i9)
  140  continue

        close(jdisk, iostat=ierr)
         if(ierr.ne.0)goto 999
*---copy 2nd channel into 1st channel
      ispec(1) = ispec(2)

*---Convert to floating point storage
         do  300  i  = 1,  ical(1)
             spec(i)=float(ispec(i) )
  300    continue

*---Do nonlinear correction, etc. 
         do 400 i = 1, ical(1)
            tmpspc(i) = spec(i)
  400    continue
         CALL fixsawth(filnam,TMPSPC,SPEC,ical(1),RCAL(5),RCAL(6),
     &      RCAL(7), ierr)
*---set file type (see readsp.for)
         ical(5)=12

  999 continue
      RETURN
 
      END
