*-----------------------------------------------------------------------
      SUBROUTINE CALGA4(K,DVFREE,DCHI2,DUMMYG,NFREE,DUMMYN,IERR,FMAX,
     &                  FNOISE)
*-----------------------------------------------------------------------
      INTEGER K,NFREE,DUMMYN,IERR
      REAL*8 DVFREE(NFREE),DUMMYG(NFREE),DCHI2,FMAX,FNOISE
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     24May94 CS
*
*     Global Area routine for VE08AD optimization.
*
*     k      : [input]  Ignored but should be 1;
*     dvfree : [input]  Values of free variables for this local iter.;
*     dchi2  : [output] Chi-squared at this point;
*     dummyg : [output] Ignored;
*     nfree  : [input]  Number of free variables;
*     dummyn : [input]  Ignored;
*     iflag  : [input]  Ignored but should be 1;
*            : [output] Unchanged unless error or user aborts;
*     fmax   : [input]  Ignored;
*     fnoise : [output] Estimate of round-off error in dchi2;
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'errcodes.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER I
      REAL DUMMYF(MAXPTS),CHI2,VFREE(MLPAR),GRAD(MLPAR)
 
      EXTERNAL CALGA
*-----------------------------------------------------------------------
 
      DO 100 I = 1,NFREE
        VFREE(I) = DVFREE(I)
 100  CONTINUE
 
      CALL CALFUN(CALGA,NFREE,VFREE,VALB,VAUB,0,0,NFRPT,CHI2,GRAD,
     &            DUMMYF,IERR)
 
      IF ( (IERR.NE.NOERROR) .OR. (ABORT.NE.ABORTOFF) ) IERR = ERRABORT
      DCHI2 = CHI2
 
      FNOISE = 1.0D-7*DCHI2
 
      RETURN
      END
