 
*-----------------------------------------------------------------------
      SUBROUTINE CALLC1(VFREE,NFREE,VUB,VLB,CHI2)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     Orig 20May94 CS, mru 23May94 CS
*
*     Local routine for SOPTMZ optimization.
*
*     nfree  : [input]  Number of free variables to optimize over;
*     vfree  : [input]  Values of free variables for this local iter.;
*     vub    : [input]  Upper bounds for variables (currently unused);
*     vlb    : [input]  Lower bounds for variables (currently unused);
*     chi2   : [output] Chi-squared at this point.
*-----------------------------------------------------------------------
      INTEGER NFREE
      REAL VFREE(NFREE),VUB(NFREE),VLB(NFREE),CHI2
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'varcom.inc'
 
      INTEGER IERR
      REAL DUMMYG(MLPAR),DUMMYF(MAXPTS)
 
      EXTERNAL CALLC
*-----------------------------------------------------------------------
 
      CALL CALFUN(CALLC,NFREE,VFREE,VLLB,VLUB,-1,0,NFRPT,CHI2,DUMMYG,
     &            DUMMYF,IERR)
 
      RETURN
      END
