*-----------------------------------------------------------------------
      subroutine chkcal(ispec, ierr, icol, irow)
*-----------------------------------------------------------------------
*     MOSS VERSION
*-----------------------------------------------------------------------
      integer ispec, ierr, icol, irow
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      include 'parcom.inc'
      include 'speccom.inc'

      integer i
*-----------------------------------------------------------------------
         
      ierr = 0

C Check that step > 0 before exiting
      IF ( SPCCAL(7,ISPEC).LE.0. ) THEN
         CALL ERRMSG('Step must be strictly positive!')
         ICOL = 3
         IROW = 7
         IERR = -1
         goto 1000
      endif

C Reset x-coords in case STEP or V=0 CHANNEL have changed
      do 100 i = 1, icalsp(1,ispec)
         xspc(i,ispec) = (i-spccal(6,ispec)) * spccal(7,ispec)
  100 continue

C Recopy to fit table if a picked spectrum had its calibration edited
      if (picked(ispec)) call maktab(0)

 1000 return
      end
