      subroutine cpyloc(site1,site2,zkclr)
*-----------------------------------------------------------------------
      integer site1,site2
      logical zkclr
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1991 cs
*---mru : 931103 tk
*
*     site1  : Number of source site;
*     site2  : Number of destination site.
*     zkclr  : Zero the constraints & weights of the destination site?
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'

      integer i, j
      character*2 subnum

*---Copy local integer parameters
      do 50 i = 1, MILPAR
         ilp(i,site2) = ilp(i,site1)
         ilpnam(i,site2) = ilpnam(i,site1)
   50 continue

*---Copy local linear parameters
      call intstr(site2,subnum,'(i2)')
      do 55 i = 1, MLLPAR
         pln0(i,site2) = pln0(i,site1)
         plnlb(i,site2) = plnlb(i,site1)
         plnub(i,site2) = plnub(i,site1)
         if (zkclr) then
            weiln(i,site2) = 1.0
            konln(i,site2) = 0
         else
            weiln(i,site2) = weiln(i,site1)
            konln(i,site2) = konln(i,site1)
         endif
         plnnam(i,site2) = 'Rel Area'//subnum
   55 continue
 
*---Copy local nonlinear parameters
      do 100 j = 1, MLPAR
         plnam(j,site2) = plnam(j,site1)
         pl0(j,site2) = pl0(j,site1)
         if (zkclr) then
            konl(j,site2) = 0
         else
            konl(j,site2) = konl(j,site1)
         endif
         weil(j,site2) = weil(j,site1)
         pllb(j,site2) = pllb(j,site1)
         plub(j,site2) = plub(j,site1)
  100 continue
 
      return
      end
