*-----------------------------------------------------------------------
      subroutine custom
*-----------------------------------------------------------------------
*--- PION 110620: replace gcoln()
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'speccom.inc'
      include 'scrncom.inc'
      include 'plotcom.inc'
*-----------------------------------------------------------------------
      integer ichr
      real x1, y1, x2, y2, xaxpos, yaxpos, axwid, axht

      real aspect, topmrg, pagewd, pageht
      parameter (aspect = 0.75, topmrg = 1.2)
      parameter(pagewd = 8.5, pageht = 11.0)

      integer infoin
      external infoin
*-----------------------------------------------------------------------

      x1 = 1.0 - aspect * pagewd/pageht * (iscrow-topmrg)/float(iscrow)
      y1 = 2.0 / iscx
      x2 = 1.0 - (2.0 / iscx)
      y2 = (iscrow-topmrg) / float(iscrow) 

      call clscrn
      call garea(0.0,0.0,1.0,1.0)
      call gclear

      call garea(x1, y1, x2, y2)
      call gunit(x1, y1, x2, y2)
	call igrcolourn(NRMCOL)
c      call gcoln(nrmcol)
      call grecta(x1, y1, x2, y2)

      call message('Place axis box')
      xaxpos = x1
      yaxpos = y2
      axwid = 0.0
      axht = 0.0 
      call ginbox(xaxpos, yaxpos, axwid, axht, 3)
      if (infoin(55).eq.21) then
         boxllx = min(xaxpos, xaxpos+axwid)
         boxurx = max(xaxpos, xaxpos+axwid)
         boxury = max(yaxpos, yaxpos+axht)
         boxlly = min(yaxpos, yaxpos+axht)
         
         call shoact(.false.)
      endif

      call inkey(ichr)

      return
      end      