 
*-----------------------------------------------------------------------
      INTEGER FUNCTION EDTBLA()
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 16Jul93 cs
*
*     Editing routine for baselines and global area parameters.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'constcom.inc'
 
      INTEGER TOPPGA,MHEAD,INTMOD,IWID
      PARAMETER (TOPPGA=5,MHEAD=5)
      PARAMETER (IWID=5,INTMOD=7-IWID)
 
      INTEGER IPAR2,ISPEC2
      INTEGER ICOL,IROW,ICHR,IX,IY,I,J,TOPBL,TOPNAM,ILINE
      INTEGER BLTRAN(2,MBLPAR*LT1),ARTRAN(2,MAPAR*LT1),NAREA,NBL
      CHARACTER*10 HEADER(MHEAD)
 
      REAL YTOYS,YSTOY
      EXTERNAL YTOYS,YSTOY
*-----------------------------------------------------------------------
      INTEGER IJ2KON,COLAT,KON2I,KON2J
      COLAT(I) = 10*I + 3
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      HEADER(1) = 'Name'
      HEADER(2) = ' Value'
      HEADER(3) = 'Constr.'
      HEADER(4) = 'Lower B'
      HEADER(5) = 'Upper B'
 
      NAREA = 0
      DO 100 J = 1,NSPEC
        DO 50 I = 1,IAP(2,J)
          NAREA = NAREA + 1
          ARTRAN(1,NAREA) = I
          ARTRAN(2,NAREA) = J
 50     CONTINUE
 100  CONTINUE
      TOPBL = TOPPGA + NAREA + 1
 
      NBL = 0
      DO 200 J = 1,NSPEC
        DO 150 I = 1,IBLP(2,J)
          NBL = NBL + 1
          BLTRAN(1,NBL) = I
          BLTRAN(2,NBL) = J
 150    CONTINUE
 200  CONTINUE
      TOPNAM = TOPBL + NBL + 2
 
*---Fudge baseline values; the user will see baseline values
*---corresponding to y-axis values in the current plotting mode.
      DO 300 J = 1,NSPEC
        DO 250 I = 1,IBLP(2,J)
          PBL0(I,J) = YTOYS(PBL0(I,J),CAL(1,J))
 250    CONTINUE
 300  CONTINUE
 
      CALL NORMAL
      CALL FRAME1(5,1,65,30,'C',
     &            'Page 2         GLOBAL AREAS AND BASELINES         ')
 
      CALL BRIGHT
      CALL OUTSXY(COLAT(1)-5,TOPPGA,'#')
      DO 400 I = 1,MHEAD
        CALL OUTSXY(COLAT(I),5,HEADER(I))
 400  CONTINUE
 
      CALL NORMAL
 
*---Global Areas
      ILINE = TOPPGA
      DO 500 J = 1,NSPEC
        DO 450 I = 1,IAP(2,J)
          ILINE = ILINE + 1
          CALL OUTIXY(COLAT(1)-6,ILINE,IJ2KON(I,J),4)
          CALL OUTSTR(')')
          CALL OUTSXY(COLAT(1),ILINE,PANAM(I,J))
          CALL PUTR(COLAT(2),ILINE,PA0(I,J))
          CALL OUTIXY(COLAT(3)+INTMOD,ILINE,KONA(I,J),IWID)
          CALL PUTR(COLAT(4),ILINE,PALB(I,J))
          CALL PUTR(COLAT(5),ILINE,PAUB(I,J))
 450    CONTINUE
 500  CONTINUE
 
*---Baselines
      ILINE = TOPBL
      DO 600 J = 1,NSPEC
        DO 550 I = 1,IBLP(2,J)
          ILINE = ILINE + 1
          CALL OUTIXY(COLAT(1)-6,ILINE,IJ2KON(I,J),4)
          CALL OUTSTR(')')
          CALL OUTSXY(COLAT(1),ILINE,PBLNAM(I,J))
          CALL PUTR(COLAT(2),ILINE,PBL0(I,J))
          CALL OUTIXY(COLAT(3)+INTMOD,ILINE,KONBL(I,J),IWID)
 550    CONTINUE
 600  CONTINUE
*      if (prog.eq.'WMOSS') then
*         call bright
*         call outsxy(41,topbl+1,ytitle(kyplot)(1:20))
*         call normal
*      endif
 
*---Spectrum names
      CALL BRIGHT
      CALL OUTSXY(8,TOPNAM,'Spectra to be fitted:')
      CALL NORMAL
 
      DO 700 I = 1,NSPEC
        CALL OUTIXY(7,TOPNAM+I,I,2)
        CALL OUTSTR(')')
        CALL OUTSXY(11,TOPNAM+I,SNAME(I))
 700  CONTINUE
      CALL NORMAL
 
      ICOL = 2
      IROW = 1
 
*---Global Areas
 800  IF ( IROW.LE.NAREA ) THEN
        IF ( ICOL.LT.3 ) THEN
          ICOL = 2
        ELSEIF ( ICOL.GT.6 ) THEN
          ICOL = 5
        ELSEIF ( IROW.LT.1 ) THEN
          IROW = 1
        ENDIF
        IY = IROW + TOPPGA
*---Baselines
      ELSE
        IF ( ICOL.LT.2 ) THEN
          ICOL = 2
        ELSEIF ( ICOL.GT.3 ) THEN
          ICOL = 3
        ENDIF
        IROW = MIN(IROW,NAREA+NBL)
        IY = (IROW-NAREA) + TOPBL
      ENDIF
 
      IX = COLAT(ICOL)
 
*---Global Areas
      IF ( IROW.LE.NAREA ) THEN
        I = ARTRAN(1,IROW)
        J = ARTRAN(2,IROW)
        IF ( ICOL.EQ.2 ) THEN
          CALL GETR(IX,IY,PA0(I,J),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.3 ) THEN
          CALL GETI(IX+INTMOD,IY,KONA(I,J),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.4 ) THEN
          CALL GETR(IX,IY,PALB(I,J),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.5 ) THEN
          CALL GETR(IX,IY,PAUB(I,J),ICHR,.TRUE.)
        ENDIF
*---baselines
      ELSE
        I = BLTRAN(1,IROW-NAREA)
        J = BLTRAN(2,IROW-NAREA)
        IF ( ICOL.EQ.2 ) THEN
          CALL GETR(IX,IY,PBL0(I,J),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.3 ) THEN
          CALL GETI(IX+INTMOD,IY,KONBL(I,J),ICHR,.TRUE.)
        ENDIF
      ENDIF
 
*---check keystrokes
      IF ( ICHR.EQ.UPARR ) THEN
        IROW = MAX(1,IROW-1)
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        IROW = IROW + 1
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        ICOL = ICOL + 1
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        ICOL = ICOL - 1
      ELSEIF ( (ICHR.EQ.ESC) .OR. (ICHR.EQ.PGUP) .OR. (ICHR.EQ.PGDN) )
     &         THEN
 
*---Verify consistancy of global areas
        DO 850 J = 1,NSPEC
          DO 820 I = 1,IAP(2,J)
            IF ( KONA(I,J).NE.0 ) THEN
              IF ( KONA(I,J).NE.IJ2KON(I,J) ) THEN
                ISPEC2 = KON2J(KONA(I,J))
                IF ( (ISPEC2.LT.1) .OR. (ISPEC2.GT.NSPEC) ) THEN
                  CALL ERRMSG('Error in constraint (bad spectrum)!')
                  ICOL = 3
                  IROW = I
                  GOTO 800
                ENDIF
                IPAR2 = KON2I(KONA(I,J))
                IF ( (IPAR2.LT.1) .OR. (IPAR2.GT.IAP(2,ISPEC2)) ) THEN
                  CALL ERRMSG('Error in constraint (bad parameter)!')
                  ICOL = 3
                  IROW = I
                  GOTO 800
                ENDIF
              ELSEIF ( PALB(I,J).GT.PAUB(I,J) ) THEN
                CALL ERRMSG('Lower bound > Upper bound!')
                ICOL = 4
                IROW = I
                GOTO 800
              ELSEIF ( PA0(I,J).LT.PALB(I,J) .OR. PA0(I,J).GT.PAUB(I,J)
     &                 ) THEN
                CALL ERRMSG('Variable not started within bounds!')
                ICOL = 2
                IROW = I
                GOTO 800
              ENDIF
            ENDIF
 820      CONTINUE
          DO 840 I = 1,IBLP(2,J)
            IF ( KONBL(I,J).NE.0 ) THEN
              ISPEC2 = KON2J(KONBL(I,J))
              IF ( (ISPEC2.LT.1) .OR. (ISPEC2.GT.NSPEC) ) THEN
                CALL ERRMSG('Error in constraint (bad spectrum)!')
                ICOL = 3
                IROW = NAREA + I
                GOTO 800
              ENDIF
              IPAR2 = KON2I(KONBL(I,J))
              IF ( (IPAR2.LT.1) .OR. (IPAR2.GT.IBLP(2,ISPEC2)) ) THEN
                CALL ERRMSG('Error in constraint (bad parameter)!')
                ICOL = 3
                IROW = NAREA + I
                GOTO 800
              ENDIF
            ENDIF
 840      CONTINUE
 850    CONTINUE
 
*---Restore baseline values
        DO 900 J = 1,NSPEC
          DO 860 I = 1,IBLP(2,J)
            PBL0(I,J) = YSTOY(PBL0(I,J),CAL(1,J))
 860      CONTINUE
 900    CONTINUE
 
        IF ( ICHR.EQ.PGUP ) THEN
          EDTBLA = -1
        ELSEIF ( ICHR.EQ.PGDN ) THEN
          EDTBLA = 1
        ELSE
          EDTBLA = 0
        ENDIF
 
        RETURN
      ENDIF
      GOTO 800
      END
