      SUBROUTINE EDTCAL(ISLOT,PGUPDN)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1991 cs
*---mru : 930301 tk
*---Purpose: edit information in DATA HEADER
*-----------------------------------------------------------------------
*---externals
* islot  : Number of spectrum in the list to edit
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'constcom.inc'
      INTEGER ISLOT
      LOGICAL PGUPDN
 
      INTEGER TOPCAL,TOPNAM,TOPCMT
      PARAMETER (TOPCAL=5,TOPNAM=TOPCAL+MCAL+1,TOPCMT=TOPNAM+1)
      INTEGER ICOL,IROW,ICHR,IX,IY,I,IERR
      CHARACTER*10 HEADER(5)
      REAL ORCAL(MCAL)
      INTEGER OICAL(MCAL),INTMOD
 
      INTEGER LENACT
      EXTERNAL LENACT
 
      SAVE HEADER
      DATA HEADER/'Name','  Value','Name',' ','     Value'/
 
      IMAXWID = 9
      INTMOD = 11 - IMAXWID
 
      CALL NORMAL
      IF ( PGUPDN ) THEN
        CALL MESSAGE('Arrows move cursor; '//
     &               '~PgUp~/~PgDn~ for next spectrum; ~ESC~ when done.'
     &               )
      ELSE
        CALL MESSAGE('Arrows move cursor; ~ESC~ when done.')
      ENDIF
      CALL WNACTN('CP')
      CALL WNOPEN(3,2,76,MCAL+17)
      CALL FRAME1(3,2,78,MCAL+17,'C','DATA HEADER OF '//SPCNAM(ISLOT)
     &            (:LENACT(SPCNAM(ISLOT))))
 
      CALL BRIGHT
      CALL OUTSXY(7,TOPCAL-1,'#')
      CALL OUTSXY(10,TOPCAL-1,HEADER(1))
      DO 100 I = 2,5
        CALL OUTSXY(11+10*I,TOPCAL-1,HEADER(I))
 100  CONTINUE
 
 200  CALL NORMAL
 
      DO 300 I = 1,MCAL
        CALL OUTIXY(6,TOPCAL+I,I,2)
        CALL OUTSTR(')')
        CALL OUTSXY(10,TOPCAL+I,RCALNM(I))
        CALL PUTR(31,TOPCAL+I,SPCCAL(I,ISLOT))
        CALL OUTSXY(41,TOPCAL+I,ICALNM(I))
        CALL OUTIXY(61+INTMOD,TOPCAL+I,ICALSP(I,ISLOT),IMAXWID)
 300  CONTINUE
      CALL OUTSXY(5,TOPNAM+1,SPCNAM(ISLOT))
      DO 400 I = 1,MCOMMT
        CALL OUTSXY(5,TOPCMT+I,SPCCMT(I,ISLOT))
 400  CONTINUE
 
      ICOL = 3
      IROW = 1
 
      DO 500 I = 1,MCAL
        ORCAL(I) = SPCCAL(I,ISLOT)
        OICAL(I) = ICALSP(I,ISLOT)
 500  CONTINUE
 
*---Adjust dependent parameters for changes in cal info
*---CALADJ is an application specific routine.
      CALL CALADJ(MCAL,SPCCAL(1,ISLOT),ICALSP(1,ISLOT),ICALSP(1,ISLOT),
     &            XSPC(1,ISLOT),SPCTRA(1,ISLOT),SPCNOI(1,ISLOT))
 
*---Display changed parameters
      DO 600 I = 1,MCAL
        IF ( ORCAL(I).NE.SPCCAL(I,ISLOT) )
     &       CALL PUTR(31,TOPCAL+I,SPCCAL(I,ISLOT))
        IF ( OICAL(I).NE.ICALSP(I,ISLOT) )
     &       CALL OUTIXY(61+INTMOD,TOPCAL+I,ICALSP(I,ISLOT),IMAXWID)
 600  CONTINUE
 
 700  IF ( IROW.LE.MCAL ) THEN
        IF ( ICOL.LT.3 ) THEN
          ICOL = 3
        ELSEIF ( ICOL.GT.6 ) THEN
          ICOL = 6
        ELSEIF ( IROW.LT.1 ) THEN
          IROW = 1
        ENDIF
        IY = IROW + TOPCAL
      ELSEIF ( IROW.EQ.MCAL+1 ) THEN
        ICOL = 3
        IY = 1 + TOPNAM
      ELSE
        IF ( IROW.GT.MCAL+MCOMMT+1 ) IROW = MCAL + MCOMMT + 1
        ICOL = 3
        IY = IROW - MCAL - 1 + TOPCMT
      ENDIF
 
      IX = (ICOL-1)*10 + 11
 
      IF ( IROW.GT.MCAL+1 ) THEN
        CALL GETS(5,IY,SPCCMT(IROW-MCAL-1,ISLOT),72,ICHR,.TRUE.)
      ELSEIF ( IROW.EQ.MCAL+1 ) THEN
        CALL GETS(5,IY,SPCNAM(ISLOT),MFLLEN,ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.3 ) THEN
        CALL GETR(IX,IY,SPCCAL(IROW,ISLOT),ICHR,.TRUE.)
      ELSEIF ( ICOL.EQ.6 ) THEN
        CALL GETI(IX+INTMOD,IY,ICALSP(IROW,ISLOT),ICHR,.TRUE.)
      ENDIF
 
      IF ( ICHR.EQ.UPARR ) THEN
        IROW = IROW - 1
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        IROW = IROW + 1
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        ICOL = ICOL + 3
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        ICOL = ICOL - 3
      ELSEIF ( (ICHR.EQ.PGUP) .AND. PGUPDN ) THEN
        CALL CHKCAL(ISLOT,IERR,ICOL,IROW)
        IF ( IERR.EQ.0 ) THEN
 
          IF ( ISLOT.GT.1 ) THEN
            ISLOT = ISLOT - 1
            CALL FRAME1(3,2,78,MCAL+17,' ',
     &                  'DATA HEADER OF '//SPCNAM(ISLOT)
     &                  (:LENACT(SPCNAM(ISLOT))))
            GOTO 200
          ENDIF
        ENDIF
      ELSEIF ( (ICHR.EQ.PGDN) .AND. PGUPDN ) THEN
        CALL CHKCAL(ISLOT,IERR,ICOL,IROW)
        IF ( IERR.EQ.0 ) THEN
 
          IF ( ISLOT.LT.SPCTOT ) THEN
            ISLOT = ISLOT + 1
            CALL FRAME1(3,2,78,MCAL+17,' ',
     &                  'DATA HEADER OF '//SPCNAM(ISLOT)
     &                  (:LENACT(SPCNAM(ISLOT))))
            GOTO 200
          ENDIF
        ENDIF
      ELSEIF ( ICHR.EQ.ESC ) THEN
 
        CALL CHKCAL(ISLOT,IERR,ICOL,IROW)
        IF ( IERR.EQ.0 ) THEN
C Cleanup
          CALL WNCLOS(1)
*---renormalize spectrum
*---CALADJ is an application specific routine.
          CALL CALADJ(MCAL,SPCCAL(1,ISLOT),ICALSP(1,ISLOT),
     &                ICALSP(1,ISLOT),XSPC(1,ISLOT),SPCTRA(1,ISLOT),
     &                SPCNOI(1,ISLOT))
 
          IMAXWID = 5
 
          RETURN
        ENDIF
      ENDIF
      GOTO 700
      END
