      INTEGER FUNCTION EDTLOC(ISUB)
*-----------------------------------------------------------------------
      INTEGER ISUB
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:
*---old mru 18Jul93 cs
*---mru: 950601 tk
*
*     isub   : number of local subsite to edit.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'varcom.inc'
 
      INTEGER TOPPL,INTMOD,IWID
      PARAMETER (TOPPL=2,IWID=5,INTMOD=7-IWID)
 
      CHARACTER*1 SUBNUM
      INTEGER TOPPLN,TOPINT
      INTEGER ICOL,IROW,ICHR,IX,IY,I,J,NHALF,ISUB2,IPAR2
      integer mrow,nirows,mrfram,mcfram
      CHARACTER*10 HEADER(5),LNHEAD(4)
 
*-----------------------------------------------------------------------
      INTEGER COLAT,IJ2KON,KON2I,KON2J
      COLAT(I) = 3 + 10*I
      IJ2KON(I,J) = I + 100*J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      HEADER(1) = 'Name'
      HEADER(2) = 'Value'
      HEADER(3) = 'Constr.'
      HEADER(4) = ' Lower B'
      HEADER(5) = ' Upper B'
 
      LNHEAD(1) = 'Name'
      LNHEAD(2) = 'Value'
      LNHEAD(3) = 'Constr.'
      LNHEAD(4) = ' Weight'
 
      TOPPLN = TOPPL + ILP(2,ISUB) + 1
      TOPINT = TOPPLN + ILP(3,ISUB) + 1
 
      CALL NORMAL
      CALL INTSTR(ISUB,SUBNUM,'(I1)')
*---define frame size in rows and columns
      mrfram=30
      mcfram=65
      CALL FRAME1(5,1,mcfram,mrfram,'C','SUBSITE #'//SUBNUM)
*---mrow is number of usable rows within frame
*---(Frame border requires 2 rows.)
      mrow=mrfram - 2
 
      CALL BRIGHT
      CALL OUTSXY(COLAT(1)-5,TOPPL,'#')
      DO 100 I = 1,5
        CALL OUTSXY(COLAT(I),TOPPL,HEADER(I))
 100  CONTINUE
 
      DO 200 I = 1,4
        CALL OUTSXY(COLAT(I),TOPPLN,LNHEAD(I))
 200  CONTINUE
      CALL NORMAL
 
c     /* Display Local Nonlinear Parameters */
      DO 300 I = 1,ILP(2,ISUB)
        CALL OUTIXY(COLAT(1)-6,TOPPL+I,IJ2KON(I,ISUB),4)
        CALL OUTSTR(')')
        CALL OUTSXY(COLAT(1),TOPPL+I,PLNAM(I,ISUB))
        CALL PUTR(COLAT(2),TOPPL+I,PL0(I,ISUB))
        CALL OUTIXY(COLAT(3)+INTMOD,TOPPL+I,KONL(I,ISUB),IWID)
        CALL PUTR(COLAT(4),TOPPL+I,PLLB(I,ISUB))
        CALL PUTR(COLAT(5),TOPPL+I,PLUB(I,ISUB))
 300  CONTINUE
 
c     /* Display Local Linear Parameters */
      DO 400 I = 1,ILP(3,ISUB)
        CALL OUTIXY(COLAT(1)-6,TOPPLN+I,IJ2KON(I,ISUB),4)
        CALL OUTSTR(')')
        CALL OUTSXY(COLAT(1),TOPPLN+I,PLNNAM(I,ISUB))
        CALL PUTR(COLAT(2),TOPPLN+I,PLN0(I,ISUB))
        CALL OUTIXY(COLAT(3)+INTMOD,TOPPLN+I,KONLN(I,ISUB),IWID)
        CALL PUTR(COLAT(4),TOPPLN+I,WEILN(I,ISUB))
 400  CONTINUE
 
c     /* Display Local Integer Parameters, possibly in 2 columns */
c---Do not display the first three integer parameters.
      Nirows = MIN(ILP(1,ISUB)-3 , mrfram-topint)
      if(nirows.lt. (ilp(1,isub)-3)/2 )then
         call errmsg('Not enough rows on screen to display local'//
     1 ' integer parameters.')
      endif
      nhalf = nirows+3
*---display 1st column of integer parms
      DO 500 I = 1,nirows
        IY = TOPINT + I - 1
        CALL OUTSXY(COLAT(1),IY,ILPNAM(I+3,ISUB))
        CALL OUTIXY(COLAT(2)+INTMOD,IY,ILP(I+3,ISUB),IWID)
  500 CONTINUE
*---display 2nd column of integer parms, if Nirows+1 .ge. Nipar-3
      DO 600 I = Nirows+1, ILP(1,ISUB)-3
        IY = TOPINT + I - (nirows+1)
        CALL OUTSXY(COLAT(4),IY,ILPNAM(I+3,ISUB))
        CALL OUTIXY(COLAT(5)+INTMOD,IY,ILP(I+3,ISUB),IWID)
 600  CONTINUE
 
      ICOL = 2
      IROW = 1
 
 700  IF ( IROW.LE.ILP(2,ISUB) ) THEN
        ICOL = MIN(5,MAX(2,ICOL))
        IROW = MAX(1,IROW)
        IY = TOPPL + IROW
      ELSEIF ( IROW.LE.ILP(2,ISUB)+ILP(3,ISUB) ) THEN
        ICOL = MIN(4,MAX(2,ICOL))
        IY = TOPPLN + IROW - ILP(2,ISUB)
      ELSE
        IROW = MIN(IROW,ILP(2,ISUB)+ILP(3,ISUB)+NHALF-3)
        IF ( NHALF.EQ.3 ) GOTO 700
        ICOL = MIN(5,MAX(2,ICOL))
        IF ( ICOL.EQ.3 ) THEN
          ICOL = 5
        ELSEIF ( ICOL.EQ.4 ) THEN
          ICOL = 2
        ENDIF
        IF ( NHALF.EQ.ILP(1,ISUB) ) ICOL = 2
        I = IROW - ILP(2,ISUB) - ILP(3,ISUB)
        IF ( (ICOL.GT.2) .AND. (I.GT.ILP(1,ISUB)-NHALF) ) ICOL = 2
*tk        IY = MOD(IROW-ILP(2,ISUB)-ILP(3,ISUB)-1,NHALF) + TOPINT + 1
        IY = MOD(IROW-ILP(2,ISUB)-ILP(3,ISUB)-1,NHALF) + TOPINT 
      ENDIF
 
      IX = COLAT(ICOL)
 
      IF ( IROW.LE.ILP(2,ISUB) ) THEN
        I = IROW
        IF ( ICOL.EQ.2 ) THEN
          CALL GETR(IX,IY,PL0(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.3 ) THEN
          CALL GETI(IX+INTMOD,IY,KONL(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.4 ) THEN
          CALL GETR(IX,IY,PLLB(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.5 ) THEN
          CALL GETR(IX,IY,PLUB(I,ISUB),ICHR,.TRUE.)
        ENDIF
      ELSEIF ( IROW.LE.ILP(2,ISUB)+ILP(3,ISUB) ) THEN
        I = IROW - ILP(2,ISUB)
        IF ( ICOL.EQ.2 ) THEN
          CALL GETR(IX,IY,PLN0(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.3 ) THEN
          CALL GETI(IX+INTMOD,IY,KONLN(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.4 ) THEN
          CALL GETR(IX,IY,WEILN(I,ISUB),ICHR,.TRUE.)
        ENDIF
      ELSE
        I = IROW - ILP(2,ISUB) - ILP(3,ISUB) + 3
        IF ( ICOL.EQ.2 ) THEN
          CALL GETI(IX+INTMOD,IY,ILP(I,ISUB),ICHR,.TRUE.)
        ELSEIF ( ICOL.EQ.5 ) THEN
          CALL GETI(IX+INTMOD,IY,ILP(I+NHALF-3,ISUB),ICHR,.TRUE.)
        ENDIF
      ENDIF
 
      IF ( ICHR.EQ.UPARR ) THEN
        IROW = IROW - 1
      ELSEIF ( ICHR.EQ.DNARR ) THEN
        IROW = IROW + 1
      ELSEIF ( ICHR.EQ.RTARR ) THEN
        ICOL = ICOL + 1
      ELSEIF ( ICHR.EQ.LTARR ) THEN
        ICOL = ICOL - 1
      ELSEIF ( (ICHR.EQ.ESC) .OR. (ICHR.EQ.PGUP) .OR. (ICHR.EQ.PGDN) )
     &         THEN
        DO 750 I = 1,ILP(2,ISUB)
          IF ( (KONL(I,ISUB).EQ.IJ2KON(I,ISUB)) .AND. 
     &         ((PL0(I,ISUB).LT.PLLB(I,ISUB)) .OR. 
     &         (PL0(I,ISUB).GT.PLUB(I,ISUB))) ) THEN
            CALL ERRMSG('Variable not started within bounds!')
            ICOL = 4
            IROW = I
            GOTO 700
          ENDIF
 750    CONTINUE
 
        DO 800 I = 1,ILP(2,ISUB)
          IF ( KONL(I,ISUB).NE.0 ) THEN
            ISUB2 = KON2J(KONL(I,ISUB))
            IF ( (ISUB2.LT.1) .OR. (ISUB2.GT.NSUBS) ) THEN
              CALL ERRMSG('Error in constraint (bad site)!')
              ICOL = 3
              IROW = I
              GOTO 700
            ENDIF
            IPAR2 = KON2I(KONL(I,ISUB))
            IF ( (IPAR2.LT.1) .OR. (IPAR2.GT.ILP(2,ISUB2)) ) THEN
              CALL ERRMSG('Error in constraint (bad parameter)!')
              ICOL = 3
              IROW = I
              GOTO 700
            ENDIF
          ENDIF
 800    CONTINUE
 
        DO 850 I = 1,ILP(3,ISUB)
          IF ( KONLN(I,ISUB).NE.0 ) THEN
            ISUB2 = KON2J(KONLN(I,ISUB))
            IF ( (ISUB2.LT.1) .OR. (ISUB2.GT.NSUBS) ) THEN
              CALL ERRMSG('Error in constraint (bad site)!')
              ICOL = 3
              IROW = ILP(2,ISUB) + I
              GOTO 700
            ENDIF
            IPAR2 = KON2I(KONLN(I,ISUB))
            IF ( (IPAR2.LT.1) .OR. (IPAR2.GT.ILP(3,ISUB2)) ) THEN
              CALL ERRMSG('Error in constraint (bad parameter)!')
              ICOL = 3
              IROW = ILP(2,ISUB) + I
              GOTO 700
            ENDIF
          ENDIF
 850    CONTINUE
 
        IF ( ICHR.EQ.PGUP ) THEN
          EDTLOC = -1
        ELSEIF ( ICHR.EQ.PGDN ) THEN
          EDTLOC = 1
        ELSE
          EDTLOC = 0
        ENDIF
 
        RETURN
      ENDIF
      GOTO 700
      END
