*----------------------------------------------------------------------
      SUBROUTINE EXS1(OP,C,NSTATE,ND,EXVAL)
*----------------------------------------------------------------------
*     CALCULATES THE EXPECTATION VALUES OF A SINGLE SPIN OPERATOR.
*----------------------------------------------------------------------
      INTEGER ND, NSTATE
      COMPLEX OP(ND,ND),C(ND,ND)
      REAL EXVAL(ND)
*----------------------------------------------------------------------
      REAL EVI
      COMPLEX CADJNT
      INTEGER I, J, K
*----------------------------------------------------------------------
 
      DO 100 I = 1,NSTATE
        EVI = 0.0
        DO 50 J = 1,NSTATE
          CADJNT = CONJG(C(J,I))
          DO 20 K = 1,NSTATE
            EVI = EVI + CADJNT*OP(J,K)*C(K,I)
 20       CONTINUE
 50     CONTINUE
        EXVAL(I) = EVI
 100  CONTINUE
 
      RETURN
      END
