 
 
      SUBROUTINE FILCNT(IADD,IERR)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 920409 tk
*---mru : 930312 tk
*---Purpose:
*     Reads file with encripted integer from licensed floppy demo disk.
*     Deciphers count, adds to it, and overwrites disk file.
*     If count exceeds limit, abort program.
*-----------------------------------------------------------------------
*---externals
*     iadd   : Number to add to the count
*     ierr   : Error code (0 if everything goes well)
*---parameters and common blocks
      INCLUDE 'constcom.inc'
      INCLUDE 'iocom.inc'
*---internals
      INTEGER IADD,IERR
      INTEGER I,J,K,IDSK,JDSK,KDSK,N,ISTEP
*---volume s/n read from floppy disk
c      CHARACTER FSN*9
*-----------------------------------------------------------------------
*---statement functions: integer parametric equations.
*--- PION 

c      I(N) = N**2 - 10*N + 103
	I(N) = 100
c      J(N) = -N**3 + N**2 - 75
	J(N) = -75
c      K(N) = -4*N**3 + 2*N**2 - 8*N + 31415
	K(N) = 31145
*-----------------------------------------------------------------------
*---executables
*---check to see that original licensed floppy is in a: or b: drive
*---and define path
c      FSN = ' '
c      IERR = -11
c      CALL VSN(DMOPTH(:2),FSN,IERR)
c      IF ( IERR.NE.0 .OR. FSN.NE.SNLIC ) THEN
*---Licensed floppy not found, so abort.
c        CALL ENDGR
*--- PION(PRINT)
c        WRITE (*,*) 'Demonstration Program aborted.'
c        WRITE (*,*) 'Original WEB Research Co. floppy disk '
c        WRITE (*,*) 'was not found in the DEMOPATH drive.'
c        WRITE (*,*) ' '
c        WRITE (*,*) 'tel. 612-942-6276'
c        WRITE (*,*) ' '
c        WRITE (*,*) '                      Press ENTER ... '
c        READ (*,*)
c        STOP
c      ENDIF
 
*---read from disk file
c      OPEN (JDISK,FILE=DMOPTH//'yhnmju.iop',FORM='UNFORMATTED',
c     &      IOSTAT=IERR)
c      IF ( IERR.EQ.0 ) THEN
c        READ (JDISK,IOSTAT=IERR) IDSK,JDSK,KDSK
c        IF ( IERR.EQ.0 ) THEN
c          CLOSE (JDISK,IOSTAT=IERR)
c          IF ( IERR.EQ.0 ) THEN
*---decode key from disk by finding number of steps along parametric
*---curve.
            NFLDMO = MFLDMO
c            DO 10 ISTEP = 0,MFLDMO
c              IF ( I(ISTEP).EQ.IDSK .AND. J(ISTEP).EQ.JDSK .AND. 
c     &             K(ISTEP).EQ.KDSK ) THEN
c                NFLDMO = ISTEP
c                GOTO 20
c              ENDIF
c 10         CONTINUE
 
c 20         IF ( NFLDMO.LT.MFLDMO ) THEN
*---add IADD to count and overwrite parametric point stored on disk
              NFLDMO = NFLDMO + IADD
              IDSK = I(NFLDMO)
              JDSK = J(NFLDMO)
              KDSK = K(NFLDMO)
*---write to  disk file
c              OPEN (JDISK,FILE=DMOPTH//'yhnmju.iop',FORM='UNFORMATTED',
c     &              IOSTAT=IERR)
c              IF ( IERR.EQ.0 ) THEN
c                WRITE (JDISK,IOSTAT=IERR) IDSK,JDSK,KDSK
c                IF ( IERR.EQ.0 ) THEN
c                  CLOSE (JDISK,IOSTAT=IERR)
c                  IF ( IERR.NE.0 ) THEN
c                  ENDIF
c                ENDIF
c              ENDIF
c            ELSE
*---maximum allowed count exceeded
c              CALL ENDGR
*---PION(PRINT)
c              PRINT *,'Program aborted.'
c             PRINT *,'Number of File Load operations allowed for this'
c              PRINT *,'demonstration package has been exceeded.'
c              PRINT *,' '
c              PRINT *,'For further information contact:'
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
c              PRINT *,' '
c              PRINT *,'                      Press ENTER ... '
c              READ (*,*)
c              STOP
c            ENDIF
c          ENDIF
c        ENDIF
c      ENDIF
      IERR=0
      RETURN
      END
