       SUBROUTINE foldop(ifun)
*----------------------------------------------------------------------
*---FOLDOP presents options box and accepts keybord input to define
*---folding method:
*--- IFUN       method
*---   0          do nothing
*---   1          manual
*---   2          auto
*---   3          save first half only
*---   4          save second half only
*---   5          Iron Calibration
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 920518 tk
*---mru : 960112 tk
*---      980102 tk -- add No Fold as Option #6
*----------------------------------------------------------------------
      include 'keycom.inc'
      INTEGER MAXFUN,FUNWID
      PARAMETER (MAXFUN=6, FUNWID=11)
 
      INTEGER I,ICHR,IFUN
      CHARACTER*(FUNWID) FUNS(MAXFUN)
 
      save funs
      DATA FUNS/'Manual Fold','Auto Fold','First Half','Second Half',
     &   'Iron Cal','No Fold'/
 
      call normal
      CALL WNACTN('CFP')
      CALL WNOPNT(0,0,FUNWID+2,MAXFUN+2,'Fold')
 
      IFUN = 1
 
 100  DO 200 I = 1,MAXFUN
        IF ( I.EQ.IFUN ) THEN
           call invert
        ELSE
           call normal
        ENDIF
        CALL WNOUSX(1,I+1,' '//FUNS(I)//' ')
 200  CONTINUE
 
      call normal
 
      CALL INKEY(ICHR)
      IF ( ICHR.EQ.DNARR ) THEN
        IFUN = MIN(IFUN+1,MAXFUN)
      ELSEIF ( ICHR.EQ.UPARR ) THEN
        IFUN = MAX(IFUN-1,1)
      ELSEIF ( ICHR.EQ.ENTER ) THEN
        goto 99
      ENDIF
      IF ( ICHR.eq.ESC )then
         ifun=0
      else
         GOTO 100
      endif
 
99    CALL WNCLOS(1)
      RETURN
      END
