      SUBROUTINE GETI(IX1,IY1,MPARAM,ICHR,ARRESC)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig CS
*---mru 931220 tk
*
*     Gets an integer value from the user at a specific point on the
*     screen, returning the user's last keypress.  The flag ARRESC
*     specifies whether a key other than ESC or ENTER will exit the
*     routine.
*
*     ix1    : x-position of the input field
*     iy1    : y-position of the input field
*     mparam : default value; returns the user's input
*     ichr   : keycode of the key causing GETR to return
*     arresc : Return on keys other than ENTER and ESC?
*-----------------------------------------------------------------------
      INTEGER IX1,IY1,MPARAM,ICHR
      LOGICAL ARRESC
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER MLEN
      PARAMETER (MLEN=9)
 
      REAL DUMMY
      INTEGER LENSTR,IX,IY
      CHARACTER*(MLEN) INSTR,INSTR1
 
      INTEGER LOCCHR,INFOER,INFOCU
      EXTERNAL LOCCHR,INFOER,INFOCU
*-----------------------------------------------------------------------
 
*---Display highlighted string with default value left-justified
      IF ( IX1.LE.0 ) THEN
        IX = INFOCU(1)
      ELSE
        IX = IX1
      ENDIF
      IF ( IY1.LE.0 ) THEN
        IY = INFOCU(2)
      ELSE
        IY = IY1
      ENDIF
 
      CALL INTSTR(MPARAM,INSTR1,'(I'//CHAR(IMAXWID+ICHAR('0'))//')')
 
      INSTR = INSTR1(LOCCHR(INSTR1):IMAXWID)
 
      CALL SAVCOL
      CALL INVERT
 
      CALL OUTSXY(IX,IY,INSTR(:IMAXWID))
 
      CALL INKEY(ICHR)
 
*_Patch CS 19Dec92
c        IF ((.not.ARRESC).and.(ICHR.NE.ENTER).AND.(ICHR.NE.ESC) ) THEN
c          GOTO 100
c        ELSE
c        endif
      IF ( ((ICHR.LT.48) .OR. (ICHR.GT.57)) .AND. (ICHR.NE.ICHAR('-')) )
     &     GOTO 200
 
      INSTR = CHAR(ICHR)
      LENSTR = 1
 
*---Clear Interacter error flag
      DUMMY = INFOER(1)
 
*---Display initial value
      CALL OUTSXY(IX,IY,INSTR(:IMAXWID))
 
 100  IF ( LENSTR.GT.0 ) THEN
        CALL OUTSXY(IX-1+LENSTR,IY,INSTR(LENSTR:LENSTR))
      ELSE
        CALL CURXY(IX,IY)
      ENDIF
      IF ( LENSTR.LE.IMAXWID-1 ) CALL OUTSTR('_')
      IF ( LENSTR.LE.IMAXWID-2 ) CALL OUTSTR(' ')
 
      CALL INKEY(ICHR)
 
      IF ( ((ICHR.GE.ICHAR('0')) .AND. (ICHR.LE.ICHAR('9'))) .AND. 
     &     (LENSTR.LT.IMAXWID) ) THEN
        INSTR1 = INSTR
        IF ( LENSTR.GT.0 ) THEN
          INSTR = INSTR1(:LENSTR)//CHAR(ICHR)
        ELSE
          INSTR = CHAR(ICHR)
        ENDIF
        LENSTR = LENSTR + 1
      ELSEIF ( (ICHR.EQ.ICHAR('-')) .AND. (LENSTR.EQ.0) ) THEN
        INSTR = '-'
        LENSTR = 1
      ELSEIF ( ((ICHR.EQ.DEL) .OR. (ICHR.EQ.BS)) .AND. (LENSTR.GT.0) )
     &         THEN
        LENSTR = LENSTR - 1
      ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.ESC) .OR. (ICHR.EQ.TAB)
     &         .OR. ((ICHR.GE.UPARR) .AND. (ICHR.LE.PGDN) .AND. ARRESC)
     &         ) THEN
        IF ( LENSTR.LE.0 ) GOTO 200
        CALL STRINT(INSTR(:LENSTR),MPARAM)
        IF ( INFOER(1).EQ.0 ) GOTO 200
      ENDIF
      GOTO 100
 
 200  CALL RSTCOL
      CALL OUTIXY(IX,IY,MPARAM,IMAXWID)
      RETURN
      END
