*-----------------------------------------------------------------------
      SUBROUTINE GETL(IX1,IY1,LPARAM,YSTR,NSTR,ICHR,ARRESC)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 27Jun93 CS
*
*     Gets a logical value from the user at a specific point on the
*     screen, returning the user's last keypress: 'Y', 'N', ESC, ENTER,
*     or any other key if arresc is true.
*
*     ix1    : x-position of the input field;
*     iy1    : y-position of the input field;
*     lparam : default value; returns the user's input;
*     ystr   : string for true value (' ' => 'Yes')
*     nstr   : string for false value (' ' => 'No')
*     ichr   : keycode of the key causing GETL to return;
*     arresc : Return on keys other than ENTER, Y, N, or ESC?
*-----------------------------------------------------------------------
      INTEGER IX1,IY1,ICHR
      LOGICAL ARRESC,LPARAM
      CHARACTER*(*) YSTR,NSTR
*-----------------------------------------------------------------------
      INCLUDE 'keycom.inc'
 
      INTEGER IX,IY,MLEN
      CHARACTER*80 YSTR1,NSTR1
 
      INTEGER LENACT,INFOCU
      EXTERNAL LENACT,INFOCU
*-----------------------------------------------------------------------
 
*---Display highlighted string with default value left-justified
      IF ( IX1.LE.0 ) THEN
        IX = INFOCU(1)
      ELSE
        IX = IX1
      ENDIF
      IF ( IY1.LE.0 ) THEN
        IY = INFOCU(2)
      ELSE
        IY = IY1
      ENDIF
 
      IF ( LENACT(YSTR).EQ.0 ) THEN
        YSTR1 = 'Yes'
      ELSE
        YSTR1 = YSTR
        CALL JUSTIF(YSTR1,'L')
      ENDIF
      IF ( LENACT(NSTR).EQ.0 ) THEN
        NSTR1 = 'No'
      ELSE
        NSTR1 = NSTR
        CALL JUSTIF(NSTR1,'L')
      ENDIF
      MLEN = MAX(LENACT(NSTR1),LENACT(YSTR1))
 
      CALL SAVCOL
      CALL INVERT
      IF ( LPARAM ) THEN
        CALL OUTSXY(IX,IY,YSTR1(1:MLEN))
      ELSE
        CALL OUTSXY(IX,IY,NSTR1(1:MLEN))
      ENDIF
 
 100  CALL INKEY(ICHR)
 
      IF ( ICHR.EQ.ICHAR('y') .OR. ICHR.EQ.ICHAR('Y') ) THEN
        LPARAM = .TRUE.
        GOTO 200
      ELSEIF ( ICHR.EQ.ICHAR('n') .OR. ICHR.EQ.ICHAR('N') ) THEN
        LPARAM = .FALSE.
        GOTO 200
      ELSEIF ( ICHR.EQ.ENTER .OR. ICHR.EQ.ESC ) THEN
        GOTO 200
      ELSEIF ( ARRESC ) THEN
        GOTO 200
      ENDIF
      GOTO 100
 
*---Display initial value
 200  CALL RSTCOL
      IF ( LPARAM ) THEN
        CALL JUSTIF(YSTR1(1:MLEN),'R')
        CALL OUTSXY(IX,IY,YSTR1(1:MLEN))
      ELSE
        CALL JUSTIF(NSTR1(1:MLEN),'R')
        CALL OUTSXY(IX,IY,NSTR1(1:MLEN))
      ENDIF
 
      RETURN
      END
