*-----------------------------------------------------------------------
      INTEGER FUNCTION GETSPC()
*-----------------------------------------------------------------------
*     Allows the user to select a spectrum from the list using the
*     list movement keys (Grey +, Grey -, PgUp, PgDn). If no spectrum
*     is selected, a negative spectrum number is returned.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'keycom.inc'
      INCLUDE 'scrncom.inc'
 
      INTEGER TMPACT,ICHR
*-----------------------------------------------------------------------
 
      TMPACT = ACTSPC
 
 100  CALL INKEY(ICHR)
      IF ( ICHR.EQ.GRPLUS ) THEN
        ACTSPC = MIN(ACTSPC+1,SPCTOT)
        CALL SHOLST
      ELSEIF ( ICHR.EQ.GRMIN ) THEN
        ACTSPC = MAX(1,ACTSPC-1)
        CALL SHOLST
      ELSEIF ( ICHR.EQ.PGDN ) THEN
        ACTSPC = MIN(ACTSPC+PAGLEN,SPCTOT)
        CALL SHOLST
      ELSEIF ( ICHR.EQ.PGUP ) THEN
        ACTSPC = MAX(ACTSPC-PAGLEN,1)
        CALL SHOLST
      ELSEIF ( (ICHR.EQ.ENTER) .OR. (ICHR.EQ.AUXENTER) ) THEN
        GETSPC = ACTSPC
        SELECT(ACTSPC) = .NOT.(SELECT(ACTSPC))
        ACTSPC = TMPACT
        GOTO 200
      ELSEIF ( ICHR.EQ.ESC ) THEN
        GETSPC = -1
        GOTO 200
      ENDIF
      GOTO 100
 
 200  RETURN
      END
