*-----------------------------------------------------------------------
      SUBROUTINE GETVEC
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     08Oct91 cs, mru 16Jul93
*     Copies all global nonlinear, local nonlinear, global area and
*     linear parm from the parameter vector to the current parameter
*     arrays.
*     Assumes all curent integer parameters correctly reflect the
*     parameter vector contents.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'mancom.inc'
 
      INTEGER I,IPAR,ISUB
*-----------------------------------------------------------------------
      INTEGER KON2I,KON2J
      KON2I(I) = 1 + MOD(I-1,100)
      KON2J(I) = I/100
*-----------------------------------------------------------------------
 
      DO 100 I = 1,NPTOT
        IPAR = KON2I(PARIDX(I))
        ISUB = KON2J(PARIDX(I))
        IF ( PARTYP(I).EQ.GNLTYP ) THEN
          PG0(IPAR,ISUB) = PARVEC(I)
          PGUB(IPAR,ISUB) = PARUB(I)
          PGLB(IPAR,ISUB) = PARLB(I)
        ELSEIF ( PARTYP(I).EQ.LNLTYP ) THEN
          PL0(IPAR,ISUB) = PARVEC(I)
          PLUB(IPAR,ISUB) = PARUB(I)
          PLLB(IPAR,ISUB) = PARLB(I)
        ELSEIF ( PARTYP(I).EQ.GARTYP ) THEN
          PA0(IPAR,ISUB) = PARVEC(I)
          PAUB(IPAR,ISUB) = PARUB(I)
          PALB(IPAR,ISUB) = PARLB(I)
        ELSEIF ( PARTYP(I).EQ.LINTYP ) THEN
          PLN0(IPAR,ISUB) = PARVEC(I)
          PLNUB(IPAR,ISUB) = PARUB(I)
          PLNLB(IPAR,ISUB) = PARLB(I)
        ELSEIF ( PARTYP(I).EQ.BLTYP ) THEN
          PBL0(IPAR,ISUB) = PARVEC(I)
          PBLUB(IPAR,ISUB) = PARUB(I)
          PBLLB(IPAR,ISUB) = PARLB(I)
        ENDIF
 100  CONTINUE
 
      RETURN
      END
