*----------------------------------------------------------------------
      LOGICAL FUNCTION GETYN(QUESTN)
*----------------------------------------------------------------------
*     Gets a Yes/No answer from the user to a question.
*
*     questn : Question to which the user should respond
*----------------------------------------------------------------------
      CHARACTER*(*) QUESTN
*----------------------------------------------------------------------
      INCLUDE 'scrncom.inc'
 
      INTEGER ICOL,IWID,IROW,ICHR
 
      INTEGER LENACT
      EXTERNAL LENACT
*----------------------------------------------------------------------
 
      CALL EMPHSZ
 
*---Pop-up question window
      IWID = LENACT(QUESTN) + 4
      ICOL = (ISCCOL-IWID)/2
      IROW = ISCROW/3
      CALL WNSAVE(ICOL,IROW,IWID+1,4+1)
 
      CALL FRAME0(ICOL,IROW,ICOL+IWID-1,IROW+4,'Clear')
      CALL OUTSXY(ICOL+2,IROW+1,QUESTN)
      CALL OUTSXY(ICOL+LENACT(QUESTN)/2,IROW+3,'(Y/N)')
 
*---Wait for answer
 100  CALL INKEY(ICHR)
      IF ( (ICHR.EQ.ICHAR('Y')) .OR. (ICHR.EQ.ICHAR('y')) ) THEN
        GETYN = .TRUE.
      ELSEIF ( (ICHR.EQ.ICHAR('N')) .OR. (ICHR.EQ.ICHAR('n')) ) THEN
        GETYN = .FALSE.
      ELSE
        GOTO 100
      ENDIF
 
*---Restore screen state
      CALL WNREST
 
      RETURN
      END
