      subroutine intfn5(ilevel, ierr)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig 931101 TK
*---mru  931101 TK
*     WMOSS user-supplied routine, for Heff+efg model (Model #5)
*
*     ilevel  : [Input]  Which level of physical model to initialize;
*     ierr    : [Output] Error flag.
*-----------------------------------------------------------------------
      integer ilevel, ierr
      include 'limits.inc'
      include 'iocom.inc'
      include 'parcom.inc'
      include 'gridcom.inc'
      include 'mancom.inc'

      integer i, j
*-----------------------------------------------------------------------
      ierr=0

*---Grid is define at global level (in ULOGL5.FOR)

      if (ilevel.lt.LNLTYP) then
c         /* Initialize the local level because the Global has changed */
         do 200 j = 1, MLOC
            do 100 i = 1, MLPAR
               plcopy(i,j) = -9876543.21
  100       continue
  200    continue
      endif

      return
      end
