      subroutine intfun(ilevel,IERR)
*---Purpose: Initialize simulation.  Levels of physical models to be 
*---         initialized specified by ILEVEL.
*---         Meaning of ILEVEL defined in MANCOM.INC
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:    20Jul93 cs
*---mru:  971211 tk
*--------------------------------------------------------------------

      include 'limits.inc'
      include 'parcom.inc'  
      integer ilevel,ierr

      ierr=0

*---Initialize fit model
      if ( model.eq.1 ) then
         call intfn1(ilevel,ierr)
      elseif ( (model.eq.2).or.(model.eq.3) ) then
         call intfn2(ilevel,ierr)
      elseif (model.eq.4) then
         call intfn4(ilevel,ierr)
      elseif(MODEL.EQ.5)then
         CALL INTFN5(ilevel,ierr)
      elseif(MODEL.EQ.6)then
         CALL INTFN6(ilevel,ierr)
      elseif(MODEL.EQ.7)then
         CALL INTFN7(ilevel,ierr)
      else
         call errmsg('Invalid MODEL number.')
         ierr = -1
      endif

      return
      end

