*--------------------------------------------------------------------
      SUBROUTINE INTGRA
*--------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG

*     1992 cs, mru 10Aug93 cs
*
*     Calls the interacter graphics initializing sequence.

*--- PION 110621: graphics box initialisation and color redefinitions
*--------------------------------------------------------------------
      INCLUDE 'constcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'scrncom.inc'
 
      INTEGER INFOSC
      EXTERNAL INFOSC
*--------------------------------------------------------------------
 
*---Set graphics window to be non-resizable
	CALL SCMOPT(12,0)
c      CALL SCMOPT(6,0)
*---Request a 30-line X-windows text window
      CALL SCMOPT(2,30)
*---Add titles to X-windows windows
      CALL SCTITL('T',PROG)
      CALL SCTITL('G',PROG)
 
      IF ( ZGRAPH ) THEN
        GRPHON = .TRUE.
        CALL GRINIT('R',ISCX,ISCY,256)
c        CALL GRINIT('R',ISCX,ISCY,16)
        CALL CLRALL
 
*---Define current font and list of available fonts
        FNTLST(1) = 'simplexr.chr'
        FNTLST(2) = 'simplexg.chr'
        FNTLST(3) = 'duplexr.chr'
        FNTLST(4) = 'complexg.chr'
        IFNT = 1
        CALL GCHSET(FNTLST(IFNT))
        CHJUST = 'L'
        CALL GCHJUS(CHJUST)
        XCHSZ = 0.7
        YCHSZ = 0.7
        CALL GCHSIZ(XCHSZ,YCHSZ)
 
        IF ( UNIX ) CALL GHCOPT(19,2)
 
*---fill pattern (PION: texture for spectra box)

        CALL GFILL(4,1,1)

*Black->grey (PION: bkgd for spectra)
        CALL GPARGB(0,191,191,191)
c        CALL GPARGB(0,230,230,230)

*White->Black (PION: normal spectra color)
        CALL GPARGB(NRMCOL,0,0,0)

*Magenta->Dk. Grey
        CALL GPARGB(MSKCOL,180,180,180)

*--- PION; is needed to reset RGB palette to correctly display the rest?

c	  CALL GPARGB(0,255,255,255)
	  CALL GPARGB(31, 255,0,0)
	  CALL GPARGB(159, 0,0,255)
*---
        ISCX = INFOSC(4)
        ISCY = INFOSC(5)
      ELSE
        GRPHON = .FALSE.
        ISCX = 1.
        ISCX = 1.
      ENDIF
 
      XA1 = 0.
      XA2 = 1.
      YA1 = 0.
      YA2 = 1.
      PA1 = 0.
      PA2 = 1.
      QA1 = 0.
      QA2 = 1.
 
      ISCROW = INFOSC(3)
      ISCCOL = INFOSC(2)
      BOT = ISCROW - 1
      PAGLEN = BOT - TOP - 1
      LSTCOL = NINT(BOXURX*ISCCOL) + 2
 
      CALL SHOLST
      CALL SHOACT(.FALSE.)
 
      RETURN
      END
