*-----------------------------------------------------------------------
      SUBROUTINE MESSAGE(STR)
*-----------------------------------------------------------------------
*  Prints a message, clearing the bottom line & positioning
*     there.  Characters in the string to be hilighted should be
*     enclosed by tildes (~'s).
*  str    : string to output
*-----------------------------------------------------------------------
      CHARACTER*(*) STR
*-----------------------------------------------------------------------
      INTEGER I
      LOGICAL HILITE
*-----------------------------------------------------------------------
 
      CALL NORMAL
      CALL CLLINE(1)
 
      HILITE = .FALSE.
      DO 100 I = 1,LEN(STR)
        IF ( STR(I:I).EQ.'~' ) THEN
          HILITE = .NOT.HILITE
        ELSE
          IF ( HILITE ) THEN
            CALL EMPHSZ
          ELSE
            CALL BRIGHT
          ENDIF
          CALL OUTSTR(STR(I:I))
        ENDIF
 100  CONTINUE
 
      CALL NORMAL
 
      RETURN
      END
