*----------------------------------------------------------------------
      SUBROUTINE MMIP3(A,B,C)
*----------------------------------------------------------------------
*     Calculates the inner product of two matrices.
*
*                          3
*     C = AB  i.e., Cij = SUM Aik * Bkj  for all i,j in {1,2,3}
*                         k=1
*----------------------------------------------------------------------
      REAL A(3,3),B(3,3),C(3,3)
*----------------------------------------------------------------------
      INTEGER I,J,K
      REAL X
*----------------------------------------------------------------------
      DO 100 I = 1,3
        DO 50 J = 1,3
          X = 0.0
          DO 20 K = 1,3
            X = X + A(I,K)*B(K,J)
 20       CONTINUE
          C(I,J) = X
 50     CONTINUE
 100  CONTINUE
      RETURN
      END
