      SUBROUTINE monasi(FILNAM,SPEC,TEXT,ICAL,RCAL,IERR)
C
C       READ one SPECTRUM AND ITS HEADER from Monash ASCII file.
*
C       File FORMAT IS AS FOLLOWS:
C       HEADER IS  4 lines of text   (store in text(1-4)
c                              5th line has Nchannels as first number on line
c                               6th & 7th lines have integer Monash info that is treated as text (store in text(5&6)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 960707 tk
*---mru : 980503 tk: add fold option
C --------------------------------------------------
      INCLUDE 'iocom.inc'
      include 'limits.inc'

      real specuf(2*lspec)
      CHARACTER FILNAM*(*),TEXT(MCOMMT)*72
      REAL SPEC(lspec),RCAL(MCAL)
      INTEGER ICAL(MCAL), IERR
      INTEGER Nchan, nuf
      integer i, nrow, ierr1, nlast, irow
*-------------------------------------------------------
*---executables

*---clear header info in RAM
      do 10 i=1,mcal
         ical(i)=0
         rcal(i)=0.0
   10 continue
         do 40 i=1,mcommt
40         text(i)=' '

C OPEN FILE
      OPEN (JDISK,FILE=FILNAM,IOSTAT=IERR)
      IF ( IERR.NE.0 ) RETURN
 
C READ IN THE HEADER
c---- 4 lines of text
      DO 50 I = 1,4
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
 50     CONTINUE
c---number of channels
      read(jdisk,*,iostat=ierr,err=300)nchan
      if(nchan.lt.1 .or. nchan .gt. lspec)then
         call errmsg('Impoper value for Nchan in Monash file.')
         ierr=1
         go to 300
      else
         nuf = nchan
c---set file type to "Monash"
         ical(5)=13
      endif

c--- 2 more lines of text
      DO 60 I = 5,6
          READ (JDISK,'(a)',IOSTAT=IERR,ERR=300) TEXT(I)
60     CONTINUE

C READ IN THE SPECTRUM
c---define number of rows with 8 channels
      NROW = nchan/8
c---define number of channels in last incomplete row.
      Nlast = nchan - 8*nrow

      do 100 irow= 1,nrow
           read(jdisk,*,IOSTAT=IERR,ERR=300)
     & (specuf(I + (irow-1)*8), I=1,8)
100   continue

      if(nlast.gt.0) read(jdisk,*,IOSTAT=IERR,ERR=300)
     & (specuf(I + nrow*8), I=1,nlast)

      CALL FALT(filnam, nuf, specuf, ical(1), spec, rcal(5),
     &       rcal(6), rcal(7), ierr)

      ierr=0

 
  300 CLOSE (JDISK, IOSTAT=IERR1)

      if (ierr1.ne.0) ierr = ierr1

      RETURN
      END
