*----------------------------------------------------------------------
      SUBROUTINE MSKAPP(NSPPTS,SPC,MSK,SPCVEC,NPT)
*----------------------------------------------------------------------
*     Applies a list mask to a list of spectra, moving all unmasked
*     points into a single vector.
*
*     nsppts : list of lengths for the spectra
*     spc    : list of spectra
*     msk    : list of masks
*     spcvec : output vector of unmasked points
*     npt    : number of unmasked points found
*----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
 
      REAL SPC(LSPEC,*),SPCVEC(*)
      LOGICAL MSK(LSPEC,*)
      INTEGER NSPPTS(*),NPT
*----------------------------------------------------------------------
      INTEGER I,J
*----------------------------------------------------------------------
 
      NPT = 0
      DO 100 J = 1,NSPEC
        DO 50 I = 1,NSPPTS(J)
          IF ( MSK(I,J) ) THEN
            NPT = NPT + 1
            SPCVEC(NPT) = SPC(I,J)
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
      RETURN
      END
