*-----------------------------------------------------------------------
      SUBROUTINE OTHERA(IOTHER)
*-----------------------------------------------------------------------
*     Plots a spectrum stored in OTHSPC using exclusive-or
*     mode, which erases the previously displayed plot.
*
*     iother   : Number of spectrum to erase
*
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    07May93 CS
*--- PION 110620: replace gcoln()
*-----------------------------------------------------------------------
      INTEGER IOTHER
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER I
 
      INTEGER MCOLS
      PARAMETER (MCOLS=4)
 
      INTEGER COLORS(0:MCOLS-1)
 
*---Initialize "Other spectrum" colors
      COLORS(0) = 176
      COLORS(1) = 128
      COLORS(2) = 96
      COLORS(3) = 64
 
*---Assume proper window, units.
	call igrcolourn(COLORS(MOD(IOTHER,MCOLS)))
c      CALL GCOLN(COLORS(MOD(IOTHER,MCOLS)))
      CALL GPLOTM('Eor')
 
*---plot old subspectrum
      IF ( YFLIP ) THEN
        CALL GMOVEA(OTHX(OBOUND(1),IOTHER),-SBSPC(OBOUND(1),IOTHER))
        DO 50 I = OBOUND(1) + 1,OBOUND(2)
          CALL GLINEA(OTHX(I,IOTHER),-OTHSPC(I,IOTHER))
          CALL GPOINR(0.0,0.0)
 50     CONTINUE
      ELSE
        CALL GMOVEA(OTHX(OBOUND(1),IOTHER),SBSPC(OBOUND(1),IOTHER))
        DO 100 I = OBOUND(1) + 1,OBOUND(2)
          CALL GLINEA(OTHX(I,IOTHER),OTHSPC(I,IOTHER))
          CALL GPOINR(0.0,0.0)
 100    CONTINUE
      ENDIF
 
      CALL GPLOTM('Normal')
 
      RETURN
      END
