*file: plotcom.inc
*---mru 930426 tk
*---PION 110621 : redefine thr res and sub colors :
*--- because a palette redefinition (RED=143, Blue=79) occurs in compiler.
*---Storage for current plot window 
*---This includes size and position of current plot window and
*---current definition of character font, size and direction

*---Plot colors
      integer thrcol, rescol, subcol, nrmcol, mskcol, bakcol
      parameter (nrmcol=224, mskcol=192, bakcol=0)
*next line for color monitors
      parameter (thrcol=79, rescol=143, subcol=231)
*      parameter (thrcol=159, rescol=31, subcol=191)
*next line for monochrome monitors
*      parameter (thrcol=224,rescol=224,subcol=224)

*---toggles for turning on fast-erase of theory, residual and sub plots.
*---!!! m1subs must be greater than or equal to msubs in PARCOM.INC !!!
      integer m1subs, othoff
      parameter (m1subs = 20, othoff=2)
      logical tb4,rb4,sb4(m1subs),ob4(m1subs)

*---Window and plot info
*---user's request for window corners [norm. screen units]
      real boxllx, boxlly, boxurx, boxury
*---current window corners [norm. screen units]
      real pw1,qw1,pw2,qw2
*---Corners of plot box including tic marks and labels [norm. window units]. 
      real up1,vp1,up2,vp2
*---Axes corners [norm. window units]
      real ua1,va1,ua2,va2
*---Axes corners [data units]
      real xa1,ya1,xa2,ya2
*---Axes corners [screen units]
      real pa1,qa1,pa2,qa2
*---conversion factors between data units and norm. window units
      real xperu,yperv
*---length between tic mark in data units
      real xstep,ystep
*---Full screen toggle
      logical tfull
*---sizes of Plot title, X-title, Y-title and legend boxes
      real vptlsz,vxtlsz,uytlsz,uldgsz
*---Width of border between data and box (in percentage of data range)
      real xbordr, ybordr
*---Zoom box clip borders
      real clptop, clpbot, clplt, clprt   
*---manual scale box clip borders
      real mantop, manbot, manlt, manrt   

*---font file name, font list, justification, sizes, direction
      integer maxfnt,ifnt
      parameter (maxfnt=4)
      character*72 fntlst(maxfnt)
      character*1 chjust
      real xchsz,ychsz,chngl 
      
      common /pbox/ pw1,qw1,pw2,qw2, up1,vp1,up2,vp2, 
     &   boxllx, boxlly, boxurx, boxury,
     &   vptlsz,vxtlsz,uytlsz,uldgsz,
     &   ua1,va1,ua2,va2,xa1,ya1,xa2,ya2,pa1,qa1,pa2,qa2,
     &   xperu, yperv, xstep, ystep, xbordr, ybordr,
     &   clptop, clpbot, clplt, clprt, 
     &   mantop, manbot, manlt, manrt,
     &   tb4, rb4, sb4, ob4, tfull, xchsz, ychsz, chngl, ifnt,
     &   fntlst, chjust
