      SUBROUTINE PROCM(A,IA,JA,B,IB,JB,C,ND)
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig:  tk 1988
*---mru :  tk 930531
*---Purpose:
*      PROCM CALCULATES THE PRODUCT OF SQUARE COMPLEX
*      MATRICES .   C = A*B
*      SET IA=0 TO SUM OVER FIRST INDEX OF A,ETC.
*
*      SET OTHER INDEX TO LIMIT OF SUM (NEG. FOR CONJUGATE).
*      ADJOINT(A(I,J))=CONJG(A(J,I))
*-----------------------------------------------------------------------
*---externals
      COMPLEX A(ND,ND),B(ND,ND),C(ND,ND)
      INTEGER IA,JA,IB,JB,ND
*---parameters and common blocks
      INCLUDE 'iocom.inc'
*---internals
      COMPLEX AA,BB
      INTEGER M,I,J,K
*-----------------------------------------------------------------------
*---executables
      M = IABS(IA+JA)
      IF ( M.GT.ND ) WRITE (JOUT,*) 'm.gt.nd in subroutine procm'
      IF ( (IA.EQ.0 .AND. JA.EQ.0) .OR. (IA.NE.0 .AND. JA.NE.0) )
     &     CALL ERRMSG(' improper ia or ja in procm')
      IF ( (IB.EQ.0 .AND. JB.EQ.0) .OR. (IB.NE.0 .AND. JB.NE.0) )
     &     CALL ERRMSG('improper ib or jb in procm')
      DO 100 I = 1,M
        DO 50 J = 1,M
          C(I,J) = (0.,0.)
          DO 20 K = 1,M
            AA = A(I,K)
            IF ( IA.EQ.0 ) AA = A(K,I)
            IF ( IA.LT.0 .OR. JA.LT.0 ) AA = CONJG(AA)
            BB = B(J,K)
            IF ( IB.EQ.0 ) BB = B(K,J)
            IF ( IB.LT.0 .OR. JB.LT.0 ) BB = CONJG(BB)
            C(I,J) = C(I,J) + AA*BB
 20       CONTINUE
 50     CONTINUE
 100  CONTINUE
      RETURN
      END
