      REAL FUNCTION PYTHAG(A,B)
      REAL A,B
C
C     FINDS SQRT(A**2+B**2) WITHOUT OVERFLOW OR DESTRUCTIVE UNDERFLOW
C
      REAL P,R,S,T,U
      P = AMAX1(ABS(A),ABS(B))
      IF ( P.NE.0.0E0 ) THEN
        R = (AMIN1(ABS(A),ABS(B))/P)**2
 50     T = 4.0E0 + R
        IF ( T.NE.4.0E0 ) THEN
          S = R/T
          U = 1.0E0 + 2.0E0*S
          P = U*P
          R = (S/U)**2*R
          GOTO 50
        ENDIF
      ENDIF
      PYTHAG = P
      RETURN
      END
