      SUBROUTINE REPORT(ILEVEL,ITER,CHIBST,CHIBAD)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: 1991 cs
*--- mru: 05Sep93 cs; 951017 tk
*     Purpose:  Display iteration counts and Chi square and theory spec.
*-----------------------------------------------------------------------
      REAL CHIBST,CHIBAD
      INTEGER ITER,ILEVEL
*
*     ilevel : Local or Global level;
*     iter   : Current number of iterations at that level;
*     chibst : Best reduced chi-squared at that level;
*     chibad : Worst reduced chi-squared at that level (or last
*            : chi-squared at that level)
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'varcom.inc'
      INCLUDE 'togcom.inc'
      INCLUDE 'bestcom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'scrncom.inc'
 
      INTEGER IYGLOB,IYLOC
 
      INTEGER LMARG,LMARG1,ICHR
*-----------------------------------------------------------------------
 
      IYGLOB = 6
      IYLOC = 18
 
      IF ( ILEVEL.LE.LOCLEV ) THEN
 
        CALL NORMAL
        LMARG = ISCCOL - 9
        LMARG1 = LMARG + 1
 
        CALL OUTSXY(LMARG,4,'Annealing')
        CALL OUTIXY(LMARG,5,INEAL,3)
        CALL OUTSTR('/')
        CALL OUTINT(NEAL,3)
 
c tk 951017        IF ( (ILEVEL.EQ.GLOLEV) .AND. (MAXITG.GT.0) ) THEN
        IF ( (ILEVEL.EQ.GLOLEV) ) THEN
          CALL OUTSXY(LMARG1,IYLOC+1,'LOCAL')
          CALL BRIGHT
          CALL OUTSXY(LMARG1,IYGLOB+1,'GLOBAL')
          CALL NORMAL
          CALL OUTSXY(LMARG1,IYGLOB+3,'ITER:')
          CALL OUTIXY(LMARG1+3,IYGLOB+4,ITER,5)
          CALL OUTSXY(LMARG1,IYGLOB+5,'OF:')
          CALL OUTIXY(LMARG1+3,IYGLOB+6,MAXITG,5)
 
          CALL OUTSXY(LMARG1,IYGLOB+7,'rChiSQ:')
          CALL PUTR(LMARG1,IYGLOB+8,CHIBST)
          CALL OUTSXY(LMARG1,IYGLOB+9,'LAST:')
          CALL PUTR(LMARG1,IYGLOB+10,CHIBAD)
        ELSEIF ( ILEVEL.EQ.LOCLEV ) THEN
          IF ( MAXITG.GT.0 ) CALL OUTSXY(LMARG1,IYGLOB+1,'GLOBAL')
          CALL BRIGHT
          CALL OUTSXY(LMARG1,IYLOC+1,'LOCAL')
          CALL NORMAL
          CALL OUTSXY(LMARG1,IYLOC+3,'ITER:')
          CALL OUTIXY(LMARG1+3,IYLOC+4,ITER,5)
          CALL OUTSXY(LMARG1,IYLOC+5,'OF:')
          CALL OUTIXY(LMARG1+3,IYLOC+6,MAXITL,5)
 
          CALL OUTSXY(LMARG1,IYLOC+7,'rChiSQ:')
          CALL PUTR(LMARG1,IYLOC+8,CHIBST)
          CALL OUTSXY(LMARG1,IYLOC+9,'TO:')
          CALL PUTR(LMARG1,IYLOC+10,CHIBAD)
        ENDIF
        IF ( REPLOT(ILEVEL) ) THEN
c        ;; Plot theory
          CALL SIMPLT(ILEVEL,.FALSE.)
          REPLOT(ILEVEL) = .FALSE.
        ENDIF

        CALL SCBUFF('FL')
*---check for keyboard input 
        CALL INKEYI(ICHR)
        IF ( ICHR.GT.0 ) CALL REPMNU(ILEVEL,CHIBST)
        CALL MESSAGE('Calculating...')
****************************************************************
*************DIAGNOSTICE PATCH -- 951226 TK ********************
*        ABORT = 4
*        CALL ERRMSG('ABORT --> 4  IN REPORT BY TK')
****************************************************************
      ENDIF
 
      RETURN
      END
