*---SCRNCOM.INC


*-----------------------------------------------------------------------
      common /modecom/ color1, color2
*-----------------------------------------------------------------------
      integer color1, color2
*-----------------------------------------------------------------------
*     color1: current screen text output color
*     color2: saved screen text output color
*-----------------------------------------------------------------------

*-----------------------------------------------------------------------
      common /scrcom/ top, bot, paglen, lstcol, iscrow, isccol,
     &   iscx, iscy
*-----------------------------------------------------------------------
      integer top, bot, paglen, lstcol, iscrow, isccol, iscx, iscy
*-----------------------------------------------------------------------
*     top    : top line for the list display
*     bot    : bottom line for the list display
*     paglen : maximum number of spectra visible at once on the
*              list. (Should be bot-top+1)
*     lstcol : leftmost column of the list display
*     iscrow : number of screen text rows
*     isccol : number of screen text columns
*     iscx   : number of horizontal pixels
*     iscy   : number of vertical pixels
*-----------------------------------------------------------------------

         
*-----------------------------------------------------------------------
* Possible output modes:
*     EMPH   : Emphasized
*     IVRT   : Inverted
*     NORM   : Normal
*     EMPH2  : Different emphasized or underlined
*     BRITE  : Bright
*     INEM   : Inverted emphasized
*     FLSH   : Flasher box
*-----------------------------------------------------------------------
      integer EMPH, IVRT, NORM, EMPH2, BRITE, INEM, FLSH
      parameter (NORM  = 0, EMPH = 1, IVRT = 2, EMPH2 = 3)
      parameter (BRITE = 4, INEM = 5, FLSH = 6)
*-----------------------------------------------------------------------
