      SUBROUTINE SHOLST
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*---orig: CS 1991
*---mru : TK 940126
*---Purpose:  Display LIST of data sets in RAM
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'parcom.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'scrncom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER SPCPAG,PLEN,ISPEC,I
      CHARACTER*(MFLLEN) TMPFIL,NOFILE
*-----------------------------------------------------------------------
 
      NOFILE = ' '
 
      CALL BRIGHT
      SPCPAG = (ACTSPC-1)/PAGLEN
      IF ( SPCPAG.GT.0 ) THEN
        CALL OUTSXY(LSTCOL,TOP,'[MORE]')
      ELSE
        CALL OUTSXY(LSTCOL,TOP,'      ')
      ENDIF
      IF ( SPCPAG.LT.INT((SPCTOT-1)/PAGLEN) ) THEN
        CALL OUTSXY(LSTCOL,BOT,'[MORE]')
      ELSE
        CALL OUTSXY(LSTCOL,BOT,'      ')
      ENDIF
 
*---default colors and attribute for text screen output.
      CALL NORMAL
*---scan page
      DO 100 I = 1,PAGLEN
        ISPEC = I + PAGLEN*SPCPAG
        IF ( ISPEC.LE.SPCTOT ) THEN
*---define text screen attributes and color
          IF ( ISPEC.EQ.ACTSPC ) THEN
            CALL EMPHSZ
            IF ( PICKED(ISPEC) ) CALL ATTRIB('U')
          ELSEIF ( PICKED(ISPEC) ) THEN
            CALL EMPHS2
          ELSE
            CALL NORMAL
          ENDIF
 
 
          IF ( SHOPTH ) THEN
            PLEN = 0
          ELSE
            CALL FIPATH(SPCNAM(ISPEC),TMPFIL,PLEN)
          ENDIF
*---Write spectrum name at line TOP+I
          IF ( SELECT(ISPEC) ) THEN
            CALL OUTSXY(LSTCOL,TOP+I,'>'//SPCNAM(ISPEC)
     &                  (PLEN+1:MIN(PLEN+1+ISCCOL-2-LSTCOL,
     &                  LEN(SPCNAM(ISPEC)))))
          ELSEIF ( ISPEC.EQ.ACTSPC ) THEN
            CALL OUTSXY(LSTCOL,TOP+I,'@'//SPCNAM(ISPEC)
     &                  (PLEN+1:MIN(PLEN+1+ISCCOL-2-LSTCOL,
     &                  LEN(SPCNAM(ISPEC)))))
          ELSE
            CALL OUTSXY(LSTCOL,TOP+I,' '//SPCNAM(ISPEC)
     &                  (PLEN+1:MIN(LEN(SPCNAM(ISPEC)),
     &                  PLEN+1+ISCCOL-LSTCOL)))
          ENDIF
*---reset attributes and colors to defaults
          CALL NORMAL
        ELSE
          CALL OUTSXY(LSTCOL,TOP+I,NOFILE(1:MIN(MFLLEN,ISCCOL-LSTCOL+1))
     &                )
        ENDIF
 100  CONTINUE
 
      CALL EMPHSZ
      CALL OUTSXY(LSTCOL,BOT+1,'-')
      CALL NORMAL
      CALL OUTSTR('Up/')
      CALL EMPHSZ
      CALL OUTSTR('+')
      CALL NORMAL
      CALL OUTSTR('Down')
 
 
*---Display parameter file name
      IF ( .NOT.PARLOD ) FILNAM(1) = ' '
      IF ( SHOPTH ) THEN
        PLEN = 0
      ELSE
        CALL FIPATH(FILNAM(1),TMPFIL,PLEN)
      ENDIF
      CALL BRIGHT()
      CALL ATTRIB('U')
      CALL OUTSXY(LSTCOL,TOP-1,FILNAM(1)
     &            (PLEN+1:MIN(MFLLEN,PLEN+1+ISCCOL-LSTCOL)))
      CALL NORMAL()
 
      RETURN
      END
