*-----------------------------------------------------------------------
      SUBROUTINE SUBERA(ISUB)
*-----------------------------------------------------------------------
*     Plots a subspectrum stored in SBSPC using exclusive-or
*     mode, which erases the previously displayed plot.
*
*     isub   : Number of subspectrum to erase
*
*-----------------------------------------------------------------------
      INTEGER ISUB
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER I
 
*---Assume proper mode, window, units and color.
 
*---PLOT OLD SUBSPECTRUM
      IF ( YFLIP ) THEN
        CALL GMOVEA(SBX(SBOUND(1)),-SBSPC(SBOUND(1),ISUB))
        DO 50 I = SBOUND(1) + 1,SBOUND(2)
          CALL GLINEA(SBX(I),-SBSPC(I,ISUB))
          CALL GPOINR(0.0,0.0)
 50     CONTINUE
      ELSE
        CALL GMOVEA(SBX(SBOUND(1)),SBSPC(SBOUND(1),ISUB))
        DO 100 I = SBOUND(1) + 1,SBOUND(2)
          CALL GLINEA(SBX(I),SBSPC(I,ISUB))
          CALL GPOINR(0.0,0.0)
 100    CONTINUE
      ENDIF
 
      RETURN
      END
