*-----------------------------------------------------------------------
      SUBROUTINE SVDCMP(A,M,N,MP,NP,W,V)
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
      INTEGER M,N,MP,NP
      REAL A(MP,NP),W(NP),V(NP,NP)
*-----------------------------------------------------------------------
      INTEGER NMAX
      PARAMETER (NMAX=100)
 
      INTEGER I,L,K,J,ITS,NM
      REAL RV1(NMAX),G,SCALE,ANORM,S,F,H,C,X,Y,Z
*-----------------------------------------------------------------------
      G = 0.0
      SCALE = 0.0
      ANORM = 0.0
      DO 100 I = 1,N
        L = I + 1
        RV1(I) = SCALE*G
        G = 0.0
        S = 0.0
        SCALE = 0.0
        IF ( I.LE.M ) THEN
          DO 20 K = I,M
            SCALE = SCALE + ABS(A(K,I))
 20       CONTINUE
          IF ( SCALE.NE.0.0 ) THEN
            DO 30 K = I,M
              A(K,I) = A(K,I)/SCALE
              S = S + A(K,I)*A(K,I)
 30         CONTINUE
            F = A(I,I)
            G = -SIGN(SQRT(S),F)
            H = F*G - S
            A(I,I) = F - G
            IF ( I.NE.N ) THEN
              DO 35 J = L,N
                S = 0.0
                DO 32 K = I,M
                  S = S + A(K,I)*A(K,J)
 32             CONTINUE
                F = S/H
                DO 34 K = I,M
                  A(K,J) = A(K,J) + F*A(K,I)
 34             CONTINUE
 35           CONTINUE
            ENDIF
            DO 40 K = I,M
              A(K,I) = SCALE*A(K,I)
 40         CONTINUE
          ENDIF
        ENDIF
        W(I) = SCALE*G
        G = 0.0
        S = 0.0
        SCALE = 0.0
        IF ( (I.LE.M) .AND. (I.NE.N) ) THEN
          DO 60 K = L,N
            SCALE = SCALE + ABS(A(I,K))
 60       CONTINUE
          IF ( SCALE.NE.0.0 ) THEN
            DO 70 K = L,N
              A(I,K) = A(I,K)/SCALE
              S = S + A(I,K)*A(I,K)
 70         CONTINUE
            F = A(I,L)
            G = -SIGN(SQRT(S),F)
            H = F*G - S
            A(I,L) = F - G
            DO 80 K = L,N
              RV1(K) = A(I,K)/H
 80         CONTINUE
            IF ( I.NE.M ) THEN
              DO 85 J = L,M
                S = 0.0
                DO 82 K = L,N
                  S = S + A(J,K)*A(I,K)
 82             CONTINUE
                DO 84 K = L,N
                  A(J,K) = A(J,K) + S*RV1(K)
 84             CONTINUE
 85           CONTINUE
            ENDIF
            DO 90 K = L,N
              A(I,K) = SCALE*A(I,K)
 90         CONTINUE
          ENDIF
        ENDIF
        ANORM = MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
 100  CONTINUE
      DO 200 I = N,1, - 1
        IF ( I.LT.N ) THEN
          IF ( G.NE.0.0 ) THEN
            DO 110 J = L,N
              V(J,I) = (A(I,J)/A(I,L))/G
 110        CONTINUE
            DO 130 J = L,N
              S = 0.0
              DO 115 K = L,N
                S = S + A(I,K)*V(K,J)
 115          CONTINUE
              DO 120 K = L,N
                V(K,J) = V(K,J) + S*V(K,I)
 120          CONTINUE
 130        CONTINUE
          ENDIF
          DO 140 J = L,N
            V(I,J) = 0.0
            V(J,I) = 0.0
 140      CONTINUE
        ENDIF
        V(I,I) = 1.0
        G = RV1(I)
        L = I
 200  CONTINUE
      DO 300 I = N,1, - 1
        L = I + 1
        G = W(I)
        IF ( I.LT.N ) THEN
          DO 220 J = L,N
            A(I,J) = 0.0
 220      CONTINUE
        ENDIF
        IF ( G.NE.0.0 ) THEN
          G = 1.0/G
          IF ( I.NE.N ) THEN
            DO 240 J = L,N
              S = 0.0
              DO 225 K = L,M
                S = S + A(K,I)*A(K,J)
 225          CONTINUE
              F = (S/A(I,I))*G
              DO 230 K = I,M
                A(K,J) = A(K,J) + F*A(K,I)
 230          CONTINUE
 240        CONTINUE
          ENDIF
          DO 260 J = I,M
            A(J,I) = A(J,I)*G
 260      CONTINUE
        ELSE
          DO 280 J = I,M
            A(J,I) = 0.0
 280      CONTINUE
        ENDIF
        A(I,I) = A(I,I) + 1.0
 300  CONTINUE
      DO 500 K = N,1, - 1
        DO 450 ITS = 1,30
          DO 320 L = K,1, - 1
            NM = L - 1
            IF ( (ABS(RV1(L))+ANORM).EQ.ANORM ) GOTO 380
            IF ( (ABS(W(NM))+ANORM).EQ.ANORM ) GOTO 340
 320      CONTINUE
 340      C = 0.0
          S = 1.0
          DO 360 I = L,K
            F = S*RV1(I)
            IF ( (ABS(F)+ANORM).NE.ANORM ) THEN
              G = W(I)
              H = SQRT(F*F+G*G)
              W(I) = H
              H = 1.0/H
              C = (G*H)
              S = -(F*H)
              DO 345 J = 1,M
                Y = A(J,NM)
                Z = A(J,I)
                A(J,NM) = (Y*C) + (Z*S)
                A(J,I) = -(Y*S) + (Z*C)
 345          CONTINUE
            ENDIF
 360      CONTINUE
 380      Z = W(K)
          IF ( L.EQ.K ) THEN
            IF ( Z.LT.0.0 ) THEN
              W(K) = -Z
              DO 385 J = 1,N
                V(J,K) = -V(J,K)
 385          CONTINUE
            ENDIF
            GOTO 500
          ENDIF
          IF ( ITS.EQ.30 ) PAUSE 'in svdcmp, its=30 and no convergence.'
          X = W(L)
          NM = K - 1
          Y = W(NM)
          G = RV1(NM)
          H = RV1(K)
          F = ((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
          G = SQRT(F*F+1.0)
          F = ((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
          C = 1.0
          S = 1.0
          DO 420 J = L,NM
            I = J + 1
            G = RV1(I)
            Y = W(I)
            H = S*G
            G = C*G
            Z = SQRT(F*F+H*H)
            RV1(J) = Z
            C = F/Z
            S = H/Z
            F = (X*C) + (G*S)
            G = -(X*S) + (G*C)
            H = Y*S
            Y = Y*C
            DO 390 NM = 1,N
              X = V(NM,J)
              Z = V(NM,I)
              V(NM,J) = (X*C) + (Z*S)
              V(NM,I) = -(X*S) + (Z*C)
 390        CONTINUE
            Z = SQRT(F*F+H*H)
            W(J) = Z
            IF ( Z.NE.0.0 ) THEN
              Z = 1.0/Z
              C = F*Z
              S = H*Z
            ENDIF
            F = (C*G) + (S*Y)
            X = -(S*G) + (C*Y)
            DO 400 NM = 1,M
              Y = A(NM,J)
              Z = A(NM,I)
              A(NM,J) = (Y*C) + (Z*S)
              A(NM,I) = -(Y*S) + (Z*C)
 400        CONTINUE
 420      CONTINUE
          RV1(L) = 0.0
          RV1(K) = F
          W(K) = X
 450    CONTINUE
 500  CONTINUE
      RETURN
      END
