*-----------------------------------------------------------------------
      SUBROUTINE THRERA
*-----------------------------------------------------------------------
*     Plots the theory stored in THRARR in XOR mode, which erases the
*        last displayed theory plot.
*-----------------------------------------------------------------------
      INCLUDE 'limits.inc'
      INCLUDE 'speccom.inc'
      INCLUDE 'plotcom.inc'
      INCLUDE 'togcom.inc'
 
      INTEGER I
 
*---Assume XOR PLOTTING MODE, valid window and units, proper color.
 
*---PLOT OLD THEORY
      IF ( YFLIP ) THEN
        CALL GMOVEA(THRX(TBOUND(1)),-THRSPC(TBOUND(1)))
        DO 50 I = TBOUND(1) + 1,TBOUND(2)
          CALL GLINEA(THRX(I),-THRSPC(I))
          CALL GPOINR(0.0,0.0)
 50     CONTINUE
      ELSE
        CALL GMOVEA(THRX(TBOUND(1)),THRSPC(TBOUND(1)))
        DO 100 I = TBOUND(1) + 1,TBOUND(2)
          CALL GLINEA(THRX(I),THRSPC(I))
          CALL GPOINR(0.0,0.0)
 100    CONTINUE
      ENDIF
 
      RETURN
      END
