      SUBROUTINE TOPMNU
*-----------------------------------------------------------------------
*---WEB Research Co.
*---orig: 1991 cs
*---mru : 960212 tk; 980210 tk
*     WMOSS Version
*
*     Presents top menu and submenus, get user input, dispatch action.
*----------------------------------------------------------------------
*---paramters and common blocks
      INCLUDE 'limits.inc'
      INCLUDE 'keycom.inc'
      include 'constcom.inc'
      include 'speccom.inc'
*---internals
      INTEGER MAIOPT,FILOPT
      INTEGER ANLOPT,PLTOPT,LSTOPT
      PARAMETER (MAIOPT=5,FILOPT=9)
      PARAMETER (ANLOPT=9,PLTOPT=3)
      PARAMETER (LSTOPT=7)
 
      CHARACTER*9 MAIMNU(MAIOPT)
      CHARACTER*22 FILMNU(FILOPT)
      CHARACTER*10 ANLMNU(ANLOPT)
      CHARACTER*16 PLTMNU(PLTOPT)
      CHARACTER*14 LSTMNU(LSTOPT)
 
      character*9 mnunam
      integer ichoice

*---external functions
      INTEGER MENU,SUBMNU
      LOGICAL GETYN
      EXTERNAL MENU,SUBMNU,GETYN
 
*---Main menu default option
      INTEGER DEFALT
*---Sub-menu default
      INTEGER DFALT2
 
      save maimnu, filmnu, anlmnu, pltmnu, lstmnu
      DATA MAIMNU/'Files','Analysis','Utilities','Hardcopy','Options'/
      DATA FILMNU/'~Data Load        [F2]','Da~ta Save        [F3]',
     &   '~Edit Data Header','Pa~rm Load        [F4]',
     &   'Parm ~Save        [F5]',
     &   '~Change Dir       [F6]','~List Save','~Print',
     &   'E~xit'/
      DATA ANLMNU/'Flash','LSub','SSub','Pick Data',
     &     'Edit Param','Do Fit','MC plot','QSD Plot','HFD Plot'/
      DATA PLTMNU/'Graphics Printer','Print Parms','Custom PS Plot'/
      DATA LSTMNU/'Add Mask','Clear Mask','Delete  [DEL]',
     &            'Zoom     [F8]', 'C~ondense by 2',
     &            'Stretch', 'Exp. Add'/
*-------------------------------------------------------------------------
*---executables
      mnunam = 'WMOSS_XP'

*---Menu/Dispatch loop
      DEFALT = 1
  100 ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,DEFALT,.FALSE.)
      IF ( ICHOICE.NE.0 ) THEN
         IF ( ICHOICE.EQ.1 ) THEN
            DEFALT = ICHOICE
            DFALT2 = 1
            GOTO 200
         ELSEIF ( ICHOICE.EQ.2 ) THEN
            DEFALT = ICHOICE
            DFALT2 = 1
            GOTO 300
         ELSEIF ( ICHOICE.EQ.3 ) THEN
            DEFALT = ICHOICE
            DFALT2 = 1
            GOTO 400
         ELSEIF ( ICHOICE.EQ.4 ) THEN
            DEFALT = ichoice
            DFALT2 = 1
            GOTO 500
         ELSEIF ( ICHOICE.EQ.5 ) THEN
            defalt = ichoice
            DFALT2 = 1
            ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,5,.TRUE.)
            CALL OPTIONS
            call shoact(.false.)
         ELSE
            CALL HOTKEY(-ICHOICE)
         ENDIF
      ENDIF
      GOTO 100

 200  ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,1,.TRUE.)
      ICHOICE = submnu(10,2,FILMNU,FILOPT,DFALT2,' ')
      IF ( ICHOICE.GT.0 ) DFALT2 = ICHOICE
      IF ( ICHOICE.EQ.1 ) THEN
*---load data files
*---display file output format options menu
         if(zcrip)then
             call errmsg('Demonstration program does not present '
     &         //'File Load Format menu.')
           else
             call filiop
           endif
*---load data from disk
        CALL FILES(1)
      ELSEIF ( ICHOICE.EQ.2 ) THEN
*---save data file
         if(zcrip)then
            call errmsg(
     +         'Free Demonstration software can not write to disk.')
         else
*---display file output format options menu
            call filoop 
*---write to disk
            CALL FILES(3)
         endif
      ELSEIF ( ICHOICE.EQ.3 ) THEN
        CALL FILES(2)
      ELSEIF ( ICHOICE.EQ.4 ) THEN
        CALL FILES(5)
      ELSEIF ( ICHOICE.EQ.5 ) THEN
         if(zcrip)then
            call errmsg(
     +         'Free Demonstration software can not write to disk.')
         else
            CALL FILES(7)
         endif
      ELSEIF ( ICHOICE.EQ.6 ) THEN
         CALL FILES(9)
      elseif (ichoice.eq.7) then
         if(zcrip)then
            call errmsg(
     +         'Free Demonstration software can not write to disk.')
         else
            call savelist
         endif
      ELSEIF ( ICHOICE.EQ.8 ) THEN
        CALL FILES(10)
      ELSEIF ( ICHOICE.EQ.9 ) THEN
            IF ( GETYN('WMOSS will close: Are you sure?') ) RETURN
      ELSEIF ( ICHOICE.EQ.-RTARR ) THEN
        DEFALT = 2
        DFALT2 = 1
        GOTO 300
      ELSEIF ( ICHOICE.EQ.-LTARR ) THEN
        DEFALT = 6
        GOTO 100
      ELSEIF ( ICHOICE.LT.0 ) THEN
        CALL HOTKEY(-ICHOICE)
      ENDIF
      IF ( ICHOICE.EQ.0 ) GOTO 100
      GOTO 200
 300  ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,2,.TRUE.)
      ICHOICE = submnu(21,2,ANLMNU,ANLOPT,DFALT2,' ')
      IF ( ICHOICE.GT.0 ) DFALT2 = ICHOICE
      IF ( ICHOICE.EQ.1 ) THEN
        CALL ANALYZE(1)
      ELSEIF ( ICHOICE.EQ.2 ) THEN
        CALL ANALYZE(2)
      ELSEIF ( ICHOICE.EQ.3 ) THEN
        CALL ANALYZE(3)
      ELSEIF ( ICHOICE.EQ.4 ) THEN
        CALL LIST(4)
      ELSEIF ( ICHOICE.EQ.5 ) THEN
        CALL FILES(6)
      ELSEIF ( ICHOICE.EQ.6 ) THEN
        CALL ANALYZE(4)
      ELSEIF ( ICHOICE.EQ.7 ) THEN
         CALL SCAPLT()
      ELSEIF ( ICHOICE.EQ.8 ) THEN
         CALL QSDPLT()
      ELSEIF ( ICHOICE.EQ.9 ) THEN
         CALL HFDPLT()
      ELSEIF ( ICHOICE.EQ.-RTARR ) THEN
        DEFALT = 3
        DFALT2 = 1
        GOTO 400
      ELSEIF ( ICHOICE.EQ.-LTARR ) THEN
        DEFALT = 1
        DFALT2 = 1
        GOTO 200
      ELSEIF ( ICHOICE.LT.0 ) THEN
        CALL HOTKEY(-ICHOICE)
      ENDIF
      IF ( ICHOICE.EQ.0 ) GOTO 100
      GOTO 300
 400  ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,3,.TRUE.)
      ICHOICE = submnu(32,2,LSTMNU,LSTOPT,DFALT2,' ')
      IF ( ICHOICE.GT.0 ) DFALT2 = ICHOICE
      IF ( ICHOICE.EQ.1 ) THEN
         CALL LIST(3)
      elseif (ichoice.eq.2.and.actspc.gt.0) then
         call clrmsk(actspc)
         if (picked(actspc)) call maktab(0)
         call shoact(.false.)
      ELSEIF ( ICHOICE.EQ.3.and.actspc.gt.0) THEN
         CALL LIST(2)
      elseif (ichoice.eq.4.and.actspc.gt.0) then
         call list(1)
      elseif (ichoice.eq.5.and.actspc.gt.0) then
         call cndns
      elseif (ichoice.eq.6.and.actspc.gt.0) then
          CALL STRTCH
      elseif (ichoice.eq.7.and.actspc.gt.0) then
          CALL ADDEXP
      ELSEIF ( ICHOICE.EQ.-RTARR ) THEN
        DEFALT = 4
        DFALT2 = 1
        GOTO 500
      ELSEIF ( ICHOICE.EQ.-LTARR ) THEN
        DEFALT = 2
        DFALT2 = 1
        GOTO 300
      ELSEIF ( ICHOICE.LT.0 ) THEN
        CALL HOTKEY(-ICHOICE)
      ENDIF
      IF ( ICHOICE.EQ.0 ) GOTO 100
      GOTO 400
 500  ICHOICE = MENU(mnunam,MAIMNU,MAIOPT,4,.TRUE.)
      ICHOICE = submnu(43,2,PLTMNU,PLTOPT,DFALT2,' ')
      IF ( ICHOICE.GT.0 ) DFALT2 = ICHOICE
      IF ( ICHOICE.EQ.1 ) THEN
        CALL DEVMNU
      ELSEIF ( ICHOICE.EQ.2 ) THEN
         if(zcrip)then
            call errmsg(
     +         'Free Demonstration software can not write to disk.')
         else
           call lstpar
         endif
      ELSEIF ( ICHOICE.EQ.3 ) THEN
         if(zcrip)then
            call errmsg(
     +         'Free Demonstration software can not write to disk.')
         else
            CALL PLOT(2)
         endif
      ELSEIF ( ICHOICE.EQ.-RTARR ) THEN
        DEFALT = 5
        GOTO 100
      ELSEIF ( ICHOICE.EQ.-LTARR ) THEN
        DEFALT = 3
        DFALT2 = 1
        GOTO 400
      ELSEIF ( ICHOICE.LT.0 ) THEN
        CALL HOTKEY(-ICHOICE)
      ENDIF
      IF ( ICHOICE.EQ.0 ) GOTO 100
      GOTO 500
      END
