*-----------------------------------------------------------------------
      subroutine ulolc2(isub)
*-----------------------------------------------------------------------
      integer isub
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     mru 28Jul93 cs
*
*     Calculate subspectrum consisting of a single lorentzian or voigt
*     line, using the parameters in the PLBEST array.
*
*     isub   : Subsite to calculate.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'constcom.inc'
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest

      real czero, step, cshift, cfwhm, cwcal
      integer npts, ispec

      external vel2ch
      real vel2ch
*-----------------------------------------------------------------------

      do 100 ispec = 1,nspec
         czero = cal(6,ispec)
         step = cal(7,ispec)

         cshift = vel2ch(plbest(1,isub), czero, step)
         cfwhm = plbest(2,isub) / step
         cwcal = fwhml0 / step
         npts = ical(1,ispec)
         call lnorm(npts, locspc(1,ispec,isub), cshift, cfwhm, cwcal,
     &      0.0, 1.0)
  100 continue
 
      return
      end
