*-----------------------------------------------------------------------
      subroutine uloloc()
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     orig:
*     mru : 28Jul93 cs; 971211 tk
*
*     Calculates the subspectra to be combined via global areas
*     and area fractions.
*-----------------------------------------------------------------------
      include 'limits.inc'
      include 'parcom.inc'
      include 'togcom.inc'

c     ;; Current value of parameters
      real plbest(MLPAR,MLOC)
      common /rlbest/ plbest

      integer isub, i
*-----------------------------------------------------------------------

      do 100 isub = 1, nsubs
c        ;; Check for the same parameters for this site
         do 105 i = 1, ilp(2,isub)
            if (plbest(i,isub).ne.plcopy(i,isub)) goto 110
  105    continue
c        ;; Yes: Skip this subsite
         goto 100

c        ;; No: save the new parameters
  110    do 115 i = 1, ilp(2,isub)
            plcopy(i,isub) = plbest(i,isub)
  115    continue
         
         if (model.eq.1) then
            call ulolc1(isub)
         elseif (model.eq.2) then
            call ulolc2(isub)
         elseif (model.eq.3) then
            call ulolc3(isub)
         elseif (model.eq.4) then
            call ulolc4(isub)
         elseif (model.eq.5) then
            call ulolc5(isub)
         elseif (model.eq.6) then
            call ulolc6(isub)
         elseif (model.eq.7) then
            call ulolc7(isub)
         elseif (model.eq.8) then
            call ulolc8(isub)
         else
            call errmsg('Invalid model specified in ULOLOC.')
            abort = AbortFatal
         endif
  100 continue

      return
      end
