*-----------------------------------------------------------------------
      SUBROUTINE VBOUND(ROWS,COLS,PLB,PUB,KON,IND,MVAR,VLB,VUB)
*-----------------------------------------------------------------------
      INTEGER ROWS,COLS,MVAR
      INTEGER KON(ROWS,COLS),IND(ROWS,COLS)
      REAL PLB(ROWS,COLS),PUB(ROWS,COLS)
      REAL VUB(MVAR),VLB(MVAR)
*-----------------------------------------------------------------------
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*    16Jul93 cs
*     Copy bounds of free parameters to bounds of variables.
*
*     rows   : [Input]  Leading dimension of kon/ind/plb/pub.  Maximum
*            :          number of parameters per "column";
*     col    : [Input]  Number of parameter columns in kon/ind/plb/pub
*            :          arrays;
*     plb    : [Input]  Lower bounds of parameters;
*     pub    : [Input]  Upper bounds of parameters;
*     kon    : [Input]  Constraints for parameters;
*     ind    : [Input]  Pointers from variables to parameters;
*     mvar   : [Input]  Maximum number of variables;
*     vlb    : [Output] Variable lower bounds;
*     vub    : [Output] Variable upper bounds.
*-----------------------------------------------------------------------
      INTEGER I,J,ISUB
*-----------------------------------------------------------------------
      INTEGER IJ2KON
      IJ2KON(I,J) = I + 100*J
*-----------------------------------------------------------------------
 
c     /* Initialize upper and lower bounds of free variables */
      DO 100 ISUB = 1,COLS
        DO 50 I = 1,ROWS
          IF ( KON(I,ISUB).EQ.IJ2KON(I,ISUB) ) THEN
            VLB(IND(I,ISUB)) = PLB(I,ISUB)
            VUB(IND(I,ISUB)) = PUB(I,ISUB)
          ENDIF
 50     CONTINUE
 100  CONTINUE
 
      RETURN
      END
