
      SUBROUTINE VMMM(N,V,ISTART,ISTOP,VMAX,IMAX,VMIN,IMIN,VMEAN)
*---PURPOSE: FIND MAX, MIN AND MEAN OF ELEMENTS WITHIN SUBSET
*---         OF VECTOR V.  SUBSET(V) = [V(ISTART),V(ISTOP)]
*---         ALSO REPORT INDICES OF MAX AND MIN.
*---TAK  6/27/90     MRU   901105 TK
 
      INTEGER N,IMAX,IMIN,ISTART,ISTOP
      REAL V(N),VMAX,VMIN,VMEAN
      INTEGER I
      REAL VI
 
C CHECK LIMITS
      IF ( N.LT.1 .OR. ISTART.LT.1 .OR. ISTOP.LT.ISTART .OR. 
     &     ISTOP.GT.N ) THEN
        call errmsg('ABORTING')
        call errmsg('improper input to subroutine vmmm.')
        call endgr
        STOP
      ENDIF
 
C SCAN SUBRANGE
      VMAX = V(ISTART)
      VMIN = VMAX
      VMEAN = VMAX
      IMAX = ISTART
      IMIN = ISTART
      IF ( ISTOP.GT.ISTART ) THEN
        DO 50 I = ISTART + 1,ISTOP
          VI = V(I)
          IF ( VI.LT.VMIN ) THEN
            VMIN = VI
            IMIN = I
          ELSEIF ( VI.GT.VMAX ) THEN
            VMAX = VI
            IMAX = I
          ENDIF
          VMEAN = VMEAN + VI
 50     CONTINUE
        VMEAN = VMEAN/(ISTART-ISTOP+1.0)
      ENDIF
 
      RETURN
      END
