      SUBROUTINE VSN(DRIVE,SN,IERR)
*-----------------------------------------------------------------------
*     Returns the volume serial number of specified drive.
*     This subroutine calls the INTERACTER routine OSCMNS
*--- Contact- OLD: WEB Research Co. /// NEW: WMOSS.ORG
*     10aug92
*-----------------------------------------------------------------------
      CHARACTER DRIVE*2
      INTEGER IERR
      CHARACTER*9 SN
*-----------------------------------------------------------------------
      CHARACTER*80 COMAND,C80
 
      INTEGER INFOER
      EXTERNAL INFOER
*-----------------------------------------------------------------------
 
*---initialize
      SN = ' '
      IERR = 0
 
*---write volumne information to disk file
      COMAND = 'vol '//DRIVE//' >vsn.inf'
 
      CALL OSCMNS(COMAND)
      IF ( INFOER(1).EQ.13 ) THEN
        IERR = INFOER(3)
        write(*,*)'VSN VOL error: ',ierr
*---if "vol" command did not work, then try "dir" command.
        comand=' dir '//drive//' >vsn.inf'
        CALL OSCMNS(COMAND)
        IF ( INFOER(1).EQ.13 ) THEN
          IERR = INFOER(3)
          write(*,*)'VSN DIR error: ',ierr
          GOTO 100
        endif
      ENDIF
 
*---read info and get serial number
      OPEN (10,FILE='vsn.inf',IOSTAT=IERR)
      IF ( IERR.EQ.0 ) THEN
        READ (10,*,IOSTAT=IERR)
        IF ( IERR.EQ.0 ) THEN
          READ (10,*,IOSTAT=IERR)
          IF ( IERR.EQ.0 ) THEN
            READ (10,'(a80)',IOSTAT=IERR) C80
            IF ( IERR.EQ.0 ) THEN
              CLOSE (10,IOSTAT=IERR)
              IF ( IERR.EQ.0 ) THEN
*---delete temporary file
                COMAND = 'del vsn.inf'
                CALL OSCMNS(COMAND)
                IF ( INFOER(1).EQ.13 ) THEN
                  IERR = INFOER(3)
                  GOTO 100
                ENDIF
 
*---parse s/n
                SN = C80(26:34)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
      ENDIF
 
 100  RETURN
      END
