 
*FROM: NETLIBD@ANTARES.MCS.ANL.GOV (NETLIB)
*STATUS: R
*CAVEAT RECEPTOR.  (JACK) DONGARRA@ANL-MCS.ARPA, (ERIC GROSSE) RESEARCH!EHG
*CAREFUL! ANYTHING FREE COMES WITH NO GUARANTEE.
*** FROM NETLIB, THU JAN 19 10:07:24 CST 1989 ***
 
      SUBROUTINE X4CH(AR,AI,W,MATZ,ZR,ZI,FV1,FV2,FM1,IERR)
*---CONVERTED TO SINGLE PRECISION BY TK, 900315.  MRU 900821 TK
 
      INTEGER IERR,MATZ
      REAL AR(4,4),AI(4,4),W(4),ZR(4,4),ZI(4,4),FV1(4),FV2(4),FM1(2,4)
C
C     THIS SUBROUTINE CALLS THE RECOMMENDED SEQUENCE OF
C     SUBROUTINES FROM THE EIGENSYSTEM SUBROUTINE PACKAGE (EISPACK)
C     TO FIND THE EIGENVALUES AND EIGENVECTORS (IF DESIRED)
C     OF A COMPLEX HERMITIAN MATRIX.
C
C     ON INPUT
C
C        NM  MUST BE SET TO THE ROW DIMENSION OF THE TWO-DIMENSIONAL
C        ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C        DIMENSION STATEMENT.
C
C        N  IS THE ORDER OF THE MATRIX  A=(AR,AI).
C
C        AR  AND  AI  CONTAIN THE REAL AND IMAGINARY PARTS,
C        RESPECTIVELY, OF THE COMPLEX HERMITIAN MATRIX.
C
C        MATZ  IS AN INTEGER VARIABLE SET EQUAL TO ZERO IF
C        ONLY EIGENVALUES ARE DESIRED.  OTHERWISE IT IS SET TO
C        ANY NON-ZERO INTEGER FOR BOTH EIGENVALUES AND EIGENVECTORS.
C
C     ON OUTPUT
C
C        W  CONTAINS THE EIGENVALUES IN ASCENDING ORDER.
C
C        ZR  AND  ZI  CONTAIN THE REAL AND IMAGINARY PARTS,
C        RESPECTIVELY, OF THE EIGENVECTORS IF MATZ IS NOT ZERO.
C
C        IERR  IS AN INTEGER OUTPUT VARIABLE SET EQUAL TO AN ERROR
C           COMPLETION CODE DESCRIBED IN THE DOCUMENTATION FOR TQLRAT
C           AND TQL2.  THE NORMAL COMPLETION CODE IS ZERO.
C
C        FV1, FV2, AND  FM1  ARE TEMPORARY STORAGE ARRAYS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO BURTON S. GARBOW,
C     MATHEMATICS AND COMPUTER SCIENCE DIV, ARGONNE NATIONAL LABORATORY
C
C     THIS VERSION DATED AUGUST 1983.
C
C     ------------------------------------------------------------------
C
*_CS 24Jun91 calls the 4x4-specific routines

      CALL X4HTRIDI(AR,AI,W,FV1,FV2,FM1)

      ZR(1,1) = 1.0
      ZR(2,1) = 0.0
      ZR(3,1) = 0.0
      ZR(4,1) = 0.0
 
      ZR(1,2) = 0.0
      ZR(2,2) = 1.0
      ZR(3,2) = 0.0
      ZR(4,2) = 0.0
 
      ZR(1,3) = 0.0
      ZR(2,3) = 0.0
      ZR(3,3) = 1.0
      ZR(4,3) = 0.0
 
      ZR(1,4) = 0.0
      ZR(2,4) = 0.0
      ZR(3,4) = 0.0
      ZR(4,4) = 1.0
 
      CALL X4TQL2(W,FV1,ZR,IERR)
 
      IF ( IERR.EQ.0 ) CALL X4HTRIBK(AR,AI,FM1,ZR,ZI)

      RETURN
      END
